<?php
 
$appPath = "$baseDir/$webDir/".APPDIR;
$mode = 'release';

if(!empty($_SESSION['userName'])) {
	$userName 				= getUserName();
	$bandwidthFilePath 		= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".BW_FILE;
	$relativeFile 			= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".RELATIVE_FILE;
	$mpc 					= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".MPC_FILE;
	$drlFile 				= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".RESTORE_LOCATION_FILE;
	$OutErrorFilePath 		= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".ERROR_FILE;
	$OutOutputFilePath 		= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".OUTPUTFILE;
	$searchDirLocal  		= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/Backup/.+searchList";
	$searchDirRemote 		= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/Restore/.+searchList";
	$temp_file 				= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".TEMP_OPERATION_FILE;
	$excludeFullFile		= "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/" . EXCLUDE_FULL_PATH_FILE;
	$excludePartialFilePath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".EXCLUDE_LIST_PARTIAL_FILE;
} else {
	$userName 				= "";
	$bandwidthFilePath 		= "";
	$relativeFile 			= "";
	$mpc 					= "";
	$drlFile 				= "";
	$OutErrorFilePath 		= "";
	$OutOutputFilePath 		= "";
	$searchDirLocal  		= "";
	$searchDirRemote 		= "";
	$temp_file 				= "";
	$excludePartialFilePath = "";
}

/************************************************************************************************
* Function Name	: __autoload
* Objective	: To include classes in PHP
* Added By	: Sreenath P.
************************************************************************************************/
function __autoload($class_name) {
    include "c.".$class_name . ".php";
}

if(!isset($_SESSION['serverIPAddress'])){
	$_SESSION['serverIPAddress'] = getLocalServerip();
}

$serverIPAddress = $_SESSION['serverIPAddress'];

// Setting the Scheduler path, added by Sreenath P. on 01-04-2014
Scheduler::SetSchedulerPath($baseDir, $webDir, $userName, $user, $machine);
if(!empty($_SESSION['userName'])) { 	 	
	readAccountSettingsFile();
	if(!empty($_SESSION['PROXY'])){
	  $proxyString = trim($_SESSION['PROXY']);
	  $proxy_Array = preg_split( "/[:@]/", $proxyString);
		$_SESSION['proxy_option'] = 'Manual';
		$_SESSION['proxyUserName'] = $proxy_Array[0];
		$_SESSION['proxyPassword'] = $proxy_Array[1];
		$_SESSION['ipAddress'] = $proxy_Array[2];
		$_SESSION['port'] = $proxy_Array[3];	
	}
}

checkIfHtaccessExists();
$whiteSpace = " ";
$assignmentOperator = "=";
$pathSeparator = "/";
$lineFeed = "\n";
$idevsutilBinaryPath = "$appPath/idevsutil_IDrive";
$idevsutilArgument = "--utf8-cmd";
$searchHandle = 0;
$countItem = 0;
$isOpened = 0;
$pidPath = PID_FILE;
$pagePath = "";
$startPid = START_PID;
$userCancelFile = CANCEL_PATH;

$hashEvsParameters = array( 
			"SERVERADDRESS" => "--getServerAddress",
			"USERNAME" => "--user",
			"PASSWORD" => "--password-file",                       
			"ENCTYPE" => "--enc-type",
			"PVTKEY" => "--pvt-key",                       
			"VALIDATE" => "--validate",
			"CONFIG" => "--config-account",
			"PROXY" => "--proxy",
			"UTF8CMD" => "--utf8-cmd",
			"ENCODE" => "--encode",
			"FROMFILE" => "--files-from",
			"TYPE" => "--type",
			"BWFILE" => "--bw-file",
			"PROPERTIES" => "--properties",
			"XMLOUTPUT" => "--xml-output",
			"GETQUOTA" => "--get-quota",
			"AUTHLIST" => "--auth-list",
			"SPEED" => "--trf-",
			"OUTPUT" => "--o",
			"ERROR" => "--e",
			"PROGRESS" => "--100percent-progress",
			"QUOTAFROMFILE" => "--quota-fromfile",
			"CREATEDIR" => "--create-dir",
			"SEARCH" => "--search",
			"VERSIONINFO" => "--version-info",
			"RENAME" => "--rename",
			"OLDPATH" => "--old-path",
			"DELETE" => "--delete-items",
			"PUT_BACK" => "--moveto-original",
			"DELETE_TRASH" => "--deletefrom-trash",
			"NEWPATH" => "--new-path",
			"ITEMSTATUS" => "--items-status"
);

#********************************************************************************************************************
# Subroutine Name         : getOperationFile.
# Objective               : Create utf8 file for EVS command respective to operation type(backup/restore/validate...).
# Added By                : Avinash Kumar
#********************************************************************************************************************/
function getOperationFile($optType, $input='', $searchPath='')
{
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;
	GLOBAL $hashEvsParameters;
	GLOBAL $lineFeed;
	GLOBAL $pathSeparator;
	GLOBAL $assignmentOperator;
	GLOBAL $OutErrorFilePath;
	GLOBAL $OutOutputFilePath;
	GLOBAL $selected_backupset;
	GLOBAL $archive;
	GLOBAL $permissionVal;
	
	$encPwdPath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/IDPWD";
	$encPvtkeyPath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/IDPVT";
	$utfPath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".UTF8_FILE;
	
	$serverAddressOperator = "@";
	$serverName = "home";
	$serverNameOperator = "::";
	$privateEncryptionKey = "private";
	$encryptionType = "";
	$proxyString = "";
	
	if(isset($_SESSION['ipAddress']) && $_SESSION['ipAddress'] != ""){
			$proxyString = $_SESSION['proxyUserName'].":".$_SESSION['proxyPassword']."@".$_SESSION['ipAddress'].":".$_SESSION['port'];
	}
	
	switch ($optType) {
		case VERSIONINFOOP: 
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$hashEvsParameters["VERSIONINFO"].$lineFeed.
						$hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator.$input;
			
			break;
		case PROPERTIESOP:
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$hashEvsParameters["PROPERTIES"].$lineFeed.
						$hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$input;									
			break;
		case CREATEDIROP:
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$hashEvsParameters["CREATEDIR"].$assignmentOperator.$input[0].$lineFeed;
			if($input[2] == "Private"){
				$utfParam .= $hashEvsParameters["PVTKEY"].$assignmentOperator.$encPvtkeyPath.$lineFeed;
			}						
			$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator.$input[1];
			break;
		case RENAMEOP:
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$hashEvsParameters["RENAME"].$lineFeed.
						$hashEvsParameters["OLDPATH"].$assignmentOperator.$input[0].$lineFeed.
						$hashEvsParameters["NEWPATH"].$assignmentOperator.$input[1].$lineFeed;
			if($_SESSION["encType"] == "Private"){
				$utfParam .= $hashEvsParameters["PVTKEY"].$assignmentOperator.$encPvtkeyPath.$lineFeed;
			}
			$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator;		
			break;
		case SPEEDOP:
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$input.$lineFeed;
			if($_SESSION["encType"] == "Private"){
				$utfParam .= $hashEvsParameters["PVTKEY"].$assignmentOperator.$encPvtkeyPath.$lineFeed;
			}
			$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator;
			break;
		case ARCHIVEOP:			//Modified by sajana for ArchiveClean up...
		case PERIODICARCHIVEOP:
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed;
			$OutErrorFilePath = Scheduler::$archiveclean_dir.$selected_backupset."/".ERROR_FILE;
			$OutOutputFilePath = Scheduler::$archiveclean_dir.$selected_backupset."/".OUTPUTFILE;
			$utfPath = Scheduler::$archiveclean_dir.$selected_backupset."/".UTF8_FILE;;
							
			if(file_exists($encPvtkeyPath))
				$utfParam .= $hashEvsParameters["PVTKEY"].$assignmentOperator.$encPvtkeyPath.$lineFeed;
			
			$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["DELETE"].$lineFeed.
						$hashEvsParameters["FROMFILE"].$assignmentOperator.$input.$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$hashEvsParameters["OUTPUT"].$assignmentOperator.$OutOutputFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator;
			break;
		case FILESTATUSOP:
						
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed;
			$OutErrorFilePath = Scheduler::$archiveclean_dir.$selected_backupset."/".ERROR_FILE;
			$OutOutputFilePath = Scheduler::$archiveclean_dir.$selected_backupset."/".OUTPUTFILE;
			$utfPath = Scheduler::$archiveclean_dir.$selected_backupset."/".UTF8_FILE;
			
			if(file_exists($encPvtkeyPath))
				$utfParam .= $hashEvsParameters["PVTKEY"].$assignmentOperator.$encPvtkeyPath.$lineFeed;
			
			$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["ITEMSTATUS"].$lineFeed.
						$hashEvsParameters["FROMFILE"].$assignmentOperator.$input.$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$hashEvsParameters["OUTPUT"].$assignmentOperator.$OutOutputFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator;
			break;
		case DELETEOP:
			$utfPath = UTF8_FILE;
			$OutErrorFilePath = "./".ERROR_FILE;
			$OutOutputFilePath = "./".OUTPUTFILE;
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed;
			$OutErrorFilePath = $_SESSION['currentRemoteSearchPath'].ERROR_FILE;
			$OutOutputFilePath = $_SESSION['currentRemoteSearchPath'].OUTPUTFILE;
			$utfPath = $_SESSION['currentRemoteSearchPath'].UTF8_FILE;
			if(file_exists($encPvtkeyPath))
				$utfParam .= $hashEvsParameters["PVTKEY"].$assignmentOperator.$encPvtkeyPath.$lineFeed;
			
			$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["DELETE"].$lineFeed.
						$hashEvsParameters["FROMFILE"].$assignmentOperator.$input.$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$hashEvsParameters["OUTPUT"].$assignmentOperator.$OutOutputFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator;
			break;
		case PUT_BACKOP:
			$utfPath = UTF8_FILE;
			$OutErrorFilePath = "./".ERROR_FILE;
			$OutOutputFilePath = "./".OUTPUTFILE;
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed;
			if($_SESSION["encType"] == "Private"){
				$utfParam .= $hashEvsParameters["PVTKEY"].$assignmentOperator.$encPvtkeyPath.$lineFeed;
			}
			
			$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["PUT_BACK"].$lineFeed.
						$hashEvsParameters["FROMFILE"].$assignmentOperator.$input.$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$hashEvsParameters["OUTPUT"].$assignmentOperator.$OutOutputFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator;
			break;
		case REMOVE_FROM_TRASHOP:
			$utfPath = UTF8_FILE;
			$OutErrorFilePath = "./".ERROR_FILE;
			$OutOutputFilePath = "./".OUTPUTFILE;
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed;
			if($_SESSION["encType"] == "Private")
				$utfParam .= $hashEvsParameters["PVTKEY"].$assignmentOperator.$encPvtkeyPath.$lineFeed;
			
			$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["DELETE_TRASH"].$lineFeed.
						$hashEvsParameters["FROMFILE"].$assignmentOperator.$input.$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$hashEvsParameters["OUTPUT"].$assignmentOperator.$OutOutputFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator;
			break;			
		case VALIDATEOP:		
			
			$utfParam = $hashEvsParameters["VALIDATE"].$lineFeed.
			            $hashEvsParameters["USERNAME"].$assignmentOperator.$userName.$lineFeed.
	                    $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed;
			break;
		case CONFIGOP:
			
			$utfParam = $hashEvsParameters["CONFIG"].$lineFeed.
						$hashEvsParameters["USERNAME"].$assignmentOperator.$userName.$lineFeed.
						$hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$hashEvsParameters["ENCTYPE"].$assignmentOperator.$input.$lineFeed;
			if($input == "Private"){
				$utfParam .= $hashEvsParameters["PVTKEY"].$assignmentOperator.$encPvtkeyPath.$lineFeed;
	   		}	
			$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.	
						 $hashEvsParameters["ENCODE"].$lineFeed;
			break;
		case GETSERVERADDRESSOP:
		
			$utfParam = $hashEvsParameters["SERVERADDRESS"].$lineFeed.
						$userName.$lineFeed.
						$hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
			            $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed;
			break;	
	
		case SEARCHOP:
			if($archive == 1){
						
				$volumePath = getOriginalServicePath();
				$OutErrorFilePath = Scheduler::$archiveclean_dir.$selected_backupset."/".ERROR_FILE;
				$OutOutputFilePath = Scheduler::$archiveclean_dir.$selected_backupset."/".OUTPUTFILE;
				$utfPath = "$volumePath/".USER_PROFILE."/$userName/".Scheduler::$archive."/".$selected_backupset."/".UTF8_FILE;
			}
			else{
				$OutErrorFilePath = $_SESSION['currentRemoteSearchPath'].ERROR_FILE;
				$OutOutputFilePath = $_SESSION['currentRemoteSearchPath'].OUTPUTFILE;
				$utfPath = $_SESSION['currentRemoteSearchPath'].UTF8_FILE;
			}
			$utfParam = $hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$hashEvsParameters["OUTPUT"].$assignmentOperator.$OutOutputFilePath.$lineFeed.
						$hashEvsParameters["SEARCH"].$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$searchPath."*".$input."*".$lineFeed;
			break;
		case AUTHLISTOP:
			    $utfPath = preg_replace(('/' . UTF8_FILE . '/'), (AUTHLISTOP . '_' . UTF8_FILE), $utfPath);
				$OutErrorFilePath = $OutOutputFilePath = createFullRestoreDir($input);
				$OutErrorFilePath .= "/".ERROR_FILE;
				$OutOutputFilePath .= "/" . OUTPUTFILE;
			$utfParam = $hashEvsParameters["AUTHLIST"].$lineFeed.
						$hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$hashEvsParameters["OUTPUT"].$assignmentOperator.$OutOutputFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$input.$lineFeed;
			break;
		case GETQUOTAOP:
					$utfParam = $hashEvsParameters["XMLOUTPUT"].$lineFeed.
						$hashEvsParameters["PASSWORD"].$assignmentOperator.$encPwdPath.$lineFeed.
						$hashEvsParameters["ENCODE"].$lineFeed;  
						$utfParam .= $hashEvsParameters["GETQUOTA"].$lineFeed;
						$utfParam .= $hashEvsParameters["PROXY"].$assignmentOperator.$proxyString.$lineFeed.
						$hashEvsParameters["ERROR"].$assignmentOperator.$OutErrorFilePath.$lineFeed.
						$userName.$serverAddressOperator.
						$_SESSION['serverAddr'].$serverNameOperator.
						$serverName.$pathSeparator.$lineFeed;	
			break;
	} 
	
	file_put_contents($utfPath, $utfParam);
	@chmod($utfPath, $permissionVal);
	Scheduler::Log("$optType operation has been executed.");
	return $utfPath;
}

/*********************************************************************************************************
* Subroutine Name       : tracker
* Objective             : This function will help in debugging the code and will be easy to cleanup by 
						  grepping it one way and other way by commenting function defination. So no debug 
						  messages will be present in production code.
* Added By              : Deepak Chaurasia
**********************************************************************************************************/
function tracker($strToWrite,$isFresh='0')
{
	GLOBAL $baseDir;
	GLOBAL $permissionVal;
    GLOBAL $webDir;
        $debugFile = "$baseDir/$webDir/".APPDIR."/".DEBUG_FILE;
        
        if($isFresh == 1){
        	unlink($debugFile);
        }
        	
	file_put_contents($debugFile,"$strToWrite \n",FILE_APPEND);
	@chmod($debugFile, $permissionVal);
}

/*********************************************************************************************************
* Subroutine Name	: remoteList.
* Objective			: List of user data from IDrive server(--auth-list) for specific path.
* Added By			: Avinash Kumar.
* Modified By       : Yogesh Kumar.
**********************************************************************************************************/
function remoteList( $remotePath ) {
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $lineFeed;
	GLOBAL $OutErrorFilePath;
	GLOBAL $OutOutputFilePath;
	GLOBAL $userName;
	GLOBAL $permissionVal;
	
	$pidFile = '';
	$rListIntPath = '';
	$restoreFile = '';
	
	$authListUtfFile = getOperationFile(AUTHLISTOP, $remotePath);	
	$pidFile = createFullRestoreDir($remotePath);
	$pidFile .= '/'.PID_FILE;
    $idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$authListUtfFile\"";
	@unlink($OutOutputFilePath);

	Scheduler::Log('Requesting remote list: ' . $remotePath);

	if(!($handle = fopen($pidFile, "w"))){
		Scheduler::Log("Failed to create $pidFile");
		exit;
	}
	else{
		if(!flock($handle, LOCK_EX|LOCK_NB, $lockFlag)){
			Scheduler::Log("Not able to lock " . PID_FILE);	
		}
	}

	$restoreDir = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/.RestoreList";
	if( !is_dir($restoreDir) ) {
		if( !mkdir($restoreDir, $permissionVal) ) {
			Scheduler::Log("Could not create directory $restoreDir, Reason : $php_errormsg");
			@unlink($authListUtfFile);
			return;
		}
		@chmod($restoreDir, $permissionVal);
	}

	pclose(popen("$idevsutilCommandLine &","r"));

	while(!filesize($OutOutputFilePath) && !filesize($OutErrorFilePath)){
		if(!file_exists($pidFile)){
			break;
		}
		sleep(1);
    }

	$extraString = '';
	$fp = fopen($OutOutputFilePath, 'r');
	$pageNumber = 0;
	$numberOfLines = 0;
	$maxNumberOfLines = 1000;
	$arrayList = array();
	while( 1 ) {
		$terminate = false;
		if(file_exists($OutErrorFilePath) && filesize($OutErrorFilePath)){
			break;
                }
		$records = '';
		$records = fread($fp, (1024 * 10));
		if ($records == '') {
			sleep(1);
			continue;
		}
		$records = explode("\n", $records);
  		$records[0] = $extraString . $records[0];
		$extraString = '';

		foreach($records as $record) {
			$matches = explode("] [", $record, 6);
			if(count($matches) !== 6) {
				if(preg_match('/bytes\/sec/', $record)) {
					$terminate = true;
					break;
				}
				
				$extraString = $record;
				continue;
			}
			
			$type 		= trim(str_replace('[', '', $matches[0]));
			$matches[count($matches) - 1] = rtrim($matches[count($matches) - 1], "]");
			$element 	= $matches[count($matches) - 1];

			if($type == "D") {
				$arrayList[$element]['size']		= '--';
				$arrayList[$element]['datetime']	= trim($matches[3]);
				$arrayList[$element]['type']		= "D";
			} else {
				$arrayList[$element]['size']		= trim($matches[1]);
				$arrayList[$element]['datetime']	= $matches[3];
				$arrayList[$element]['type']		= "F";
			}
			
			++$numberOfLines;
			if ($numberOfLines == $maxNumberOfLines) {
				$rListPath = constructRestoreFileName($remotePath, $pageNumber);
				file_put_contents($rListPath, json_encode($arrayList), LOCK_EX);
				@chmod($rListPath, $permissionVal);
				$arrayList = array();
				$numberOfLines = 0;
				$pageNumber++;
			}
		}

		if ($terminate) {
			if (count($arrayList) > 0) {
				$rListPath = constructRestoreFileName($remotePath, $pageNumber);
				file_put_contents($rListPath, json_encode($arrayList), LOCK_EX);
				@chmod($rListPath, $permissionVal);
			}
			break;
		}
	}
	fclose($fp);

	$rListPath = constructRestoreFileName($remotePath, $pageNumber);
	unlink($authListUtfFile);
	if(filesize($OutErrorFilePath))
	{
		# errorLog("remoteList", false);
		return;
	}
	else if( ($pageNumber == 0) && !file_exists( $rListPath ) ) {
		file_put_contents($rListPath, json_encode($arrayList), LOCK_EX);
		@chmod($rListPath, $permissionVal);
	}
}

#****************************************************************************************************
# Subroutine Name         : remoteSearch.
# Objective               : This function will execute the EVS search command and parse the output file 
#							to provide the expected output to user.
# Modified By             : Deepak Chaurasia
#*****************************************************************************************************/
function remoteSearch($searchItem,$searchPath)
{
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $OutErrorFilePath;	
	GLOBAL $OutOutputFilePath;
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;
	GLOBAL $searchHandle;
	GLOBAL $countItem;
	GLOBAL $isOpened;
	GLOBAL $searchDirRemote;
	GLOBAL $pagePath;
	GLOBAL $pidPath;
	GLOBAL $permissionVal;
	
	if(!is_dir($searchDirRemote)){
		if(!mkdir($searchDirRemote, $permissionVal)){
			$resp[] = false;
			$resp[] = "Failed to create Directory ".$searchDirRemote." : ".$php_errormsg;
			unset($_SESSION['currentRemoteSearchPath']);
			echo json_encode($resp);
			exit;
		}		
		@chmod($searchDirRemote,$permissionVal);
	}
	
	if("" == $searchItem){
		unset($_SESSION['currentRemoteSearchPath']);
		return;
	}
	
	$volumePath = @readlink("$baseDir/$webDir");
	if(empty($volumePath)){
		$volumePath = "$baseDir/$webDir";
	}
	$searchDirRemote = "$volumePath/".SERVICE."/".USER_PROFILE."/$userName/Restore/.+searchList";
	$isSearchDir = createSearchDir($searchPath.$searchItem,$searchDirRemote);
	if($isSearchDir === false){
		print "Search pattern directory not created";
		return;
	}
	
	$pidPathForSearch = "$isSearchDir/$pidPath";
	$_SESSION['currentRemoteSearchPath'] = $isSearchDir."/";
	session_write_close();
	
	//to get the php error message in $php_errormsg variable.
	ini_set('track_errors', 1);			
	
	//Terminating if result is already there for search pattern
	if(file_exists($isSearchDir."/page1")){
		return;
	}
	
	if(!($handle = fopen($pidPathForSearch, "w"))){
		Scheduler::Log($php_errormsg);
		return;
	}
	else{
		@chmod($pidPathForSearch,$permissionVal);
		if(!flock($handle, LOCK_EX|LOCK_NB, $lockFlag)){
			Scheduler::Log("Not able to lock " . PID_FILE);	
		}
		fclose($handle);
	}
	
	$lastLine  = "";
	$pageCount = 0;
	$flag = 0;
	$buffer = "";
	$byteRead = 0;
	$len = 0;
	$toSearchStr = "";
	$type = "";
	$size = "";
	$dateTime = "";
	$item = "";
	$pattern = "";
	$tmpArr = array();
	$isNotOpened = 0;
	$commLine = 4;
	$totalCount = 0;
	
	$searchUtfFile = getOperationFile(SEARCHOP, $searchItem, $searchPath);
	@chmod($searchUtfFile,$permissionVal);
	if(!file_exists($searchUtfFile)){
		Scheduler::Log($php_errormsg);
		return false;
	}

	$searchUtfFile = str_replace("'","'\''",$searchUtfFile);
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."'$searchUtfFile'";
	if(!file_exists($pidPathForSearch)){
		$errStr = ERR_STR_VAL;
		goto USER_CANCEL;
	}
	else{
		Scheduler::Log("Requesting remote search: " . $searchItem);
		pclose(popen("$idevsutilCommandLine &","r"));
	}
	
	while(!filesize($OutOutputFilePath) and !filesize($OutErrorFilePath)){
		if(!file_exists($pidPathForSearch)){
			$errStr = ERR_STR_VAL;	
			goto USER_CANCEL;
		}
		sleep(0.1);
	}	

	/* update server address if cmd failed due to wrong evs server address. */
	if(checkErrorAndUpdateServerAddr($OutErrorFilePath)){
		goto USER_CANCEL;
	}
				
	if(!filesize($OutOutputFilePath)){
		# errorLog("remoteSearch", false);
		goto USER_CANCEL;
	}
	
	$handle = fopen($OutOutputFilePath, "r");
	if(!$handle) {
		print "not able to open\n";
		goto USER_CANCEL;
	}
	
	//Parse output.txt file for search results
	while(1){	
		if(!file_exists($pidPathForSearch)){
			fclose($handle);
			if($searchHandle){
				fclose($searchHandle);
			}
			$errStr = ERR_STR_VAL;
			goto USER_CANCEL;
		}
		
		$buffer = fread($handle, LIMIT);
		if(0 === strlen($buffer)){
			if(filesize($OutErrorFilePath)){
				break;
			}
			sleep(WAIT_FOR);
			fseek($handle, 0, 1);		//to clear eof flag
			continue;
		}
				
		//need to check appending partial record to packet or to first line of packet
		if("" != $lastLine){
			$buffer = $lastLine . $buffer;
		}
		$resultList = explode("\n", $buffer);
		$bufIndex = count($resultList);
		$bufIndex -= 1;
		
		//keep last line of buffer only when it not ends with newline.
		if(!preg_match('/\n$/', $buffer)){
			$lastLine = $resultList[$bufIndex];
		}
		else{
			$lastLine = "";
		}
		
		if(0 == $countItem)
		{
			if(preg_match('/Total files found/', $resultList[$bufIndex-1])){
				$flag = 1;
			}
			if($commLine > 0){
				if($bufIndex > $commLine){
					$resultList = array_slice($resultList, $commLine);
					$bufIndex -= $commLine;
					$commLine = 0;
				}				
				else if($bufIndex > 0){
					$commLine -= $bufIndex;
					$bufIndex = 0;
				}
				
				if($commLine > 0){
					if(!$flag){
						continue;
					} else {
						break;
					}
				}
			}
		}		
		
		if(0 < $bufIndex and preg_match('/Total files found/', $resultList[$bufIndex-1])){
			$flag = 1;
			$bufIndex -= 1;
		}
		
		$totalCount += $bufIndex;
		for($index = 0; $index < $bufIndex; $index++)
		{
			if(0 == $isOpened)
			{
				$pageCount++;
				if($searchHandle){
					fclose($searchHandle);
				}
				$searchHandle = fopen("$pagePath/page$pageCount", "w");
				if(!$searchHandle)
				{
					Scheduler::Log($php_errormsg);
					unlink($pidPathForSearch);
					return;
				}
				$isOpened = 1;
			}
			
			$tmpArr = explode("] [", $resultList[$index], 6);
			$tmpArr[count($tmpArr) - 1] = rtrim($tmpArr[count($tmpArr) - 1], "]");
			$item = $tmpArr[count($tmpArr) - 1];
			
			if($countItem == 0){
				if(stristr($item,$searchItem)){
					$pattern = $item;
					$dateTime = preg_replace("/^\[/", "", $tmpArr[0]);		//remove '['
					$size 	= trim($tmpArr[1]);
					$size = convertFileSize($size);
					$type 	= trim($tmpArr[2])==0?"D":"F";
					addListWithType($type, $item, $dateTime, $size);
				}
				continue;
			}
			
			$retVal = "";
			$retVal = stripos($item, $pattern);
			$orgPattern = $pattern;

			/* Check for all previous patterns based on current pattern */
			$arrTmp = array();
			if($retVal === FALSE) {
				$arrTmp = explode("/", $pattern);
			}

			if($retVal === FALSE and sizeof($arrTmp) > 2 and $arrTmp[sizeof($arrTmp) -1] == "")
				$tmp = array_pop($arrTmp);

			while($retVal === FALSE and sizeof($arrTmp) > 2) {
				$tmp = array_pop($arrTmp);
				if(1 == sizeof($arrTmp)) {
					$pattern = $orgPattern;
					break;
				}
				
				$pattern = implode("/", $arrTmp);
				$retVal = "";
				$retVal = stripos($item, $pattern);
			}
									
			if($retVal !== FALSE and $retVal == 0){
				$len = strlen($pattern);
				$toSearchStr = substr($item, $len);
				$exitMatch = 0;
				if("" != $toSearchStr){
					if(!stristr($toSearchStr,$searchItem)){
						if(FALSE === stripos($toSearchStr, "/") and substr($item, $len-1, 1) !== "/"){
							$exitMatch = 1;
						}
					}
					else{
						$exitMatch = 1;
					}
				}
				
				if($exitMatch){
					$pattern = $item;
					$dateTime = preg_replace("/^\[/", "", $tmpArr[0]);		
					$size 	= trim($tmpArr[1]);
					$size = convertFileSize($size);
					$type 	= trim($tmpArr[2])==0?"D":"F";
					addListWithType($type, $item, $dateTime, $size);
				}
			}
			else {
				$pattern = $item;
				$dateTime = preg_replace("/^\[/", "", $tmpArr[0]);		
				$size 	= trim($tmpArr[1]);
				$size = convertFileSize($size);
				$type 	= trim($tmpArr[2])==0?"D":"F";
				addListWithType($type, $item, $dateTime, $size);
			}
			
			if(!file_exists($pidPathForSearch)){
				fclose($handle);
				if($searchHandle){
					fclose($searchHandle);
				}
				$errStr = ERR_STR_VAL;
				goto USER_CANCEL;
			}
		}
		
		if(1 == $flag){
			break;
		}
	}
	if($searchHandle){
		fclose($searchHandle);
	}
	if($handle){
		fclose($handle);
	}

   USER_CANCEL:
	if(file_exists($pidPathForSearch)){
		unlink($pidPathForSearch);
	}
	else{
		$isSearchDir = str_replace("'","'\''",$isSearchDir);
		$isSearchDir = "'".$isSearchDir;
		shell_exec("rm -rf $isSearchDir/page'*");
		$isSearchDir = ltrim ($isSearchDir, "'");
	}
	
	$searchUtfFile = str_replace("'\''","'",$searchUtfFile);
	if(file_exists($searchUtfFile)){
		unlink($searchUtfFile);
	}

	$isSearchDirError = $isSearchDir."/".ERROR_FILE;
	if(file_exists($isSearchDirError)){
		unlink($isSearchDirError);
	}

	$isSearchDirOutput = $isSearchDir."/".OUTPUTFILE;	
	if(file_exists($isSearchDirOutput)){
		unlink($isSearchDirOutput);
	}
}

/*******************************************************************************************************
* Subroutine Name         : createSearchDir.
* Objective               : Create search folder recursively with pattern folder.      
* Added By                : Avinash Kumar.
********************************************************************************************************/
function createSearchDir($searchData,$searchDirRemote)
{
	GLOBAL $pagePath;
	GLOBAL $permissionVal;
	
	$searchData = preg_replace("/\*+/", "", $searchData);		//remove character '*'.
	$dirArr = explode("/", $searchData);
	$len = count($dirArr);
	$path = $searchDirRemote;
	$init = empty($dirArr[0])?1:0;
	for($i = $init; $i < $len; $i++)
	{
		$path .= "/$dirArr[$i]";
		if(! file_exists($path))
		{
			if(!mkdir($path,$permissionVal))
			{
				if($i == $len - 1)
				{
					$lastItemLen = strlen($dirArr[$i]);
					$path = substr($path, 0, -$lastItemLen);		//remove last item when mkdir fails.
					$path .= "pattern";
					if(file_exists($path))
					{
					
						$path = str_replace("'","'\''",$path);
						$path = "'".$path."'";
						shell_exec("rm -rf $path");
					}
					if(!mkdir($path,$permissionVal))
					{
						Scheduler::Log($php_errormsg);
						return false;
					}
					@chmod($path,$permissionVal);
				}
				
				Scheduler::Log($php_errormsg);
				return false;
			}
			@chmod($path,$permissionVal);
		}
	}
	$pagePath = $path;
	return $pagePath;
}

#*******************************************************************************************************
# Subroutine Name         : addListWithType.
# Objective               : Create list with file or directory type.
# Added By                : Avinash Kumar.
#*******************************************************************************************************/
function addListWithType($type, $item, $dateTime, $size)
{
	GLOBAL $countItem;
	GLOBAL $searchHandle;
	GLOBAL $isOpened;
	if("" == $item)
	{
		return;
	}
	
	if("D" == $type){
		$size = '--';
	}

	$str = $item . "\n" . $size . "\n" . $dateTime . "\n" . $type . "\n";
    flush();
	fwrite($searchHandle, $str);
	$countItem++;
	 
	if(0 == $countItem % NO_OF_LINES)
	{
		$isOpened = 0;
	}
}

#*******************************************************************************************************
# Subroutine Name         : convertFileSize.
# Objective               : file size of a file which has been result of search in readable format.      
# Added By                : Avinash Kumar.
#*******************************************************************************************************/
function convertFileSize($fileSize)
{
	$fileSpec = "bytes";
	GLOBAL $whiteSpace;

	if($fileSize > 1023)
	{
		$fileSize /= 1024;
		$fileSpec = "KB";
	}

	if($fileSize > 1023)
	{
		$fileSize /= 1024;
		$fileSpec = "MB";
	}

	if($fileSize > 1023)
	{
		$fileSize /= 1024;
		$fileSpec = "GB";
	}

	if($fileSize > 1023)
	{
		$fileSize /= 1024;
		$fileSpec = "TB";
	}

	$fileSize = sprintf("%.2f", $fileSize);
	if(0 == ($fileSize - intval($fileSize)))
	{
		$fileSize = sprintf("%.0f", $fileSize);
	}
	return $fileSize.$whiteSpace.$fileSpec;
}


/*********************************************************************************************************
* Subroutine Name	: deleteItems.
* Objective			: Delete set of file/folder from server.
* Added By			: Avinash Kumar.
* Modified By		: (26-Aug-2015) Modified by sajana for Archive Cleanup.
**********************************************************************************************************/
function deleteItems($operationType, $input)
{
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $OutErrorFilePath;	
	GLOBAL $OutOutputFilePath;
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;
	GLOBAL $searchDirRemote;
	GLOBAL $permissionVal;
	GLOBAL $archive_per;
	GLOBAL $selected_backupset;
	GLOBAL $total_perc;
	GLOBAL $periodic_perc_error;
	
	$lastLine = "";
	$commLine = 5;
	$flag = 0;
	$logHandle = "";
	$countDeleted = 0;
	$logStatus = "";
	$outputFile = "";
	$flagTerm = 1;
	$errStr = "";
	$pidPath = PID_FILE;
	
	$logDate = shell_exec('date +"%Y-%m-%d %I:%M:%S %p"');
	if(ARCHIVEOP == $operationType || PERIODICARCHIVEOP == $operationType)
		$pidPath = Scheduler::$archiveclean_dir.$selected_backupset."/".PID_FILE;
	
	$restoreList = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/.RestoreList/";
	$_SESSION['deleteCommand'] = 0;
	
	/* to get the php error message in $php_errormsg variable. */
	ini_set('track_errors', 1);			
	
	if(ARCHIVEOP != $operationType && PERIODICARCHIVEOP != $operationType){
		if(!($pidhandle = fopen($pidPath, "w"))){
			Scheduler::Log($php_errormsg);
		}
		else{
			if(!flock($pidhandle, LOCK_EX|LOCK_NB, $lockFlag)){
				Scheduler::Log("Not able to lock " . PID_FILE);	
			}

			fwrite($pidhandle,"Delete");
			fclose($pidhandle);
			@chmod($pidPath,$permissionVal);
		}	
	}
	
	$linecount = 0;
	$linecount = count(file($input)); 
 
	$deleteUtfFile = getOperationFile($operationType, $input);		
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$deleteUtfFile\"";	
	
	/* log file name creation as per operation type. */
	if(DELETEOP == $operationType)
		$outputFile = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/Delete/LOGS/" . $logDate . " DELETE";
	else if(PUT_BACKOP == $operationType)
		$outputFile = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/Delete/LOGS/" . $logDate . " PUT_BACK";
	else if(REMOVE_FROM_TRASHOP == $operationType)
		$outputFile = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/Delete/LOGS/" . $logDate . " TRASH DELETE";
	else if(ARCHIVEOP == $operationType || PERIODICARCHIVEOP == $operationType)
	{
		$logDir = Scheduler::$archiveclean_dir.$selected_backupset."/LOGS/";
		if(!is_dir($logDir)){
			if(!mkdir($logDir, $permissionVal)){
				$errStr = 'AR_DEL_LOG_DIR';
				goto USER_CANCEL;
			}
			@chmod($logDir,$permissionVal);
		}
		
		$logpid = Scheduler::$archiveclean_dir.$selected_backupset."/".LOG_PID_FILE;
		$outputFile = Scheduler::$archiveclean_dir.$selected_backupset."/LOGS/" . trim($logDate)." ".ARCHIVECLEANUP_TITLE;
	}
	
	if(!($logHandle = fopen($outputFile, "w"))){
		Scheduler::Log($php_errormsg);
		$errStr = 'AR_DEL_LOG';
		goto USER_CANCEL;
	}
	
	if(!($logProgresshandle = openFile($logpid)) && $operationType == ARCHIVEOP){
		$errStr = 'AR_PID';
		goto USER_CANCEL;
	}
	
	fwrite($logProgresshandle, $outputFile);
	fclose($logProgresshandle);
	$logStartEndTime = shell_exec('date +"%a %b %d %T %Y"');
	
	/* write the operation start time with content corresponding to operation type. */
	if(DELETEOP == $operationType || REMOVE_FROM_TRASHOP == $operationType){
		fwrite($logHandle, "Delete Start Time: ".$logStartEndTime."\n\n");
	}
	else if(ARCHIVEOP == $operationType || PERIODICARCHIVEOP == $operationType) 		
	{
		/* changed by Avinash 04-07-2016 */
		fwrite($logHandle, "Start Time: ".trim($logStartEndTime)."\n\n"); 
		//fwrite($logHandle, "Username  : ".$_SESSION['userName']."\n");
		fwrite($logHandle, "Username: ".Scheduler::$user_name."\n");
		if(PERIODICARCHIVEOP == $operationType)
			fwrite($logHandle, "Backup set: ".$selected_backupset."\n");
		
		//fwrite($logHandle, "Start Time : ".trim($logStartEndTime)."\n"); 
		if(ARCHIVEOP == $operationType)	
			fwrite($logHandle, "Backup set: ".$_SESSION['user_backup_set']."\n");
		
		if(PERIODICARCHIVEOP == $operationType)
			fwrite($logHandle, "Periodic Cleanup Operation"."\n");
		else
			fwrite($logHandle, "Archive Cleanup Operation"."\n");

		fwrite($logHandle, " "."\n");
		
		 /* If no % error then write deleted content */
		if(!isset($periodic_perc_error))
			/* changed by Avinash 04-07-2016 */
			//fwrite($logHandle, "Deleted Content"."\n");
			fwrite($logHandle, "[Deleted Content]"."\n");
		else if((PERIODICARCHIVEOP == $operationType) && ($periodic_perc_error == 0)){
			$flagTerm = 0; 					/* setting flag to skip delete operation for % error */
			fwrite($logHandle, "[Periodic Cleanup Operation] Aborted due to the number of files considered for deletion is ".$total_perc."%, which is more than ".$archive_per."%"."\n");
		}
	}
	else if(PUT_BACKOP == $operationType)
		fwrite($logHandle, "Put Back Start Time: ".$logStartEndTime."\n\n");
	
	if(!file_exists($pidPath)){
		$flagTerm = 0;
		$errStr = ERR_STR_VAL;
	}
	
	if($flagTerm ==1){
		$_SESSION['deleteCommand'] = 1;
		session_write_close();
		system("$idevsutilCommandLine &");
		
		while(!filesize($OutOutputFilePath) && !filesize($OutErrorFilePath) && file_exists($pid))
			sleep(0.1);
	
		/* if error file size is positive then return from here "with error". */
		if(filesize($OutErrorFilePath) and !filesize($OutOutputFilePath))
		{
			# errorLog("deleteItems", false);
			fwrite($logHandle, "\n" . ADDITIONAL_INFO . "\n");
			if(!($errHandle = fopen($OutErrorFilePath, "r")))
			{
				Scheduler::Log($php_errormsg);
				$errStr = $php_errormsg;	
			}
			else{
				while(! feof($errHandle)){
					$errContent = fgets($errHandle);
					fwrite($logHandle, $errContent);
					/* update server address if cmd failed due to wrong evs server address. */
					if(FALSE != (strpos($errContent, SERVER_ERROR))){
						getServerAddress();
					}
				}
				fclose($errHandle);
			}
		}
		else{
			if($handle = fopen($OutOutputFilePath, "r")) 
			{
				while($flagTerm)
				{			
					$buffer = fread($handle, LIMIT);
					if(0 === strlen($buffer))
					{
						sleep(WAIT_FOR);
						fseek($handle, 0, 1);		/* to clear eof flag */
						
						if(!file_exists($pidPath)){
							$flagTerm = 0;
							$errStr = ERR_STR_VAL;
						}
						continue;
					}
					
					/* Append partial record to packet */
					if("" != $lastLine)			 
						$buffer = $lastLine . $buffer;
				
					$resultList = explode("\n", $buffer);
					$bufIndex = sizeof($resultList);
					$lastLine = $resultList[$bufIndex - 1];
					$bufIndex -= 1;
					
					if($bufIndex != 0 and (preg_match('/End of operation/',$resultList[$bufIndex - 1]))){
						$flag = 1;
						$bufIndex -= 2;		/* To remove 1 empty line & Number of items deleted. */
					}
					else if(1 < $bufIndex and preg_match('/End of operation/',$resultList[$bufIndex-2])){
						$flag = 1;
						$bufIndex -= 3;		/* To remove 2 empty lines & Number of items deleted. In case delete multiple entries in delete set with exist data and non exist data. */
					}
					else if($bufIndex != 0 and preg_match('/Incomplete operation/',$resultList[$bufIndex - 1]))
					{
						$flag = 1;
						$bufIndex -= 4;		/* To remove 2 empty lines, End of operation & Number of items deleted. In case delete from trash multiple entries in delete set with exist data and non exist data. */					}
					
					if(preg_match('/No items found/',$resultList[$bufIndex - 1]))
						break;
										
					/*when output file has no. of lines more than $commLine(5) then only has to remove.
					Description : for the case when some item has already exists at server and user has performed delete
					and then perform delete from trash. Still deleteSet file has same entries and user trying to delete.
					It falls in 1st if with match "End of operation" but there is only flag filling no break and the 
					$bufIndex length has reduced by 2 so in below condition it always encounter to continue.*/
					if( 0 < $commLine and 0 < $bufIndex)
					{
						if($bufIndex > $commLine)
						{
							$resultList = array_slice($resultList, $commLine);
							$bufIndex -= $commLine;
							$commLine = 0;
						}				
						else if($bufIndex > 0)
						{
							$resultList = array_slice($resultList, $bufIndex-1);
							$commLine -= $bufIndex;
							$bufIndex = 0;
						}
						
						if($commLine > 0)
						{
							if($flag)
								break;
							else
								continue;
						}
					}
					
					for($index = 0; $index < $bufIndex; $index++)
					{
						if("" != $resultList[$index]){
							fwrite($logHandle, $resultList[$index]."\n");
							$countDeleted++;
						}
					}
					if(1 == $flag)
						break;
				}
				fclose($handle);		
			}
		}
		
		/* Deleting contents inside the .RestoreList Dir .*/
		$pathsToDelete = "\"$restoreList\"* \"$searchDirRemote\"";
		Scheduler::Log("$pathsToDelete &");
		removeDirContent($pathsToDelete);		
	}
	
	session_start();
	$failToDelete = $linecount - $countDeleted;
			
	fwrite($logHandle, "\n" . SUMMARY);
	if(DELETEOP == $operationType || REMOVE_FROM_TRASHOP == $operationType)
	{
		fwrite($logHandle, "\n" . TOAL_CONSIDERD_DELETE . $linecount."\n");
		fwrite($logHandle, TOTAL_DELETED . $countDeleted."\n");
		fwrite($logHandle, TOTAL_FAIL_TO_DELETE . $failToDelete."\n");
		fwrite($logHandle, "\n" . DELETE_END_TIME . $logStartEndTime."\n");
	}
	if(ARCHIVEOP == $operationType || PERIODICARCHIVEOP == $operationType)
	{
		fwrite($logHandle, "\n" . TOAL_CONSIDERD_DELETE . $linecount."\n");
		fwrite($logHandle, TOTAL_DELETED . $countDeleted."\n");
		fwrite($logHandle, TOTAL_FAIL_TO_DELETE . $failToDelete."\n");
		fwrite($logHandle, "\n" . "End Time: " . trim($logStartEndTime)."\n");
	}
	else if(PUT_BACKOP == $operationType)
	{
		fwrite($logHandle, "\n" . TOTAL_CONSIDERED_MOVE . $linecount."\n");
		fwrite($logHandle, TOTAL_MOVED . $countDeleted."\n");
		fwrite($logHandle, TOTAL_FAIL_TO_MOVE . $failToDelete."\n");
		fwrite($logHandle, "\n" . MOVE_END_TIME . $logStartEndTime."\n");
	}
	if("" != $errStr)
	{
		fwrite($logHandle, ERR_SEPERATOR . "\n");
		fwrite($logHandle, $errStr ."\n");
		fwrite($logHandle, ERR_SEPERATOR . "\n");
	}
	
	/* log error as additional information */
	if(filesize($OutErrorFilePath) and filesize($OutOutputFilePath))
	{
		fwrite($logHandle, "\n" . ADDITIONAL_INFO . "\n");
		if(!($errHandle = fopen($OutErrorFilePath, "r")))
		{
			Scheduler::Log($php_errormsg);
			$errStr = $php_errormsg;
		}
		
		while(! feof($errHandle))
			fwrite($logHandle, fgets($errHandle));
		fclose($errHandle);
	}
	
	fclose($logHandle);
	
	if($linecount == $countDeleted)
		$logStatus = SUCCESS;	                      
	else if(!file_exists($pidPath) || ((PERIODICARCHIVEOP == $operationType) && ($periodic_perc_error==0)))
		$logStatus = ABORTED;	
	else
		$logStatus = FAILURE;
	
	rename($outputFile, $outputFile."_".$logStatus);
	$outputFile = $outputFile."_".$logStatus;
	
	if(($logProgresshandle = openFile($logpid))) {
		fwrite($logProgresshandle, $outputFile."_".$logStatus);
		fclose($logProgresshandle);
	}

USER_CANCEL: 
	
	if($errStr =='AR_DEL_LOG_DIR' || $errStr == 'AR_DEL_LOG' || $errStr =='AR_PID')
		unlink($outputFile);			
	if(file_exists($OutErrorFilePath))
		unlink($OutErrorFilePath);
	if(file_exists($OutOutputFilePath))
		unlink($OutOutputFilePath);
	if(file_exists($deleteUtfFile))
		unlink($deleteUtfFile);
	if(file_exists($pidPath))
		unlink($pidPath);
	if(file_exists($logpid))
		unlink($logpid);
	if(file_exists($input))
		unlink($input);

return $errStr;
}

/*********************************************************************************************************
* Subroutine Name	: errorLog
* Objective			: Logs error 
* Added By			: Basavaraj Bennur
**********************************************************************************************************/
function errorLog($funcName, $pos)
{
	GLOBAL $OutErrorFilePath;
	if($pos !== false){
		Scheduler::Log($funcName);
	}
	
	Scheduler::Log($funcName . @file_get_contents($OutErrorFilePath));
	@unlink($OutErrorFilePath);
}

/*********************************************************************************************************
* Subroutine Name	: encodePathWrapper
* Objective			: Wrapper func to createEncodeFile. 
* Added By			: Basavaraj Bennur
**********************************************************************************************************/
function encodePathWrapper($passwrd, $encType, $pvtKey)
{
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;
	GLOBAL $permissionVal;
	
	$encPwdPath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/IDPWD";
	$encPvtkeyPath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/IDPVT";
		
	if(empty($passwrd)){
		Scheduler::Log("Password entry is missing.");
	}
	else {
		createEncodeFile($passwrd, $encPwdPath);
		@chmod($encPwdPath, $permissionVal);
	}
	if($encType == "Private"){
		if(empty($pvtKey)){
			Scheduler::Log("Private entry is missing.");
		}
		else{
			createEncodeFile($pvtKey, $encPvtkeyPath);
			@chmod($encPvtkeyPath, $permissionVal);
		}
	}	
}

#****************************************************************************************************
# Subroutine Name         : createPwdFile.
# Objective               : Create password encrypted file.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
function createEncodeFile($data, $path)
{	
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $assignmentOperator;
	GLOBAL $whiteSpace;
	GLOBAL $hashEvsParameters;
	$utfFile = "";
	if(file_exists($path)){
		unlink($path);
	}
	$utfFile = getUtf8File($data, $path);
	
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$hashEvsParameters["UTF8CMD"].$assignmentOperator."\"$utfFile\"";
	
	$commandOutput = `$idevsutilCommandLine`;
	unlink($utfFile);
}

#****************************************************************************************************
# Subroutine Name         : getUtf8File.
# Objective               : utf8 encode file creation.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
function getUtf8File($data, $path)
{
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;
	GLOBAL $permissionVal;
	
	//create utf8 file.	
 	$utfFile = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".UTF8_FILE;	
  	file_put_contents($utfFile, "--string-encode=$data\n--out-file=$path");
	@chmod($utfFile, $permissionVal);
  	return $utfFile;	
}

/*********************************************************************************************************
* Subroutine Name	: validateIDriveLoginCGI
* Objective			: Validates IDrive account using CGI. Returns TRUE on Success and FALSE on failure
* Added By			: Senthil Pandian
**********************************************************************************************************/
function validateIDriveLoginCGI($passwrd)
{
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $lineFeed;
	GLOBAL $userName;
	
	if(empty($_SESSION['userName']) || !isset($_SESSION['userName'])){
		GLOBAL $bandwidthFilePath;
		GLOBAL $relativeFile;
		GLOBAL $mpc;
		GLOBAL $drlFile;
		GLOBAL $OutErrorFilePath;

		$_SESSION['userName'] = $userName;	
		$bandwidthFilePath = Scheduler::$user_dir.BW_FILE;
		$relativeFile = Scheduler::$user_dir.RELATIVE_FILE;
		$mpc = Scheduler::$user_dir.MPC_FILE;
		$drlFile = Scheduler::$user_dir.RESTORE_LOCATION_FILE;
		$OutErrorFilePath = Scheduler::$user_dir.ERROR_FILE;
	}

	$path = IDRIVE_CGI_PATH."?username=".rawurlencode($userName)."&password=".rawurlencode($passwrd);
	$validOutput = getCurlOutput($path);
	
	$pos1 = strpos($validOutput, "ERROR");
	$pos2 = strpos($validOutput, "FAILURE");
	if($pos1 !== false || $pos2 !== false){
    if($pos2 !== false)
		{
			if(strpos($validOutput, "windows_user"))
				return "windows_user";			
		}
		return FALSE;
	}
	
	$xml = simplexml_load_string($validOutput);
	$xmlArray = $xml->login;

	if((string)$xmlArray['plan_type'] != "MobileOnly"){

		if((string)$xmlArray['message'] == "SUCCESS"){	
			$serverOutput = (string)$xmlArray['evssrvr'];
			$usedQuota  = (string)$xmlArray['quota_used'];
			$totalQuota = (string)$xmlArray['quota'];
			$_SESSION['accountUsage']  = $usedQuota."#".$totalQuota;		

			if($serverOutput != ''){
				$_SESSION['serverAddr'] = $serverOutput;
			}
		}
	} else {
		$xmlArray['message'] = "INVALID_PLAN_TYPE";
	}
	$retVal=(string)$xmlArray['message']."_".(string)$xmlArray['cnfgstat']."_".(string)$xmlArray['enctype']."#".$usedQuota."#".$totalQuota; 
	return $retVal;
}
/*********************************************************************************************************
* Subroutine Name	: confAccount
* Objective			: Configures idrive account. Returns TRUE on Success and FALSE on failure
* Added By			: Basavaraj Bennur
**********************************************************************************************************/
function confAccount($encType)
{
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $lineFeed;
	$errorRedirection = "2>&1";	
	$configUtfFile = getOperationFile(CONFIGOP, $encType);
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$configUtfFile\"".$whiteSpace.$errorRedirection.$lineFeed;
	$commandOutput = `$idevsutilCommandLine`;

	unlink($configUtfFile);
	$pos = strpos($commandOutput, "ERROR");
	if($pos !== false){
		# errorLog("validateAccount",$pos);
		$arrOutput = array(FALSE);
		return $arrOutput;
	}
	$xmlArray = parseXMLOutput($commandOutput);
	return $xmlArray;
}

/*********************************************************************************************************
* Subroutine Name	: getServerAddress
* Objective			: Gets Server Address. Returns TRUE on Success and FALSE on failure
* Added By			: Basavaraj Bennur
* Modified By 		: Avinash Kumar
**********************************************************************************************************/
function getServerAddress()
{
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $lineFeed,$permissionVal;
	
	$errorRedirection = "2>&1";
	$getServerUtfFile = getOperationFile(GETSERVERADDRESSOP);
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$getServerUtfFile\"".$whiteSpace.$errorRedirection.$lineFeed;
	$out = `$idevsutilCommandLine`;
	
	@unlink($getServerUtfFile);	
	$pos = strpos($out, "ERROR");
	if($pos !== false){
		# errorLog("validateAccount",$pos);
		$arrOutput = array(FALSE);
		return $arrOutput;
	}
	$xmlArray = parseXMLOutput($out); 
	
		
	if(!empty($xmlArray['cmdUtilityServer'])){
		$serverAddr = trim($xmlArray['cmdUtilityServer']);
		$arrOutput = array(TRUE, $serverAddr);
		
		/* Update evs server address in .serverAddr.txt */	
		$file = Scheduler::$user_dir.SERVER_ADDR_PATH;
		file_put_contents($file, $xmlArray['cmdUtilityServer']);
		@chmod($file, $permissionVal);
		unset($_SESSION['serverAddr']); 
	} else {
		Scheduler::Log("getServerAddress is empty.");
		$arrOutput = array(FALSE);
	}

	return $arrOutput;
}

/*********************************************************************************************************
* Subroutine Name	: getVersionInfo
* Objective			: Gets version details of supplied file. Returns TRUE on Success and FALSE on failure
* Added By			: Basavaraj Bennur
* Modified By		: Yogesh Kumar
**********************************************************************************************************/
function getVersionInfo($input)
{	
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $OutErrorFilePath;
	$versionUtfFile = getOperationFile(VERSIONINFOOP, $input);
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$versionUtfFile\"";	
	
	$out =`$idevsutilCommandLine`;
	unlink($versionUtfFile);
	
	/* update server address if cmd failed due to wrong evs server address. */
	checkErrorAndUpdateServerAddr($OutErrorFilePath);
	
	$pos = strpos($out, "ERROR");
	if(0 < filesize($OutErrorFilePath) || $pos !== false){
		# errorLog("getVersionInfo",$pos);
		$arrOutput = array(FALSE, array('err' => 'Failed to restore the file.'));
		return $arrOutput;
	}	
	unlink($OutErrorFilePath);	
	$arrOutput = array(TRUE, array('err' => 'No version found.'));
	preg_match_all("/\[(.*?)\]/", $out, $matches);
	if (isset($matches[1]) && (count($matches[1]) > 0)) {
		$index = 1;
		while (array_key_exists($index, $matches[1])) {
			$matches[1][$index]       = humanReadableSize($matches[1][$index]);
			$expDate                  = explode(' ',trim($matches[1][($index - 1)]));
			$matches[1][($index - 1)] = $expDate[0]." ".ampmTimeFormat($expDate[1]);
			$index += 3;
		}
		$arrOutput = array(TRUE, $matches[1]);
	}
	return $arrOutput;
}

/*********************************************************************************************************
* Subroutine Name	: getProperties
* Objective			: Gets properties of a file. Returns TRUE on Success and FALSE on failure
* Added By			: Basavaraj Bennur
**********************************************************************************************************/
function getProperties($input)
{	
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $OutErrorFilePath;
	$propertiesUtfFile = getOperationFile(PROPERTIESOP, $input);
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$propertiesUtfFile\"";	
	$out = `$idevsutilCommandLine`;
	unlink($propertiesUtfFile);
	/* update server address if cmd failed due to wrong evs server address. */
	checkErrorAndUpdateServerAddr($OutErrorFilePath);

	$pos = strpos($out, "ERROR");
	if(0 < filesize($OutErrorFilePath) || $pos !== false){
		# errorLog("getProperties",$pos);
		$arrOutput = array(FALSE);
		return $arrOutput;		
	}
	unlink($OutErrorFilePath);
	preg_match_all("/\[(.*?)\]/", $out, $matches);
	$arr[] = humanReadableSize($matches[1][2]);
    $arr[] = $matches[1][1];
	  $expDate = explode(' ',trim($matches[1][0])); 
	  $arr[] = $expDate[0]." ".ampmTimeFormat($expDate[1]);
	$arrOutput = array(TRUE, $arr); 
	return $arrOutput;
}

/*********************************************************************************************************
* Subroutine Name	: createDir
* Objective			: Creates directory on server. Returns TRUE on Success and FALSE on failure
* Added By			: Basavaraj Bennur
**********************************************************************************************************/
function createDir($dirName, $path, $encType)
{	
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $OutErrorFilePath;
	GLOBAL $lineFeed;
	$errorRedirection = "2>&1";
	
	$input = array($dirName, $path, $encType);
	$createDirUtfFile = getOperationFile(CREATEDIROP, $input);
	
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$createDirUtfFile\"".$whiteSpace.$errorRedirection.$lineFeed;	

	$out = `$idevsutilCommandLine`;
	@unlink($createDirUtfFile);
	/* update server address if cmd failed due to wrong evs server address. */
	checkErrorAndUpdateServerAddr($OutErrorFilePath);

	$pos = strpos($out, "ERROR");
	if(0 < @filesize($OutErrorFilePath) || $pos !== false){		
		# errorLog("createDir",$pos);
		$arrOutput = array(FALSE, $out);
		return $arrOutput;
	}
	@unlink($OutErrorFilePath);
	$arrOutput = array(TRUE, $out);
	return $arrOutput;
}

/*********************************************************************************************************
* Subroutine Name	: renamePath
* Objective			: Renames old path to newpath on server. Returns TRUE on Success and FALSE on failure
* Added By			: Basavaraj Bennur
**********************************************************************************************************/
function renamePath($oldPath, $newPath)
{
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $OutErrorFilePath;
	$input = array($oldPath, $newPath);
	
	$renameUtfFile = getOperationFile(RENAMEOP, $input);		
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$renameUtfFile\"";	
	
	$out = `$idevsutilCommandLine`;	
	unlink($renameUtfFile);
	/* update server address if cmd failed due to wrong evs server address. */
	checkErrorAndUpdateServerAddr($OutErrorFilePath);
	
		if(file_exists($OutErrorFilePath)){
			$error = file_get_contents($OutErrorFilePath);
			$error = trim(str_replace('@ERROR:','',$error));
			$error = str_replace(' ','&nbsp;',$error);
		} else {
			$error = "Rename failed";
		}
	$pos = strpos($out, "ERROR");
	$success = strpos($out, "renamed");
	
	if(is_int($success)){
		return true;
	} else {
		# errorLog("renamePath",$pos);
		return $error;
	}
}

/*********************************************************************************************************
* Subroutine Name	: renameRestoreSetItems
* Objective			: Renames old path to newpath in Restore Set file in all job if old path exists.
* Added By			: Senthil Pandian.K
**********************************************************************************************************/
function renameRestoreSetItems($oldPath, $newPath){
	GLOBAL $permissionVal;
	$jobs = Scheduler::ReadJobs();
	$jobType = "Restore";
		$jobTypeLen = strlen($jobType)+1;
	$find 	 = array($oldPath."\n",$oldPath."/");
	$replace = array($newPath."\n",$newPath."/");
	foreach($jobs as $k=>$job) {
		if($job["job_type"] == $jobType) {
			$jobNameDir = substr($k,$jobTypeLen);
			$jobNameDirPath = Scheduler::$user_dir."$jobType/$jobNameDir";

			$displayFile_content = file_get_contents("$jobNameDirPath/".RESTORESETFILEDISPLAY);
			$displayFile_content  = str_replace($find,$replace,$displayFile_content);
			file_put_contents("$jobNameDirPath/".RESTORESETFILEDISPLAY,$displayFile_content);
		}		  
	}
		@chmod("$jobNameDirPath/".RESTORESETFILEDISPLAY, $permissionVal);
}

/*********************************************************************************************************
* Subroutine Name	: renameBackupLocation
* Objective			: Renames old path to newpath for BackupLocation if old path exists.
* Added By			: Senthil Pandian.K
**********************************************************************************************************/
function renameBackupLocation($oldPath, $newPath)
{
	GLOBAL $userName,$permissionVal;
	$backupLocation = Scheduler::GetHost($userName);
	if($backupLocation==$oldPath){
		$backupLocation = $newPath;	
		file_put_contents(Scheduler::$user_dir.MPC_FILE,$backupLocation);
	} elseif(strpos($backupLocation,$oldPath."/")==0){
		$backupLocation = str_replace($oldPath."/",$newPath."/",$backupLocation);
		file_put_contents(Scheduler::$user_dir.MPC_FILE,$backupLocation);
	}	
	@chmod(Scheduler::$user_dir.MPC_FILE, $permissionVal);
	return $backupLocation;
}

/*********************************************************************************************************
* Subroutine Name	: renameRestoreList
* Objective			: Renames old path to newpath for RestoreList if old path exists.
* Added By			: Senthil Pandian.K
**********************************************************************************************************/
function renameRestoreList($oldPath, $newPath){
	GLOBAL $user,$permissionVal;
	
	$filePath = Scheduler::$user_dir.".RestoreList";

	if(file_exists($filePath.$oldPath)){
		$cmd = "mv '$filePath$oldPath' '$filePath$newPath'";
		`$cmd`;
	}

   //To rename the item in list.txt
		$rootPath = explode('/',$oldPath);
		$oldItem = array_pop($rootPath);	
		$rootPath = implode("/",$rootPath);
		if(file_exists($filePath.$rootPath)){
			$exp2    = explode('/',$newPath);
			$newItem = end($exp2); //Last element from array
			$toFind  = json_encode(array($newItem));
			$lastItemLen = strlen(trim($toFind));
			$newItem = substr($toFind, 1, ($lastItemLen-2));
			
			$toFind  = json_encode(array($oldItem));
			$lastItemLen = strlen(trim($toFind));
			$oldItem = substr($toFind, 1, ($lastItemLen-2));
			$restoreFile = constructRestoreFileName($rootPath); 
			$restoreFileContent = file_get_contents($restoreFile);
			
			$oldItem = preg_replace("/^(?:.*\n){2,5}/","",$oldItem);
			$newItem = preg_replace("/^(?:.*\n){2,5}/","",$newItem);
			
					
			$renamedString = str_replace($oldItem,$newItem,$restoreFileContent);
			file_put_contents($restoreFile,$renamedString);	
			@chmod($restoreFile, $permissionVal);		
	}
}
function renameRestoreList1($oldPath, $newPath){
	GLOBAL $user,$permissionVal;
	$filePath = Scheduler::$user_dir.".RestoreList/";
	$list = shell_exec("ls -l \"$filePath\" | grep ^- | awk '{ sub(/[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ +[^ ]+ /, \"\"); print }' |  awk '{ print }'");
	$exp = explode("\n",$list);
	sort($exp,SORT_STRING);
	$exp1 = explode('/',$oldPath);
	$exp2 = explode('/',$newPath);
	
	$rootLevel=0;
	$rootPath = $exp1;
	array_pop($rootPath);
	$rootPath = implode("_",$rootPath);
	$rootPath = $rootPath==''?'_':$rootPath;
	$rootFilePath = RESTORELIST.$rootPath.".txt";
	
	$formattedOldPath = str_replace('/','_',$oldPath);
	$formattedNewPath = str_replace('/','_',$newPath);

	foreach($exp as $file){
		if(trim($file)==$rootFilePath) {
			$restoreFileContent = file_get_contents($filePath.trim($file));
			if(strpos($restoreFileContent,"\n\n".end($exp1)."\n")>0){
				$renamedString = str_replace("\n\n".end($exp1)."\n","\n\n".ltrim(end($exp2),'/')."\n",$restoreFileContent);
				file_put_contents($filePath.trim($file),$renamedString);
				@chmod($filePath.trim($file), $permissionVal);
				$rootLevel=1;
			} elseif(strpos($restoreFileContent,end($exp1)."\n")==0){
				$find    = array("+","*","?");
				$replace = array("\+","\*","\?");
				$newPath = str_replace($find,$replace,ltrim(end($exp2),'/'));
				$oldPath = str_replace($find,$replace,end($exp1));
				$renamedString = preg_replace("/".$oldPath."\n/","$newPath\n",$restoreFileContent,1);
				$renamedString = str_replace($replace,$find,$renamedString);
				file_put_contents($filePath.trim($file),$renamedString);
				@chmod($filePath.trim($file), $permissionVal);
				$rootLevel=1;
			}
		} else if($rootLevel==1){
			if(strpos($file,$formattedOldPath)>0){			
				$toRename = str_replace($formattedOldPath,$formattedNewPath,$file);
				$cmd = "mv \"$filePath".trim($file)."\" \"$filePath".trim($toRename)."\"";
				$res = shell_exec($cmd);				
			}
		}
	}		
}

/*********************************************************************************************************
* Subroutine Name	: updateNewDirInRestoreList
* Objective			: Update new directory in RestoreList if path exists.
* Added By			: Senthil Pandian.K
**********************************************************************************************************/
function updateNewDirInRestoreList($currPath,$newDir){
	GLOBAL $permissionVal;
	$restoreFile = constructRestoreFileName($currPath); 
	if(file_exists($restoreFile)){
		$restoreFileContent = file_get_contents($restoreFile);
			
		if(trim($restoreFileContent)!=''){
			$oldDirArray = json_decode($restoreFileContent, true);
			$oldDirArray[$newDir]["size"]     = "--"; 
			$oldDirArray[$newDir]["datetime"] = date('Y/m/d h:m:s');
			$oldDirArray[$newDir]['type'] = "D";
			$newDirString = json_encode($oldDirArray);
		} else {	
			$newDirArray[$newDir]["size"]     = "--"; 
			$newDirArray[$newDir]["datetime"] = date('Y/m/d h:m:s');
			$newDirArray[$newDir]['type'] = "D";		
			$newDirString = json_encode($newDirArray);
		}
		file_put_contents($restoreFile,$newDirString);
		@chmod($restoreFile, $permissionVal);
	}	
}

/*********************************************************************************************************
* Subroutine Name	: rateOfTransfer
* Objective			: Tests the upload / download transfer rate. Returns TRUE on Success and FALSE on failure
* Added By			: Basavaraj Bennur
**********************************************************************************************************/
function rateOfTransfer($input)
{
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $OutErrorFilePath;	
	
	$speeUtfFile = getOperationFile(SPEEDOP, $input);		
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$speeUtfFile\"";	
	
	$out = `$idevsutilCommandLine`;
	unlink($speeUtfFile);
	/* update server address if cmd failed due to wrong evs server address. */
	checkErrorAndUpdateServerAddr($OutErrorFilePath);
	
	$pos = strpos($out, "ERROR");
	if(0 < filesize($OutErrorFilePath) || $pos !== false){	
		# errorLog("rateOfTransfer",$pos);
		$arrOutput = array(FALSE);
		return $arrOutput;
	}
	unlink($OutErrorFilePath);	
	$arrOutput = array(TRUE, $out);
	return $arrOutput;
}

#****************************************************************************************************
# Subroutine Name         : parseXMLOutput.
# Objective               : Parse evs command output and return values of corresponding message.
# Added By                : Basavaraj Bennur.
#*****************************************************************************************************/
function parseXMLOutput($commandOutput)
{
	preg_match_all("/\<tree (.*?)\"\/>/", $commandOutput, $xmlOutput);
	$out =$xmlOutput[1][0];
	$exp = explode('" ',$out);
	
	foreach($exp as $item){
		$fields = explode('="',$item);
		$arr[$fields[0]] = $fields[1];
	}
	return $arr;
}

/************************************************************************************************
* Subroutine Name	: readAccountSettingsFile
* Objective		: Reads ACCOUNT_SETTINGS_FILE and copies values into a Session array
* Added By		: Basavaraj Bennur
************************************************************************************************/
function readAccountSettingsFile()
{ 
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;
	$accountSettingsFilePath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/ACCOUNT_SETTINGS_FILE";

	if(file_exists($accountSettingsFilePath) === TRUE)
	{ 
		$accountSettingsFileContents = file_get_contents($accountSettingsFilePath);
		$accountSettingsArray = explode("\n", $accountSettingsFileContents);

		for($count = 0; $count < count($accountSettingsArray); $count++)
		{
			$temp = preg_replace("/\s/", "", $accountSettingsArray[$count]);
			$arr = explode("=", $temp); 
			if(count($arr)>1){
				$_SESSION[$arr[0]] = $arr[1]; 
			}
		}
		$_SESSION['configVerified'] = true;
	}	
}

/****************************************************************************************************
* Subroutine Name         : ampmTimeFormat.
* Objective               : Convert the given time in 24-hour format to 12 hour format.
* Added By                : Basavaraj Bennur.
* Modified By             : Senthil Pandian
******************************************************************************************************/
function ampmTimeFormat($hourMin)
{
	$result='';
	$timeArr=explode(":",$hourMin);
	$hour = $timeArr[0];
	$min  = str_pad($timeArr[1], 2, '0', STR_PAD_LEFT);
	$sec  = str_pad($timeArr[2], 2, '0', STR_PAD_LEFT);
	$finalHr = $hour;
	$amPm =" PM";
	
	if($hour < 12){	
		if($hour == "00")
			$finalHr = "12";
		$amPm = " AM";
	}
	else if($hour > 12){
		$finalHr = $hour - 12;
	}


	$finalHr  = str_pad($finalHr, 2, '0', STR_PAD_LEFT);
    $result = "$finalHr:$min:$sec$amPm";
	return $result;
}

function humanReadableSize($bytes)
{
	if(is_numeric($bytes)){
		$precision = 2;
		$kilobyte = 1024;
	    	$megabyte = $kilobyte * 1024;
		$gigabyte = $megabyte * 1024;
	    	$terabyte = $gigabyte * 1024;
	   
	    	if ($bytes < $kilobyte) {
			return $bytes . ' B';
	    	} 
		elseif (($bytes >= $kilobyte) && ($bytes < $megabyte)) {
			return round($bytes / $kilobyte, $precision) . ' KB';
	    	} 
		elseif (($bytes >= $megabyte) && ($bytes < $gigabyte)) {
			return round($bytes / $megabyte, $precision) . ' MB';
	    	} 
		elseif (($bytes >= $gigabyte) && ($bytes < $terabyte)) {
			return round($bytes / $gigabyte, $precision) . ' GB';
	    	} 
		elseif ($bytes >= $terabyte) {
			return round($bytes / $terabyte, $precision) . ' TB';
	    	} 
	} else {
		return $bytes;
	}
}
/****************************************************************************************************
* Subroutine Name         : createFullRestoreDir.
* Objective               : Create full restore directory. 
* Added By                : Yogesh Kumar.
******************************************************************************************************/
function createFullRestoreDir($restorePath) {
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;
	GLOBAL $permissionVal;
	
	ini_set('track_errors', 1);
	
	$restoreListFolderPath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/.RestoreList";
	$restoreDir = $restoreListFolderPath.$restorePath;
	
	if (!file_exists($restoreDir)) 
	{
		if(!mkdir($restoreDir, $permissionVal, true))
		{
			 die("Failed to create directory $restoreDir, Reason : $php_errormsg");
			Scheduler::Log("Could not create directory $restoreDir, Reason : $php_errormsg");
			
		}
		else @chmod($restoreDir,$permissionVal);
		
	}
	return $restoreDir;
}
/****************************************************************************************************
* Subroutine Name         : constructRestoreFileName.
* Objective               : Create restore file name.
* Added By                : Basavraj Bennur.
* Modified By             : Yogesh Kumar.
******************************************************************************************************/
function constructRestoreFileName($restorePath, $pageNumber='0')
{	
	$restoreDir = createFullRestoreDir($restorePath);
	$rListPath = $restoreDir."/list_{$pageNumber}.txt";

	return $rListPath;
}

/****************************************************************************************************
* Subroutine Name         : getUserName.
* Objective               : Get current user logged on with IDrive account.
* Added By                : Avinash Kumar.
* Modified				  : Sabin Cheruvattil
******************************************************************************************************/
function getUserName($currentPath = '')
{
	# check username is empty or not in session
	if(trim($_SESSION['userName']) != '') {
		return $_SESSION['userName'];
	}
	
	if($currentPath == '') {
		$currentPath	= getcwd();
	}
	
	# try to find the user name from currentPath
	$needle				= "/" . SERVICE . "/" . USER_PROFILE . "/";
	$tmp				= explode($needle, $currentPath);
	
	if(count($tmp) > 0) {
		$splitPath 		= explode("/" , $tmp[1]);
		return $splitPath[0];
	}
	
	# Following condition needed when it runs from command line[Ex: send mail]
	GLOBAL $userName;
	if($userName != '') {
		return $userName;
	}

	return '';
}
/****************************************************************************************************
* Subroutine Name         : encrypt.
* Objective               : Encryption for password and private key.
* Added By                : Avinash Kumar.
******************************************************************************************************/
function encrypt($arg)                                                                                                               
{                                                                                                                            
   	for($j = 0; $j != strlen($arg); $j++)                                                                                
        {                                                                                                                    
        	$ascPassword[$j] = dechex(ord($arg[$j]));                                                                    
   	}                                                                                                                    
        if(count($ascPassword)>0){
		$ascPasswordStr = implode('-', $ascPassword);                                                                        
		$ascPasswordStr = rand(10,99) . "-" . $ascPasswordStr . "-" . rand(10,99);  
		return $ascPasswordStr; 
	}                                          
}
/****************************************************************************************************
* Subroutine Name         : getLocalServerip.
* Objective               : Get NAS IP Adddress.
* Added By                : Avinash Kumar.
******************************************************************************************************/
function getLocalServerip()
{
	if(isset($_SERVER["SERVER_NAME"]))
		return $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"];
	else 
		return '';
}
                    

/* Added by Senthil (27-Mar-2014) - It may needs to be removed by later */
/*
if(!file_exists($bandwidthFilePath)){
file_put_contents($bandwidthFilePath, '');
}
if(!file_exists($relativeFile)){
file_put_contents($relativeFile, "");
}*/
/* Added by Senthil */
/****************************************************************************************************
* Function Name         : getLogFilesList.
* Objective             : Get Log Files list.
* Added By              : Senthil Pandian
******************************************************************************************************/
function getLogFilesList($jobname){

 GLOBAL $fileNames;
 GLOBAL	$hash;
 GLOBAL $logFilePath;
  
  $jobLogDirPath = $jobname."/LOGS";
  $exp =  explode("/",$jobname);
  $jobname = $exp[count($exp)-1];
  
     if(is_dir($jobLogDirPath)){
	if($dh = opendir($jobLogDirPath))
	{
		while(($file = readdir($dh)) !== false) 
		{
			if (($file === ".") || ($file === "..") || (strpos($file, "_ERRORFILE") !== FALSE) || ($file === "PROGRESS_DETAILS") || ($file === "LOG_DETAILS") || (strpos($file, ".pid") !== FALSE))
				continue;      	
			else
			{
				$absPath = "$jobLogDirPath/$file";
				$fileNames[filemtime($absPath)] = $file;
				$logFilePath[trim($file)] = $absPath;
				$hash[trim($file)] = $jobname;
			}
		}
	
	closedir($dh);
	}
    }
}

/****************************************************************************************************
* Function Name         : getRunningJobLogs.
* Objective             : Get Log Files list which is running.
* Added By              : Senthil Pandian
******************************************************************************************************/
function getRunningJobLogs($jobname){
 GLOBAL $runningJobName;
 GLOBAL $completedJobName;
 GLOBAL $completedJob;
 GLOBAL $runningJob;

  $jobLogDirPath = $jobname."/".LOG_PID_FILE;
  if(file_exists($jobLogDirPath)){
	$runningFile = trim(file_get_contents($jobLogDirPath));	
	$absPath = "$jobname/$runningFile";
	if(strstr($runningFile,"SUCCESS") || strstr($runningFile,"FAILURE") || strstr($runningFile,"ABORTED")){	
		$completedJob[]['jobName'] = $jobname;
		$completedJob[]['path'] = $absPath;
		$completedJob[]['logFile'] = $runningFile;

	} else {
		$runningJob[]['jobName'] = $jobname;
		$runningJob[]['path'] = $absPath;
		$runningJob[]['logFile'] = $runningFile;
	}
  }
}

/****************************************************************************************************
* Function Name         : ordinal_suffix.
* Objective             : Get the suffix of number.
* Added By              : Senthil Pandian
******************************************************************************************************/
function ordinal_suffix($num){
    if($num < 11 || $num > 13){
         switch($num % 10){
            case 1: return 'st';
            case 2: return 'nd';
            case 3: return 'rd';
        }
    }
    return 'th';
}
/****************************************************************************************************
* Function Name         : restartSession.
* Objective             : Restarting session
* Added By              : Senthil Pandian
******************************************************************************************************/
function restartSession(){
	$proxyOption   = isset($_SESSION['proxy_option'])?$_SESSION['proxy_option']:'';
	$ipAddress 	   = isset($_SESSION['ipAddress'])?$_SESSION['ipAddress']:'';
	$port		   = isset($_SESSION['port'])?$_SESSION['port']:'';
	$proxyUserName = isset($_SESSION['proxyUserName'])?$_SESSION['proxyUserName']:'';
	$proxyPassword = isset($_SESSION['proxyPassword'])?$_SESSION['proxyPassword']:'';
	$encryptedToken = $_SESSION['encryptedToken'];
	$nasUserName 	= $_SESSION['nasUserName'];
    $cgiSID 		= $_SESSION['CGI_SID'];
	$serverAddr     = $_SESSION['serverAddr'];
	
  session_destroy();
  session_start();
  
    $_SESSION['validUser'] = true;
	$_SESSION['proxy_option'] = $proxyOption;
	$_SESSION['ipAddress']    = $ipAddress;
	$_SESSION['port']         = $port;
	$_SESSION['proxyUserName']  = $proxyUserName;
	$_SESSION['proxyPassword']  = $proxyPassword;	
	$_SESSION['encryptedToken'] = $encryptedToken;	
	$_SESSION['nasUserName']  	= $nasUserName;	
    $_SESSION['CGI_SID'] 		= $cgiSID;
	$_SESSION['serverAddr']     = $serverAddr;
}

/****************************************************************************************************
* Function Name         : getCurlOutput.
* Objective             : Get response from third party API using cURL
* Added By              : Senthil Pandian
******************************************************************************************************/
function getCurlOutput($path){
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL,$path);
	curl_setopt($ch, CURLOPT_FAILONERROR,1);
	curl_setopt($ch, CURLOPT_TIMEOUT, 60);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION,false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	/* For Proxy - Start*/	
	if(isset($_SESSION['isProxyEnabled']) && $_SESSION['isProxyEnabled']==true){
		//IP & Port
		if(isset($_SESSION['ipAddress']) && !empty($_SESSION['ipAddress'])){
			$proxy = $_SESSION['ipAddress'].":".$_SESSION['port'];
			curl_setopt($ch, CURLOPT_PROXY, $proxy);
		}
		//Username & Password
		if(isset($_SESSION['proxyUserName']) && !empty($_SESSION['proxyUserName'])){
			$proxyauth = $_SESSION['proxyUserName'].":".$_SESSION['proxyPassword'];
			curl_setopt($ch, CURLOPT_PROXYUSERPWD, $proxyauth);
		}
	}
	/* For Proxy - End*/	
	
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$retValue = curl_exec($ch);	
	$server_error  = curl_error($ch);
	curl_close($ch);

	if(trim($server_error) != '') {
		Scheduler::Log("curl_error: " . $server_error );
	}
	
	return $retValue;
}
/****************************************************************************************************
* Function Name         : getLocalSearchResult.
* Objective             : Get local search result from particular page if page/pid.txt exist
* Added By              : Senthil Pandian
******************************************************************************************************/
function getSearchResult($currPage,$pid='',$count=0){
 session_write_close();
 $timeOutCount=20;
 START:
	$arr = array();
	$resArray = array();
	$linesCount = intval(exec('wc -l '.escapeshellarg($currPage).' 2>/dev/null'));
	
	//Checking line count is more than previous call
	$remaining = $linesCount-$count;
	if(($linesCount-$count)>=4){
		$list = file_get_contents($currPage);
		$exp  = explode("\n",$list);
		for($i=$count;$i<$linesCount;$i+=4){
		if(($i+4)>$linesCount){				
				break;
			}
			$expDate = explode(' ',substr(trim($exp[$i+2]), 0, -1)); 
			$dirDate = $expDate[0]." ".ampmTimeFormat($expDate[1]);			
			$resArray[] = array('name'=>rtrim($exp[$i],'/'),'size'=>$exp[$i+1],'date'=>$dirDate,'type'=>$exp[$i+3]);
		}
		$arr[] = 1;
		$arr[] = $i;
		$arr[] = $resArray;
		$arr[] = $linesCount;
		return $arr;
	} 
	
	if($timeOutCount){
		sleep(1);
		$timeOutCount--;
		goto START;		
	} else if(@file_exists($pid)){
		$arr[] = 1;
		$arr[] = $count;
		$arr[] = 0;
		$arr[] = 0;
	}
	else {
		$arr[] = 0;
	}
	return $arr;
}

/****************************************************************************************************
* Function Name         : simple_encrypt
* Objective             : Get encrypted string of key String & actual string which is needs to be secured
* Added By              : Senthil Pandian
******************************************************************************************************/
function simple_encrypt($str,$key) {
	GLOBAL $staticString;
	$keyString = $staticString[$key];
	$encrypted = trim(base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $keyString, $str, MCRYPT_MODE_ECB, mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND))));
	$len = $key+strlen($encrypted);
	$divided = ($len/2);
	
	$first = floor($divided);
	$last  = ($len-$first);
	
	$digit1   = strlen($first);
	$digit2   = strlen($last);
	return $digit1.$first.$encrypted.$last.$digit2;
}
				
/****************************************************************************************************
* Function Name         : simple_decrypt
* Objective             : Get decrypted string of actual string which is needs to be secured using key String
* Added By              : Senthil Pandian
******************************************************************************************************/
function simple_decrypt() {
	GLOBAL $staticString;
	$str    = $_SESSION['encryptedToken'].$_COOKIE['encryptedToken'];
	
	$digit1 = substr($str,0,1);
	$digit2 = substr($str,-1,1);
	$first  = substr($str,1,$digit1);
	$last   = substr($str,-($digit2+1),$digit2);
	$actual = substr($str,$digit1+1);
	$actual = substr($actual,0,strlen($actual)-($digit2+1));
	$key = ($first+$last)-(strlen($actual));
	$keyString = $staticString[$key];
	return trim(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $keyString, base64_decode($actual), MCRYPT_MODE_ECB, mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)));
}
		
/****************************************************************************************************
* Function Name         : encryptAndSaveNasPassword
* Objective             : Encrypt & Save Nas Password in session & cookie
* Added By              : Senthil Pandian
******************************************************************************************************/
function encryptAndSaveNasPassword($nasPassword){
	$encKey = rand(1,1000);
	$encryptedToken = simple_encrypt($nasPassword,$encKey);
	$getLen = strlen($encryptedToken);
	$divided = ($getLen/2);
	$first = floor($divided);
	
	$_SESSION['encryptedToken'] = substr($encryptedToken,0,$first);
	setcookie("encryptedToken", substr($encryptedToken,$first),0);
}		

/****************************************************************************************************
* Function Name         : checkShowHidden
* Objective             : Displaying/hiding the files/folders based on preference settings
* Added By              : Senthil Pandian
******************************************************************************************************/
function checkShowHidden(){
	GLOBAL $excludePartialFilePath;

	if(file_exists($excludePartialFilePath)){
		$excludePartial = file_get_contents($excludePartialFilePath);
		$exp = explode("\n",$excludePartial);
		
		if(trim($exp[0])=="\/."){
			$_SESSION['showHidden']="Hide";
			print "<script>sh='Hide';</script>";
		} 
		else {
			$_SESSION['showHidden']="Show";
			print "<script>sh='Show';</script>";
		}
	} 
	else {
		$_SESSION['showHidden']="Show";
		print "<script>var sh='Show';</script>";	
	} 
	return $_SESSION['showHidden'];
}

/****************************************************************************************************
* Function Name         : showHiddenStatus
* Objective             : Checking the status of show/hidden
* Added By              : Senthil Pandian
******************************************************************************************************/
function showHiddenStatus(){
	GLOBAL $excludePartialFilePath;
	$showHidden = "Show";
	
	if(file_exists($excludePartialFilePath)){
		$excludePartial = file_get_contents($excludePartialFilePath);
		$exp = explode("\n",$excludePartial);
		
		if(trim($exp[0])=="\/.")
			$showHidden = "Hide";
	} 

	return $showHidden;
}

/****************************************************************************************************
* Function Name         : checkAppUpdate
* Objective             : Checking the status of new version
* Added By              : Senthil Pandian
******************************************************************************************************/
function checkAppUpdate() {
  GLOBAL $appUpdateKey;
  GLOBAL $appVersion;
  $currVersion = trim(str_replace("Version","",$appVersion));
  $upgradeCheckURL = VERSION_UPGRADE_CGI_PATH."?appln=".$appUpdateKey."&version=".$currVersion;
  $res = getCurlOutput($upgradeCheckURL);
  return $res;
}
/****************************************************************************************************
* Function Name         : getEVSServerAddr
* Objective             : Getting EVS server address
* Added By              : Senthil Pandian
******************************************************************************************************/
function getEVSServerAddr(){
	$file = Scheduler::$user_dir.SERVER_ADDR_PATH;
	$serverAddr = '';
	
	if(isset($_SESSION['serverAddr'])){
		$serverAddr = $_SESSION['serverAddr'];
    } else if(file_exists($file) && filesize($file)){
		$serverAddr = file_get_contents($file);
		$serverAddr = trim($serverAddr);
		$_SESSION['serverAddr'] = $serverAddr;	
	} else {
		$serverOutput = getServerAddress();
		if($serverOutput[0]){
			$serverAddr = trim($serverOutput[1]);
		}	
		$_SESSION['serverAddr'] = $serverAddr;			
	}
	return $serverAddr;
}
/****************************************************************************************************
* Function Name         : getUsernameFromCwd
* Objective             : Get the username from the current working folder inside idrive/user_profile/
******************************************************************************************************/
function getUsernameFromCwd()
{
		$username = "";
		$cwd = getcwd();
		$cwd_array = explode("/",$cwd);
		$get_key= array_search(USER_PROFILE,$cwd_array);
		
		if($get_key != NULL)
			$username = $cwd_array[$get_key+1];	
			
		return $username;
}

/****************************************************************************************************
* Function Name         : readFileChunkByChunk
* Objective             : Read a file and display its content chunk by chunk
******************************************************************************************************/
function readFileChunkByChunk($filename, $offset = 0, $readCount = 0,$currentPage = "") 
{

    $retry_count = 0;
    $stop = 0;
    $logFileSize = 0;
    
    if($currentPage == "last" && $readCount == 0){
        $resultStatus = getLogStatus($filename);
        clearstatcache();
        $logFileSize = filesize($filename);
        $lastPageChunkSize = $logFileSize%CHUNK_SIZE;
        if($lastPageChunkSize == 0)
            $lastPageChunkSize = CHUNK_SIZE;
            
        if($resultStatus['stop'] == LOG_COMPLETE && $lastPageChunkSize < LAST_LOGPAGE_MIN_CHUNK+100){
            $lastPageChunkSize = LAST_LOGPAGE_MIN_CHUNK+100;
        }
            
        $offset = $logFileSize-$lastPageChunkSize;
        if($offset<0)   
            $offset = 0;
    }
    
    $handle = fopen($filename, "r");
    if ($handle === false) 
         return array("status"=>0,"data"=>"","offset"=>$offset,"stop"=>$stop,"readCount"=>$readCount);
    fseek($handle,$offset);
    
START:       
    $buffer = fread($handle,CHUNK_SIZE);
    if($buffer != FALSE && trim($buffer) != ""){

        if($readCount + strlen($buffer) >= CHUNK_SIZE)
            $stop = CURRENT_LOGPAGE_COMPLETE;
        else{
            $resultStatus = getLogStatus($filename);
            $stop = $resultStatus['stop'];
        }
        
         //remove the first partial line
        if($currentPage == "previous" || $currentPage == "last"){
            $firstNewLinePos = strpos($buffer,"\n");
            if($firstNewLinePos !== false){
	            $buffer = substr($buffer,$firstNewLinePos+1);
	            $offset += $firstNewLinePos+1;
        	}
        }
        
        //remove the last partial line
        if($stop != LOG_COMPLETE && $currentPage != "previous"){  
            $lastNewLinePos = strrpos($buffer,"\n");
            if($lastNewLinePos !== false){
	            $lastNewLinePos++;
	            $buffer = substr($buffer,0,$lastNewLinePos);
            }else $buffer = "";
        }
        
        $offset += strlen($buffer);
        $readCount += strlen($buffer);
        
        //if log file is completed and only little data left to read then read it in this call itself
        if($stop == LOG_COMPLETE && ($currentPage == "next" || $currentPage == "last")){            
            clearstatcache();
            $logFileSize = filesize($filename);
            if($logFileSize - $offset <= LAST_LOGPAGE_MIN_CHUNK){
                $partialBuffer = fread($handle,CHUNK_SIZE);
                $offset += strlen($partialBuffer);
                $readCount += strlen($partialBuffer);
                $buffer = $buffer.$partialBuffer;
            }
        }
    }
    else{
        $buffer = '';
        $resultStatus = getLogStatus($filename);
        $stop = $resultStatus['stop'];
        
        if($stop == LOG_INPROGRESS && $retry_count <= 20 ){
            $retry_count++;
            sleep(1);
            goto START;
        }
    }
    
    fclose($handle);
    return array("status"=>1,"data"=>$buffer,"offset"=>$offset,"stop"=>$stop,"readCount"=>$readCount);
}

/****************************************************************************************************
* Function Name         : checkIfHtaccessExists
* Objective             : Checks for .htaccess file inside working folder if not creates one
******************************************************************************************************/

function checkIfHtaccessExists()
{
		GLOBAL $baseDir;
		GLOBAL $webDir;
		GLOBAL $permissionVal;
		
		$servicePath = Scheduler::$service_dir;
		$htaccess_file = "$baseDir/$webDir/".SERVICE."/.htaccess";

		if(!file_exists($htaccess_file))
		{
			if(!file_exists($servicePath))
				mkdir($servicePath,$permissionVal);
			@chmod($servicePath,$permissionVal);
			
			file_put_contents($htaccess_file,"Deny from all");
			@chmod($htaccess_file, $permissionVal);
		}
}

/****************************************************************************************************
* Function Name         : accountUsage
* Objective             : Calculating % of account usage
* Added By              : Pooja H
******************************************************************************************************/
function accountUsage()
{
	$getQuotaUtfFile = getOperationFile(GETQUOTAOP);
	
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $lineFeed;
	GLOBAL $OutErrorFilePath;

	if(empty($_SESSION['totalQuota']) || !isset($_SESSION['totalQuota'])){
		$_SESSION['totalQuota'] = 0;
		$_SESSION['usedQuota'] = 0;
		$_SESSION['percentQuotaUsed'] = 0;
	}
	
	$errorRedirection = "2>&1";
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$getQuotaUtfFile\"".$whiteSpace.$errorRedirection.$lineFeed;  	
	$commandOutput = `$idevsutilCommandLine`;
	@unlink($getQuotaUtfFile);
	/* update server address if cmd failed due to wrong evs server address. */
	checkErrorAndUpdateServerAddr($OutErrorFilePath);

	$ErrorFilePath = $OutErrorFilePath;
	
	//handling wrong server address error msg 
	$tempErrorFileSize = file_exists($ErrorFilePath)?filesize($ErrorFilePath):0;
	if($tempErrorFileSize > 0){
		$content = file_get_contents($ErrorFilePath);
		updateEvsError();
	}	
	@unlink($ErrorFilePath);

	$totalquota = "";
	$usedquota = "";
	$quotaUsed = "";
	if($commandOutput == "" || stristr($commandOutput,'ERROR'))
		return;

	$p = xml_parser_create();
	xml_parse_into_struct($p, substr($commandOutput, strpos($commandOutput, "<tree")), $values, $index);
	xml_parser_free($p);
			
	$usedquota = $values[0]['attributes']['USEDQUOTA'];
	$totalquota = $values[0]['attributes']['TOTALQUOTA'];

	if($totalquota != "" and $totalquota !='0'){
		if($usedquota != ""){
			$percentQuotaUsed = ($usedquota/$totalquota) * 100;
			if($percentQuotaUsed > 100){
				$percentQuotaUsed = 100;
			}
			$percentQuotaUsed = number_format((float)$percentQuotaUsed, 1, '.', '');
			$totalquota = $totalquota/(1024*1024*1024);
			$usedquota  = $usedquota/(1024*1024*1024);
			$usedquota  = round($usedquota,2);
			$_SESSION['totalQuota'] = empty($totalquota)?'0':$totalquota;
			$_SESSION['usedQuota'] = empty($usedquota)?'0':$usedquota;
			$_SESSION['percentQuotaUsed'] = empty($percentQuotaUsed)?'0':$percentQuotaUsed;
		}
	}
}

/****************************************************************************************************
* Function Name         : updateEvsError
* Objective             : Updating the LOG with error
* Added By              : Pooja H 
******************************************************************************************************/
function updateEvsError($content = "")
{
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;
	GLOBAL $whiteSpace;
	
	//Array for EVS error 
	$evsError = array(SERVER_ERROR,"password mismatch", "quota over limit", "encryption verification failed");
	
	//Array for EVS error message         
	$evsErrorMsg = array("Operation could not be completed. Reason : ".SERVER_ERROR,"Operation could not be completed. Reason : password mismatch", "Operation could not be completed. Reason : quota over limit", "Operation could not be completed. Reason : encryption verification failed");
			
	$getError = $_[0];

	$sizeofevsError = sizeof($evsError);
	for($i = 0; $i <= $sizeofevsError; $i++)
	{
		if(preg_match($evsError[$i],$getError)){
			getServerAddr();
			$evsMsg = $evsErrorMsg[$i];
			scheduler::Log("EVS Error:" . $evsMsg);
			break;
		}
	}
}

/****************************************************************************************************
* Function Name         : getEncrypted
* Objective             : Encrypt the given data using BLOWFISH cipher and mcrypt mode cbc.
* Added By              : Yogesh Kumar
*****************************************************************************************************/
function getEncrypted($data, $privateKey, $iv) {
	$data = base64_encode($data);
	$npc = mcrypt_module_open(MCRYPT_BLOWFISH,'','cbc','');
	mcrypt_generic_init($npc, $privateKey, $iv);
	$encrypted = mcrypt_generic($npc, $data);
	mcrypt_generic_deinit($npc);
	return $encrypted;
}

/****************************************************************************************************
* Function Name         : getDecrypted
* Objective             : Decrypt the given data using BLOWFISH cipher and mcrypt mode cbc.
* Added By              : Yogesh Kumar
*****************************************************************************************************/
function getDecrypted($data, $privateKey, $iv) {
	$npc = mcrypt_module_open(MCRYPT_BLOWFISH,'','cbc','');
	mcrypt_generic_init($npc, $privateKey, $iv);
	$decrypted = base64_decode(mdecrypt_generic($npc, $data));
	mcrypt_generic_deinit($npc);
	return $decrypted;
}

/****************************************************************************************************
* Function Name         : phpRealEscapeString
* Objective             : Escapes special chars in the unescaped strings.
* Added By              : Yogesh Kumar
*****************************************************************************************************/
function phpRealEscapeString($stringValue) {
	if(get_magic_quotes_gpc()) {
		$stringValue = stripcslashes($stringValue);
	}
	return $stringValue;
}

/****************************************************************************************************
* Function Name         : removeDirContent
* Objective             : Remove all directory content.
* Added By              : Sajana 
******************************************************************************************************/
function removeDirContent($directoryPaths)
{
	$stat = exec("rm -rf $directoryPaths");
}


/****************************************************************************************************
* Function Name         : checkIfJobRunning
* Objective             : find the running manual/scheduled archive job and returns on success
* Added By              : Sajana K
******************************************************************************************************/	
function checkIfJobRunning($jobpath)
{	
	GLOBAL $pidPath;
	$directories = glob($jobpath . '*' , GLOB_ONLYDIR);
	for($k=0;$k<count($directories);$k++){
		$pid = $directories[$k]."/".$pidPath;
		if(file_exists($pid))
			@$archiveJobInProgress = 1;
	
	}
	
	if(@$archiveJobInProgress ==1)
		return 1;
	
	return 0;	
}
/*********************************************************************************************************
* Subroutine Name	: fileStatusRemote.
* Objective			: Getting file status from server.
* Added By			: Sajana K.
**********************************************************************************************************/
function fileStatusRemote($operationType, $filesOnly)
{
	GLOBAL $idevsutilBinaryPath;
	GLOBAL $whiteSpace;
	GLOBAL $idevsutilArgument;
	GLOBAL $assignmentOperator;
	GLOBAL $OutErrorFilePath;	
	GLOBAL $OutOutputFilePath;
	GLOBAL $selected_backupset,$permissionVal;
	$pidPathForSearch = Scheduler::$archiveclean_dir.$selected_backupset."/$pidPath";	
	$openedfile = false;
		
	/* to get the php error message in $php_errormsg variable. */
	ini_set('track_errors', 1);			
	
	$deleteUtfFile = getOperationFile($operationType, $filesOnly);		
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$idevsutilArgument.$assignmentOperator."\"$deleteUtfFile\"";	
	system("$idevsutilCommandLine &");
	
	while(!filesize($OutOutputFilePath) and !filesize($OutErrorFilePath)){
		if(!file_exists($pidPathForSearch)){
			Scheduler::Log("Pid file does not exist.");
			goto USER_CANCEL;
		}
		sleep(0.1);
	}	
	
	/* update server address if cmd failed due to wrong evs server address. */
	if(checkErrorAndUpdateServerAddr($OutErrorFilePath)){
		goto USER_CANCEL;
	}
		
	if(!filesize($OutOutputFilePath)){
		Scheduler::Log("Output file is empty.");
		goto USER_CANCEL;
	}
	
	$handle = fopen($OutOutputFilePath, "r");
	$outfile = Scheduler::$archiveclean_dir.$selected_backupset."/".FILESONLY;
	
	file_put_contents($outfile,EVS_SEARCH_HEAD);
	while(1){
		if(!file_exists($pidPathForSearch)){
			Scheduler::Log("Pid file does not exist. Stopping the parsing.");
			fclose($handle);
			goto USER_CANCEL;
		}
		$buffer = fgets($handle);
		
		if(0 === strlen($buffer)){
			if(filesize($OutErrorFilePath)){
				break;
			}
			sleep(WAIT_FOR);
			fseek($handle, 0, 1);		//to clear eof flag
			continue;
		}
				
		$bufferTmp = explode("] [",$buffer);
		if(count($bufferTmp) > 1){
			$status = trim(ltrim($bufferTmp[0],"["));
			$bufferTmp2 = substr(trim($bufferTmp[1]), 0,-1);
			
			if($status == "file exists"){
				file_put_contents($outfile,"[0:00:00] [   000000] [  1] [    -   ] [  0] [$bufferTmp2]"."\n",FILE_APPEND);
				$openedfile = true;
			}
		}
		else{
			if(preg_match('/bytes  received/', $buffer))
				break;
		}
	}
	
	if($openedfile == true)
		file_put_contents($outfile,EVS_FINISH_HEAD,FILE_APPEND);
	
	@chmod($outfile, $permissionVal);
	fclose($handle);
	
USER_CANCEL: 
	if(file_exists($OutErrorFilePath))
		unlink($OutErrorFilePath);
	if(file_exists($OutOutputFilePath))
		unlink($OutOutputFilePath);
	if(file_exists($deleteUtfFile))
		unlink($deleteUtfFile);

return $openedfile;
}

/****************************************************************************************************
* Function Name         : hasReadPermissions
* Objective             : Check the current user has read permissions for the requested file/folder.
* Added By              : Yogesh Kumar
*****************************************************************************************************/
function hasReadPermissions($path) {
	foreach ($_SESSION['shared_folders'] as $sharedFolder) {
		if (substr($path, -1) !== '/') {
			$path .= '/';
		}
		if (strpos($path, $sharedFolder) === 0) {
			return true;
		}
	}
	return false;
}

/****************************************************************************************************
* Function Name         : updateIDriveApp
* Objective             : To call operations.pl with the update url
* Added By              : Pooja Havaldar
*****************************************************************************************************/
function updateIDriveApp() {
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $userName;
	GLOBAL $temp_file,$permissionVal;
	
	file_put_contents($temp_file,UPDATE_APP);
	@chmod($temp_file, $permissionVal);
	$output = perlScriptExecution(OPERATIONSFILE, Scheduler::$user_dir);
	return $output;
}
/***********************************************************************************************************************
* Function Name         : getLogFileEncodedName
* Objective             : Provides the exact and latest log file path with status in encoded form 
**************************************************************************************************************************/
function getUpdatedLogFileName($decodedPath = "")
{

    if(empty($decodedPath))
        return $decodedPath;

    $file_to_read = "";
    if(file_exists($decodedPath)) {
        $file_to_read = $decodedPath;
    } else if(file_exists($decodedPath."_SUCCESS")) {
        $file_to_read = $decodedPath."_SUCCESS";
    } else if(file_exists($decodedPath."_SUCCESS*")) {
        $file_to_read = $decodedPath."_SUCCESS*";
    } else if(file_exists($decodedPath."_ABORTED")) {				
        $file_to_read = $decodedPath."_ABORTED";
    } else if(file_exists($decodedPath."_FAILURE")) {
        $file_to_read = $decodedPath."_FAILURE";
    }
    
    return $file_to_read;
}

/****************************************************************************************************************************
* Function Name         : createOrVerifyOrDeleteLink
* Objective             : create a symbolic link for the log file to be downloaded inside IDrive/Downloads if not exists and
*                         Delete a link if deleteFlag is set 
******************************************************************************************************************************/
function createOrVerifyOrDeleteLink($file,$deleteFlag=0)
{
    GLOBAL $userName;
    $downloadFolder = getWebDirPath()."/".APPDIR."/Downloads/";
    $commandArray = array();
    
    if(!file_exists($downloadFolder) && !$deleteFlag){
        array_push($commandArray,"mkdir -m 777 '".$downloadFolder."'");
    }
     
    $filenameLogPos = strpos($file,"/LOGS/");
    $logName = substr($file,$filenameLogPos+strlen("/LOGS/"));
    $linkName = $userName."_".$logName;
    $downloadlink = $downloadFolder.$linkName;

    if(!is_link($downloadlink) && !$deleteFlag){
        $checkForUnderScore = strpos($logName,"_");
        if($checkForUnderScore)
            $downloadLinkOld = $downloadFolder.$userName."_".substr($logName,0,$checkForUnderScore);
    
        if(is_link($downloadLinkOld))
             array_push($commandArray,"rm -rf '".$downloadLinkOld."'");
         array_push($commandArray,"ln -s '".$file."'  '".$downloadlink."'");
    }
    else if($deleteFlag){
        $downloadLinkOld = substr($downloadlink,0,strrpos($downloadlink,"_"));
        array_push($commandArray,"rm -rf '".$downloadlink."' '".$downloadLinkOld."' ");
    }

    if($commandArray)
    systemCmdExecutionViaPerl($commandArray);
    
    return $linkName;
}

/***********************************************************************************************************************
* Function Name         : getLogStatus
* Objective             : Checks the status of the log file, provides logStatus and stop flag
**************************************************************************************************************************/
function getLogStatus($filename = ""){
    
    $log_file_full_arr = explode("/", $filename);
    $log_details = explode("_", $log_file_full_arr[count($log_file_full_arr) - 1]);
    $logStatus = "";
    if(count($log_details) == 1)
    {
        array_pop($log_file_full_arr);
        array_pop($log_file_full_arr);
        $logPidFile =  implode("/",$log_file_full_arr)."/".LOG_PID_FILE;
        $logStatus = @file_get_contents($logPidFile);
        if($logStatus == $filename)
        {
            $stop = LOG_INPROGRESS;
        }
        else 
            $stop = LOG_COMPLETE;
    }
    else 
        $stop = LOG_COMPLETE;
    
    return array("logStatus"=>$logStatus,"stop"=>$stop);
}

function getCurrentUsername($currentPath)
{ 
	$needle = "/".SERVICE."/".USER_PROFILE."/";
	$tmp = explode($needle,$currentPath);
	
	if(count($tmp)>0){
		$splitPath = explode("/",$tmp[1]);
		return $splitPath[0];
	}
	else
		return 0;
}

/****************************************************************************************************
* Function Name         : addToExcludeList
* Objective             : Add the selected items to excluded list.
* Added By              : Yogesh Kumar
*****************************************************************************************************/
function addToExcludeList($itemName, $itemType, $excludeFullFile) {
	GLOBAL $permissionVal;
	$status       = array();
	$hasChildren  = false;
	$new_item_len = strlen($itemName);
	$exp          = array();

	if (file_exists($excludeFullFile)) {
		$exp = file($excludeFullFile, FILE_IGNORE_NEW_LINES);
		
		#duplicate check 
		$flag_skip = in_array($itemName, $exp);
		if ($flag_skip == true) {
			$status[] = false;
			$status[] = ITEM_ALREADY_EXCLUDED;
			return $status;
		}
		
		$hasParent  = $skipCurrentIndex = false;
		$newItemLen = strlen($itemName);

		if (getOriginalServicePath() == $exp[0])
			$skipCurrentIndex = true;

		// Checking if parent exist for new item OR if child's exist for new item.
		$itemCount = count($exp);
		for($i = 0; $i < $itemCount; $i += 2) {
			if (! $hasChildren) {
				$check_val3       = strpos($itemName, $exp[$i]);
				$exclude_item_len = strlen($exp[$i]);
				$pos              = strpos($itemName, "/", $exclude_item_len);
				if (($check_val3 === 0) && ($pos === $exclude_item_len)) {
					$hasParent = true;
					break;
				}
			}

			if ((! $skipCurrentIndex) && ($itemType == 'folder')) {
				$check_val3 = strpos($exp[$i], $itemName);
				$pos        = strpos($exp[$i], "/", $new_item_len);
				if (($check_val3) === 0 && ($pos === $new_item_len)) {
					unset($exp[$i]);
					unset($exp[($i + 1)]);
					$hasChildren = true;
				}
			}
			else {
				$skipCurrentIndex = false;
			}
		}
		
		if ($hasParent == true) {
			$status[] = false;
			$status[] = ITEM_ALREADY_EXCLUDED;
			return $status;
		}
	}

	if ($hasChildren) {
		$exp[] = $itemName;
		$exp[] = $itemType;
		$filesExcluded = (implode("\n", $exp) . "\n");
		file_put_contents($excludeFullFile, $filesExcluded, LOCK_EX);
	}
	else {
		file_put_contents($excludeFullFile, ($itemName . "\n" . $itemType . "\n"), FILE_APPEND | LOCK_EX);
	}
	unset($_SESSION['fullEntry']);
	@chmod($excludeFullFile, $permissionVal);
	
	$status[] = true;
	$status[] = ITEM_EXCLUDED;
	return $status;
}

/****************************************************************************************************
* Function Name         : getNextScheduledTask
* Objective             : This will calculate the next scheduled task among all jobs
* Added By              : Sabin Cheruvattil
*****************************************************************************************************/
function getNextScheduledTask()
{
	$jobs = Scheduler::ReadJobs();

	$nextSchedule = array();
	foreach($jobs as $jobName => $jobData) {
		if(!isset($jobData['scheduler'])) {
			continue;
		}

		$nsStartingTimeStamp 					= 0;
		switch($jobData['scheduler']['scheduler_selection']) {
			case 'hourly':
				$schedulerStartMin				= $jobData['scheduler']['start_minute'];

				$serverTimeStampNow				= mktime();
				$thisHourSchedulerStartTime		= mktime(date('G'), $schedulerStartMin, 0);
				$nextHourSchedulerStartTime		= mktime(date('G') + 1, $schedulerStartMin, 0);

				# In simple case hourly selection will occur next hour.
				# If minute is selected which is greater than current minute, execution needs to be considered as same hour execution.
				$nsStartingTimeStamp			= (($serverTimeStampNow >= $thisHourSchedulerStartTime)? $nextHourSchedulerStartTime : $thisHourSchedulerStartTime);
				break;
			case 'daily':
				$schedulerStartMin				= $jobData['scheduler']['start_minute'];
				$schedulerStartHour				= (($jobData['scheduler']['start_meridian'] === 'am')? (($jobData['scheduler']['start_hour'] == 12)? 0 : $jobData['scheduler']['start_hour']) : (($jobData['scheduler']['start_hour'] == 12)? $jobData['scheduler']['start_hour'] : ($jobData['scheduler']['start_hour'] + 12)));
				
				$serverTimeStampNow				= mktime();
				$todaySchedulerStartTime		= mktime($schedulerStartHour, $schedulerStartMin, 0);
				$tomorrowSchedulerStartTime		= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n"), date("j") + 1);

				# Daily scheduled tasks in simple case will occur same day.
				# If the scheduled time has already passed, then consider next day schedule.
				$nsStartingTimeStamp			= (($serverTimeStampNow >= $todaySchedulerStartTime)? $tomorrowSchedulerStartTime : $todaySchedulerStartTime);
				break;
			case 'monthly':
				
				$nsStartingTimeStamp			= getMonthlyExecutionTime($jobData);
				break;
			default:
				# If there is no weekday selection, no need to go further
				if(trim($jobData['scheduler']['weekday_selection']) == '') {
					break;
				}
				
				$nsStartingTimeStamp			= getWeeklyExecutionTime($jobData);
				break;
			# switch cases
		}

		if($nsStartingTimeStamp != 0) {
			$nextSchedule[$jobName]['ts']		= $nsStartingTimeStamp;
			$nextSchedule[$jobName]['time']		= date('Y/m/d h:i:s A', $nsStartingTimeStamp);
			$nextSchedule[$jobName]['jobName']	= preg_replace("/^Backup_|^Restore_/", '', $jobName);
			$nextSchedule[$jobName]['jobType']	= $jobData['job_type'];
		}
	}

	if(!empty($nextSchedule)) {
		# Obtain a list of columns
		$schedulerJobNames						= array();
		$schedulerJobNamesWithType				= array();
		$schedulerTimeStamps					= array();
		foreach($nextSchedule as $key => $row) {
		    $schedulerJobNames[$key]  			= $row['jobName'];
		    $schedulerTimeStamps[$key] 			= $row['ts'];
		    $schedulerJobNamesWithType[$key] 	= $key;
		}

		# Sort the data, First by Name then by Schedule
		array_multisort($schedulerTimeStamps, SORT_ASC, SORT_NUMERIC, 
						$schedulerJobNamesWithType, SORT_ASC, SORT_STRING, 
						$schedulerJobNames, SORT_ASC, SORT_STRING, 
						$nextSchedule);
		$nextEvent 								= current($nextSchedule);
		return $nextEvent;
	}
	
	return $nextSchedule;
}

/****************************************************************************************************
* Function Name         : getWeeklyExecutionTime
* Objective             : This will calculate the execution time for weekly schedule
* Added By              : Sabin Cheruvattil
*****************************************************************************************************/
function getWeeklyExecutionTime($jobData)
{
	$schedulerStartMin				= $jobData['scheduler']['start_minute'];
	$schedulerStartHour				= (($jobData['scheduler']['start_meridian'] === 'am')? (($jobData['scheduler']['start_hour'] == 12)? 0 : $jobData['scheduler']['start_hour']) : (($jobData['scheduler']['start_hour'] == 12)? $jobData['scheduler']['start_hour'] : ($jobData['scheduler']['start_hour'] + 12)));
	$schedulerStartDays				= explode(',', str_replace(array('[', ']', '"'), "", strtolower(trim($jobData['scheduler']['weekday_selection']))));
	
	$daysOfWeek						= array('sun' => 0, 'mon' => 1, 'tue' => 2, 'wed' => 3, 'thu' => 4, 'fri' => 5, 'sat' => 6);
	$todayDayOfWeek 				= strtolower(date('D'));

	$nsStartingTimeStamp			= 0;
	$serverTimeStampNow				= mktime();
	$todaySchedulerStartTime		= mktime($schedulerStartHour, $schedulerStartMin, 0);
	
	if(count($schedulerStartDays) == 1) {
		# Single Day Selection: If there is only a single day selection, calculation can be much simpler. 
		# If the same day is selected and the selected time has not passed consider the same day for scheduled task. 
		# Otherwise it will occur next week same day. If same day is not selected for the scheduler consider the day ahead in that week. 
		# If there is no day selected ahead in that week select the day from the beginning of the week and does depends on the scheduler selection.
		
		# check if the selection is for today or not
		if($todayDayOfWeek == $schedulerStartDays[0]) {
			if($todaySchedulerStartTime < $serverTimeStampNow) {
				# Today's execution time already over. Consider the execution for next month
				$nsStartingTimeStamp	= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n"), date("j") + 7);
			} else {
				# This event is going to execute today
				$nsStartingTimeStamp	= $todaySchedulerStartTime;
			}
		} else {
			$nextScheduledDayVal	= $daysOfWeek[$schedulerStartDays[0]];
			$todayScheduledDayVal	= $daysOfWeek[$todayDayOfWeek];

			# calculate the number of days to add for the next execution date
			$daysToAddForNxtSchd	= (($nextScheduledDayVal > $todayScheduledDayVal)? ($nextScheduledDayVal - $todayScheduledDayVal) : (7 - $todayScheduledDayVal + $nextScheduledDayVal));
			# Maximum number of days - todays week day + next selected day 
			# Ex: Execution on Monday[1] and present day is wednesday[3], then: 7 - 3 + 1 = 5 | From wednesday to monday 5 days
			$nsStartingTimeStamp	= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n"), date("j") + $daysToAddForNxtSchd);
		}
	} else {
		# check if this task is good for running today
		if(in_array($todayDayOfWeek, $schedulerStartDays)) {
			# Multiple Selection With Present Day Involved: In this case first needs to consider whether today's execution time is passed or not.
			# If not passed consider today for execution otherwise the next scheduled day.
			# It can come ahead or behind. If it comes ahead consider the day ahead else consider the first selection in the scheduler's weekdays.
			if($todaySchedulerStartTime > $serverTimeStampNow) {
				# This event is going to execute today
				$nsStartingTimeStamp		= $todaySchedulerStartTime;
			} else {
				# Todays exection time already passed
				$todayWeekVal				= $daysOfWeek[$todayDayOfWeek];
				$schdulerTodayWeekIndex		= array_search($todayDayOfWeek, $schedulerStartDays);

				# Consider todays date value as a pivot element and calculate how many days to next scheduled task
				if($schdulerTodayWeekIndex < (count($schedulerStartDays) - 1)) {
					$schedulerNextDay 		= $schedulerStartDays[$schdulerTodayWeekIndex + 1];
					$schedulerNextDayVal 	= $daysOfWeek[$schedulerNextDay];

					$daysToAddForNxtSchd	= $schedulerNextDayVal - $todayWeekVal;
					$nsStartingTimeStamp	= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n"), date("j") + $daysToAddForNxtSchd);
				} else {
					# in this case selected day is ahead in the week and next execution is on some day of the begining of the week
					$schedulerNextDay 		= $schedulerStartDays[0];
					$schedulerNextDayVal 	= $daysOfWeek[$schedulerNextDay];

					$daysToAddForNxtSchd	= 7 - $todayWeekVal + $schedulerNextDayVal;
					$nsStartingTimeStamp	= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n"), date("j") + $daysToAddForNxtSchd);
				}
			}
		} else {
			# Multiple Selection Without Present Day Involved: 
			# This calculation is bit complicated as the next probable day should be found when the next execution will happen. 
			# Consider present day as a pivot element and check for upcoming day.
			# If day ahead is present take that day for execution. It can happen when there may not be any days ahead in the selection list or in that week.
			# In this case consider the scheduler weekday selection's first element becasue that will be the next execution time.
			# Consider hours and minutes in this case as well.
			$todayWeekVal					= $daysOfWeek[$todayDayOfWeek];
			$schedulerLastSelectedDayVal	= $daysOfWeek[$schedulerStartDays[count($schedulerStartDays) - 1]];

			if($todayWeekVal < $schedulerLastSelectedDayVal) {
				# calcualte number of days to next event and add to number of days ahead
				for($i = $todayWeekVal; $i < count($daysOfWeek); $i++) { 
					$schedulerNextDay 			= array_search($i, $daysOfWeek);
					$schedulerSelNextDayKey 	= array_search($schedulerNextDay, $schedulerStartDays);
					
					if($schedulerSelNextDayKey != FALSE) {
						$schedulerNextDayVal 	= $daysOfWeek[$schedulerNextDay];

						$daysToAddForNxtSchd	= $schedulerNextDayVal - $todayWeekVal;
						$nsStartingTimeStamp	= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n"), date("j") + $daysToAddForNxtSchd);
						break;
					}
				}
			} else {
				# scheduled event falls on the beginning of the week
				$schedulerNextDay 		= $schedulerStartDays[0];
				$schedulerNextDayVal 	= $daysOfWeek[$schedulerNextDay];

				$daysToAddForNxtSchd	= 7 - $todayWeekVal + $schedulerNextDayVal;
				$nsStartingTimeStamp	= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n"), date("j") + $daysToAddForNxtSchd);
			}
		}
	}

	return $nsStartingTimeStamp;
}

/****************************************************************************************************
* Function Name         : getMonthlyExecutionTime
* Objective             : This will calculate the execution time for monthly schedule
* Added By              : Sabin Cheruvattil
*****************************************************************************************************/
function getMonthlyExecutionTime($jobData)
{
	$nsStartingTimeStamp 			= 0;

	# Special cases: As we alreay know the selection allows user to select 29-31 for scheduling. 
	# 29-31 is not valid for all the months. In this case need to consider present months maximum number of days and next months possible number of days.
	# If selection exceeds the expected number of days of month, normalize the date selection by considering the max possible number of days in that month.
	# This is applicable in present month calculation and next month calculation.
	$schedulerStartMin				= $jobData['scheduler']['start_minute'];
	$schedulerStartHour				= (($jobData['scheduler']['start_meridian'] === 'am')? (($jobData['scheduler']['start_hour'] == 12)? 0 : $jobData['scheduler']['start_hour']) : (($jobData['scheduler']['start_hour'] == 12)? $jobData['scheduler']['start_hour'] : ($jobData['scheduler']['start_hour'] + 12)));
	$schedulerStartDate				= $jobData['scheduler']['day_of_month'];

	$serverTimeStampNow				= mktime();
	$thisMonthSchedStartTime		= 0;
	$maxDaysInThisMonth				= cal_days_in_month(CAL_GREGORIAN, date('n'), date('Y'));
	
	# Check whther the date selection exceeds this months maximum number of days
	if($schedulerStartDate > $maxDaysInThisMonth) {
		$thisMonthSchedStartTime 	= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n"), $maxDaysInThisMonth);
	} else {
		$thisMonthSchedStartTime	= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n"), $schedulerStartDate);
	}
	
	if($serverTimeStampNow > $thisMonthSchedStartTime) {
		# Check whther the date selection exceeds next months maximum number of days
		$maxDaysInNextMonth			= cal_days_in_month(CAL_GREGORIAN, date('n') + 1, date('Y'));
		if($schedulerStartDate > $maxDaysInNextMonth) {
			$schedulerStartDate		= $maxDaysInNextMonth;
		}

		# Scheduled Time Has Passed: If present month's time has passed consider the next month's time. 
		$nsStartingTimeStamp		= mktime($schedulerStartHour, $schedulerStartMin, 0, date("n") + 1, $schedulerStartDate);
	} else {
		# Scheduled Time Ahead: If time has not passed yet consider the same month's execution date for the scheduler.
		$nsStartingTimeStamp		= $thisMonthSchedStartTime;
	}

	return $nsStartingTimeStamp;
}

/****************************************************************************************************
* Function Name         : migrate
* Objective             : To migrate from older versions to new versions.
* Added By              : Yogesh Kumar
*****************************************************************************************************/
function migrate() {
	GLOBAL $baseDir;
	GLOBAL $webDir;
	GLOBAL $excludeFullFile;
	GLOBAL $permissionVal;
	GLOBAL $userName;
	$excludeFullFilePath = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".EXCLUDE_LIST_FILE;
	$excludeFullFileType = "$baseDir/$webDir/".SERVICE."/".USER_PROFILE."/$userName/".EXCLUDE_LIST_FOR_DISPLAY_FILE;
	if ((! file_exists($excludeFullFile)) &&
		file_exists($excludeFullFilePath) &&
		file_exists($excludeFullFileType)) {
		$excludeArray        = file($excludeFullFilePath, FILE_IGNORE_NEW_LINES);
		$excludeDisplayArray = file($excludeFullFileType, FILE_IGNORE_NEW_LINES);
		$exp = array();
		foreach($excludeArray as $index => $excludeFileName) {
			$exp[] = $excludeFileName;
			$exp[] = substr($excludeDisplayArray[$index], 1, -1);
		}
		$newExp = implode("\n", $exp) . "\n";
		file_put_contents($excludeFullFile, $newExp, LOCK_EX);
		unlink($excludeFullFilePath);
		unlink($excludeFullFileType);
		@chmod($excludeFullFile, $permissionVal);
	}
}

/****************************************************************************************************
* Function Name         : openFile
* Objective             : To create/open the file with proper permissions.
* Added By              : Yogesh Kumar
*****************************************************************************************************/
function openFile($filename) {
	$handle = fopen($filename, 'w');
	if ($handle === FALSE) {
		Scheduler::Log("Failed to create/open $filename");
	}
	else {
		@chmod($filename, $permissionVal);
	}
	return $handle;
}

/****************************************************************************************************
* Function Name         : binaryChk
* Objective             : Check if EVS binary file is compatible with NAS device
* Added By              : Vijay Vinoth
******************************************************************************************************/
function binaryChk()
{	
	GLOBAL $idevsutilBinaryPath;
	$status = TRUE;
	$lines = `$idevsutilBinaryPath -h 2>>/dev/null | wc -l`;
	if($lines < 50)
		$status = FALSE;

	return $status;
}
?>
