<?php
include_once 'path.php';
session_write_close();
if(!isset($_SESSION['validUser']) || $_SESSION['validUser'] !== true) {
	header("Location:../index.php");
	exit;
}

if($_SESSION['validUser'] === true) {
	$itemSelected = isset($_GET['fullPath']) ? $_GET['fullPath'] : ''; 
	$pageid = (isset( $_GET['pageid'] )) ? $_GET['pageid'] : '0';

	if(strpos($itemSelected, "/") !== FALSE) {
		$itemSelected = rtrim($itemSelected, "/"); 
	}

	$fullPath = "$itemSelected/";
	$fullPath = phpRealEscapeString($fullPath);

	if(1 < strlen($fullPath))
	{
		$fullPath = substr($fullPath, 0, -1);
	}	

	$rListPath = constructRestoreFileName($fullPath, $pageid);
	$pidFile = createFullRestoreDir($fullPath);
	$pidFile .= '/'.PID_FILE;
	
	$retryCount = 0;
	$dirFiles = NULL;
RETRY:
	if ( file_exists( $rListPath ) && filesize( $rListPath ) ) {
		$dirFiles = file_get_contents($rListPath);
	} else if ( file_exists( $pidFile ) ) {
		if($retryCount <= 20) {
			++$retryCount;
			sleep(1);
			goto RETRY;
		} else {
			$response = array();
			$response[] = false;
			$response['retry'] = true;
			echo json_encode($response);
			exit;
		}
	}
	else if( $pageid != '0' ) {
		$response = array();
		$response[] = false;
		$response['retry'] = false;
		echo json_encode($response);
		exit;
	}
	else {
		remoteList("$fullPath");
		if (file_exists($pidFile)) unlink($pidFile);
		// If there's a race condition, we might need to send
		// retry flag in response variable.
		exit;
	}

	$dirArrayDefault = json_decode($dirFiles,true);
	ksort($dirArrayDefault);
	$resStatus = true;
	$resHtml = '';
	$countDir = count($dirArrayDefault);

	if($countDir > 0){
	    $fullPath = $fullPath!="/"?"$fullPath/":"$fullPath";
		if(isset($_GET['newRestoreSet'])){
			$fileMenuList = '';
		} else {
			$fileMenuList = '<td class="file_menu_list"></td>';		
		}
		$index=0;
		foreach($dirArrayDefault as $dir=>$property) {
			$dirName = $dir;
			$dir = str_replace('&amp;','&',$dir);
			$dirSize = humanReadableSize($property['size']);			
			$expDate = explode(' ',trim($property['datetime']));
			$dirDate = $expDate[0]." ".ampmTimeFormat($expDate[1]);

			$size[]  = $dirSize;
			$date[]  = $dirDate;
			$fullPathHTML = htmlentities($fullPath.$dirName, ENT_QUOTES);
			$dirName = str_replace('&amp;','&',$dir);
			$dirNameHTML  = htmlentities($dirName, ENT_QUOTES);	

				if($property['type'] == "D") {
					$resHtml .= '<tr class="row_list">';
					$resHtml .= '<td class="file_check">';
					$resHtml .= '<input type="checkbox" id="chk_elements['.$index.']" name="chk_elements['.$index.']" value="'.$fullPathHTML.'">';
					$resHtml .= '<label >folder</label>  </td>';
					$resHtml .= '<td class="cont_heading" title="'.$dirNameHTML.'">';
					$resHtml .= '<a class="getDirList" href="javascript:void(0);" alt="'.$fullPathHTML.'/"><img src="include/images/idq_ico_folder.png"></a>';
					$resHtml .= '<a class="getDirList" href="javascript:void(0);" alt="'.$fullPathHTML.'/"><span>';
					$resHtml .= str_replace(' ','&nbsp;',$dirNameHTML);
					$resHtml .= '</span></a>';
					$resHtml .= '</td>';
					$resHtml .= '<td class="file_size">'.$dirSize.'</td><td class="file_date">'.$dirDate.'</td>';
					$resHtml .= $fileMenuList;
					$resHtml .= '</tr>';
					
					$type[]   = 'folder';

				} else {
					$fileMenuList1 = ($machine=='twotier')?'<td class=""></td>':$fileMenuList;
					$resHtml .= '<tr class="row_list">';
					$resHtml .= '<td class="file_check">';
					$resHtml .= '<input type="checkbox" id="chk_elements['.$index.']" name="chk_elements['.$index.']" value="'.$fullPathHTML.'">'; 
					$resHtml .= '<label >file</label></td>';
					$resHtml .= '<td class="cont_heading" title="'.$dirNameHTML.'"><img src="include/images/idq_ico_file.png" >';
					$resHtml .= '<span>'.str_replace(' ','&nbsp;',$dirNameHTML).'</span></td>';
					$resHtml .= '<td class="file_size">'.$dirSize.'</td><td class="file_date">'.$dirDate.'</td>';
					$resHtml .= $fileMenuList1;
					$resHtml .= '</tr>';
					
					$type[]   = 'file';
				}	
				$index++;
				$dirArray[] = $fullPath.$dir;
	    }
	} else {
	    	$fullPath = $fullPath!="/"?"$fullPath/":"$fullPath";

		$resStatus = false;
		$resHtml   = '<div class="nfiles" style="display:block;">'.NO_FILES.'</div>';		
	}
		if(isset($_GET['fullPath'])) {
		   $resArr[]=$resStatus;
		   $resArr[]=$resHtml;
		   if(!isset($dirArray)) {
			$dirArray = array();
		   }
		   if(!isset($type)) {
			$type = array();
			$size = array();
			$date = array();
		   }
		   $resArr[]= array('url'=>$fullPath,'dir'=>$dirArray,'type'=>$type,'size'=>$size,'date'=>$date);
		   echo json_encode($resArr);		    
		   exit;
		} else {
		   echo $resHtml;
		}
}
?>
