<?php
/**
 * @desc: Helps to sends the error report
 * @author: Sajana
 * @modified: Sabin Cheruvattil - 2016-05-09
 **/
$username			= $argv[1];
include_once 'path.php';
$successBackup		= "Successful Backup";
$successRestore 	= "Successful Restore";

$jobType			= $argv[2];
$job 				= $jobType . $argv[3];
$status 			= $argv[4];
$content 			= $argv[5];

# Add app version to the mail
$content 			.= "\n" . $appVersion;

# get machine based content 
machineBasedContent($machine);
if($argc != 6) {
	$msg = "Argument mismatch.";
}

$jobs		= Scheduler::ReadJobs("cmd", $username);
$host		= Scheduler::GetHost($username);
$job_type	= $jobs[$job]["job_type"];
$scheduler	= $jobs[$job]["scheduler"];

if(isset($scheduler) && isset($scheduler["email_notify"]) && $scheduler["email_notify"] == "on") {
	if(isset($scheduler["notify_option"])) {
		if($scheduler["notify_option"] == "notify_failure" && ($status == $successBackup || $status == $successRestore)) {
			$msg = "Notify only in failure.";
			echo $msg;
			exit;
		}
	} else {
		$msg = "Not subscribed for notification.";
		echo $msg;
		exit;
	}
} else {
	$msg = "Not subscribed for notification.";
	echo $msg;
	exit;
}

$sendto = urlencode(str_replace(";", ",", $scheduler["email"]));
$subject = "Scheduled $job_type Email Notification [$username][$status]";

$userName = $username;
readAccountSettingsFile();

$username 	= urlencode($username);
$password 	= urlencode(base64_decode($_SESSION['password']));
$content  	= urlencode($content); # Encoding the email content
$postFields = "username=$username&password=$password&to_email=$sendto&subject=$subject&content=$content";

$ret = sendCGIMail(SENDMAIL_PATH, $postFields);

$msg = "Email Notification sent to {$sendto}\n";

if($ret['error'] != '') {
	Scheduler::Log("Send Mail Error: {$ret['output']}; Curl error: {$ret['error']}");
}

echo $msg;