
use POSIX;
use constant false => 0;
use constant true => 1;
use constant LOG_FILE_SIZE_LIMIT	=> 1 * 1024 * 1024;
use constant LOG_FILE_MAX_COUNT		=> 5;
my $currentFilePath  = __FILE__;
##################################
#Operation Type                  #
##################################
our $mode = 'release';
our $mail_content = "";
our $backupOp = "Backup";
our $restoreOp = "Restore";
our $validateOp = "Validate";
our $getServerAddressOp = "GetServerAddress";
our $authListOp = "Authlist";
our $configOp = "Config";
our $getQuotaOp = "GetQuota";
our $propertiesOp = "Properties";
our $speedOp = "Speed";
our $createDirOp = "CreateDir";
our $searchOp = "Search";
our $errorRedirection = "2>&1";
our $perlPath = "";
our $psPath = "";
our $pidIdx = "";
our $cronSeparator = "";
our $whiteSpace = " ";
our $assignmentOperator = "=";
our $fileOpenStatus = 0;
our $pathSeparator = "/";
our $idevsutilArgument = "--utf8-cmd";
my $encTypeDir = "";
our $userCancelStr = "Operation could not be completed. Reason : Operation cancelled by User";
our $errorFilePath = undef;
our $outputFilePath = undef;
our $processIdFile = "pid.txt";
our $startIdFile = "StartPid.txt";
our $logPidPath = "logpid.txt";
our $restoreLoc = "/";
our $errmsgNoRetry = "";
our $taskType = "Manual";
our $operationName = "";
our $retrycount = 0;
our $prevFailedCount = 0;
our $separator = "";

our $headerMsg = "";
our $status = "";
our $backupLocation = "";

use constant SERVICE  => "idriveIt";
use constant APPDIR  => "IDrive";
use constant USER_PROFILE  => "user_profile";
use constant CACHE => ".cache";
use constant ARCHIVE_DIR => "Archive";
use constant SEARCH_FOR_RESTORE => 1;
use constant SERVER_ADDR_PATH  => ".serverAddr.txt";
use constant CANCEL_PATH => "cancel.txt";
our $userCancel = CANCEL_PATH;
our $flag;
our $lineFeed = "\n";
our $errStr = "";
our $cancelFlag = false;
our $jobrunningDir = `pwd`;
chomp($jobrunningDir);
our $SERVICE = SERVICE;
our $APPDIR = APPDIR;
our $USER_PROFILE = USER_PROFILE;
our $CACHE = CACHE;
our $ARCHIVE_DIR = ARCHIVE_DIR;
our $StatusFilePath = "./STATUS_FILE";

our $retryinfo = "./retry_info_file";

our $operationsfile ="operations.pl"; 
our $serverError = "unauthorized user";

# Status File Parameters
our @statusFileArray = ( "COUNT_FILES",
						 "SYNC_COUNT_FILES",
						 "FAILED_COUNT_FILES",
						 "FILE_COUNT",
						 "TERMINATION"
					   );

#Array containing the lines read from Account Settings File     
my @linesAccountSettingsFile = ();

#Array containing the lines read from Configuration File        
my @linesConfFile = ();

#Crontab path                   
use constant synologyCronPath => "/etc/crontab";
use constant qnapCronPath => "/etc/config/crontab";
use constant asustorCronPath => "/var/spool/cron/crontabs/root";

#Machine                        
use constant synology => "synology";
use constant qnap => "QNAP";
use constant ASUSTOR => "Asustor";

#Array to hold temporary output file path and temporary error file path           
our @OutErrorFilePaths = ("./output.txt","./error.txt");

#Size of error.txt file                   
our $tempErrorFileSize;

#Array containing the lines read from Status File               
our @linesStatusFile = ();

#EVS error message                       
our $evsMsg = "";

#Array for EVS error                     
our @evsError = (
					"password mismatch",
					"quota over limit",
					"encryption verification failed"
			);

#Array for EVS error message             
our @evsErrorMsg = (
						"Operation could not be completed, Reason : password mismatch",
						"Operation could not be completed, Reason : quota over limit",
						"Operation could not be completed, Reason : encryption verification failed"
				);				

#Array for EVS error message for UI      
our @evsErrorMsgWeb = (
						"Please re-login to your IDrive Account.",
						"Please upgrade your IDrive account.",
						"Please re-login to your IDrive Account."
					);

#Hash to hold the values of arguments to be passed to idevsutil binary
my %hashEvsParameters = ( 
			"SERVERADDRESS" => "--getServerAddress",
			"USERNAME" => "--user",
			"PASSWORD" => "--password-file",                       
			"ENCTYPE" => "--enc-type",
			"PVTKEY" => "--pvt-key",                       
			"VALIDATE" => "--validate",
			"CONFIG" => "--config-account",
			"PROXY" => "--proxy",
			"UTF8CMD" => "--utf8-cmd",
			"ENCODE" => "--encode",
			"FROMFILE" => "--files-from",
			"TYPE" => "--type",
			"BWFILE" => "--bw-file",
			"PROPERTIES" => "--properties",
			"XMLOUTPUT" => "--xml-output",
			"GETQUOTA" => "--get-quota",
			"AUTHLIST" => "--auth-list",
			"SPEED" => "--trf-",
			"OUTPUT" => "--o",
			"ERROR" => "--e",
			"PROGRESS" => "--100percent-progress",
			"QUOTAFROMFILE" => "--quota-fromfile",
			"CREATEDIR" => "--create-dir",
			"SEARCH" => "--search",
			"ADDPROGRESS" => "--add-progress",
			"FILE" => "--file"
);

my $whiteSpace = " ";
my $assignmentOperator = "=";
our $filesConsideredCount = undef;
our $totalFiles = 0;
our $failedFiles = 0;
our $summaryMsg = "";
our $mailSummaryMsg = "";
our $successFiles = 0;
our $syncedFiles = 0;
my $httpuser = `whoami`;

sub getRestoreLocation()
{
	my $restoreFile = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/restore_location.txt";
	my $retVal = 1;
	open RFH, "<", $restoreFile or (traceLog("Unable to open file $restoreFile, Reason:$!", __FILE__, __LINE__) and $retVal=0);
	if($retVal){
		$restoreLoc = <RFH>;
		if("" eq $restoreLoc){
			$restoreLoc = "/";
		}
	}
	return $restoreLoc;
}

#****************************************************************************************************
# Subroutine Name         : readBackupLocation.
# Objective               : Reads the backup location from file
# Added By                : Deepak Chaurasia
#*****************************************************************************************************/
sub readBackupLocation()
{
	$mpcName = "";
	if(-e "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/mpc.txt"){
		open MPC, "<", "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/mpc.txt" or (traceLog("Unable to open file $baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/mpc.txt, Reason:$!", __FILE__, __LINE__) and die);
		$mpcName = <MPC>;
		close MPC;
	}
	elsif("twotier" eq $machine and -e "/mpc.txt"){
		open MPC, "<", "/mpc.txt" or (traceLog("Unable to open file /mpc.txt, Reason:$!", __FILE__, __LINE__) and die);
		$mpcName = <MPC>;
		close MPC;
		$mpcName = "/".$mpcName;
	}
	else{				                                                                        
		$mpcName = `hostname`;
		chomp($mpcName);
	}
	return $mpcName;
}

#****************************************************************************************************
# Subroutine Name         : getVars.
# Objective               : Get machine information from config file. 
# Added By                : Uttam Tiwari.
#*****************************************************************************************************/
sub getVars()
{
	open(CONFIG, (substr($currentFilePath, 0, rindex($currentFilePath, '/')) . '/../.config/config.txt')) or (traceLog("Unable to open config file:$!", __FILE__, __LINE__) and die);
	while (<CONFIG>) {
		my @pair = split(/\s+/,$_);
		if("webDir" eq $pair[0]) {
			$webDir = $pair[1];
		}
		elsif("baseDir" eq $pair[0]) {
			$baseDir = $pair[1];
		}
		elsif("user" eq $pair[0]) {
			$user = $pair[1];
		}
		elsif("machine" eq $pair[0]) {
			$machine = $pair[1];
		}
		elsif("cronCat" eq $pair[0]) {
				$cronCat = $pair[2];
		}
	}
	close CONFIG;
	return ($baseDir,$webDir,$user,$cronCat,$machine);
}

#Get config information                  
our ($baseDir,$webDir,$user,$cronCat,$machine) = getVars();

#setting permission based on machine type.
our $permissionVal = getPermission();
our $host = getHostName();


if($dsmVersionArr[0] =~ m/\"6\"$/){
	$dsmVersion6 = true;
}

if("QNAP" eq $machine){
	$cronSeparator = " ";
    $pidIdx = 2;
    $separator = "/";
}
elsif("synology" eq $machine){
	our $dsmVersion6 = false;
	my $dsmVersionCmdOut = `cat /etc.defaults/VERSION`;
	my @dsmVersionArr = split("\n", $dsmVersionCmdOut);
	chomp($dsmVersionArr[0]);
	
	if($dsmVersionArr[0] =~ m/\"6\"$/){
		$dsmVersion6 = true;
	}
	
	if($dsmVersion6){
		$psPath = "ps -elf";
		$pidIdx = 3;
	}
	else{
		$psPath = "ps -wwwww";
		$pidIdx = 0;
	}
	$cronSeparator = "\t";
    $separator = " ";
}
elsif("twotier" eq $machine){
	$psPath = "ps -wwwww -ax";
	$pidIdx = 0;
	$cronSeparator = "\t";
    $separator = " ";
}
elsif(ASUSTOR eq $machine){
	$psPath = "ps -elf";
	$pidIdx = 0;
	$cronSeparator = " ";
    $separator = " ";
}
else {

	$psPath = "ps -elf";
	$pidIdx = 6;
	$cronSeparator = "\t";
    $separator = " ";
}

#****************************************************************************************************
# Subroutine Name         : getPerlPath.
# Objective               : This subroutine gets the perl path according to machine name
# Modified By             : Pooja Havaldar
#*****************************************************************************************************/
sub getPerlPath()
{
	if("twotier" eq $machine){
		$perlPath = "/usr/pbi/idrive-amd64/bin/perl";
	} else {
		$perlPath = `which perl`;
		chomp($perlPath);
		if($perlPath eq ""){
			if("QNAP" eq $machine){
				$perlPath = "/opt/bin/perl";
			}
			elsif(("synology" eq $machine) or ("netgear" eq $machine) or (ASUSTOR eq $machine)){
				$perlPath = "/usr/bin/perl";
			}
		}
	}
	return $perlPath;
}
our $perlPath = getPerlPath();

#****************************************************************************************************
# Subroutine Name       : getPhpPath.
# Objective             : This function will return full path for PHP based on machine type
# Added By              : Senthil Pandian
#*****************************************************************************************************/
sub getPhpPath()
{
	if("twotier" eq $machine){
		$phpPath = "/usr/pbi/idrive-amd64/bin/php";
	} else {	
		$phpPath = `which php`;
		chomp($phpPath);
		if($phpPath eq ""){
			if("QNAP" eq $machine){
				$phpPath = "/mnt/ext/opt/apache/bin/php";	
			}
			elsif("synology" eq $machine or "netgear" eq $machine){
				$phpPath = "/usr/bin/php";
			}
			elsif(ASUSTOR eq $machine){
				$phpPath = "/usr/builtin/bin/php";
			}
		}
	}
	return $phpPath;	
}
our $phpPath = getPhpPath();

#get user name                           
our $username = "";
$username = getUserName();

#idevsutil binary path
our $idevsutilBinaryPath = "$baseDir/$webDir/$APPDIR/idevsutil_IDrive";

#****************************************************************************************************
# Subroutine Name         : getUserName.
# Objective               : Get currently logged on IDrive user name.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub getUserName()
{	
	if($jobrunningDir =~ m/user_profile/) {
		@arr = split('user_profile/', $jobrunningDir);
		@usrArr = split('/', $arr[1]);
		$username = $usrArr[0];
	}

	return $username;
}

#****************************************************************************************************
# Subroutine Name         : getJobName.
# Objective               : This subroutine gets the current working JobName from job running directory
# Modified By             : Pooja Havaldar
#*****************************************************************************************************/
sub getJobName()
{
	@arr = split($username, $jobrunningDir);
    @JobName = split('/', $arr[1]);
    $JobName = $JobName[2];
	return $JobName;
}

#****************************************************************************************************
# Subroutine Name         : getThrottleValue.
# Objective               : This subroutine gets the Throttle Value
# Modified By             : Pooja Havaldar, Avinash Kumar(13-JUN-2016)
#*****************************************************************************************************/
sub getThrottleValue(){
	my $bandwidthFilePath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.bw.txt";
	my $throttle = 100;
	if(-e $bandwidthFilePath and open(BWFH, "< $bandwidthFilePath")){
		$throttle = <BWFH>;
		close BWFH;
		chomp($throttle);
	}
	
	return $throttle;
}

#****************************************************************************************************
# Subroutine Name         : createLogFiles.
# Objective               : This subroutine creates the Log Directory if not present. It also creates 
#							the Error Log and Output Log files.
# Modified By             : Deepak Chaurasia, Avinash Kumar(02-JUN-2016)
#*****************************************************************************************************/
sub createLogFiles()
{  
    my $logDirectory = $jobrunningDir."/LOGS";
  	if(!-d $logDirectory){
		if(! mkdir $logDirectory){
			traceLog("Unable to create directory $logDirectory, Reason:$!", __FILE__, __LINE__);
			return;
		}
		chmod $permissionVal, $logDirectory;
	}
	
	$currentTime = `date "+%Y-%m-%d %I:%M:%S %p"`;

	chomp($currentTime);
	$outputFilePath = $logDirectory.$pathSeparator.$currentTime.$whiteSpace.$_[0]; 
	$errorFilePath = $jobrunningDir."/ERROR";
	if(!-d $errorFilePath){
		if(! mkdir $errorFilePath){
			traceLog("Unable to create directory $errorFilePath, Reason:$!", __FILE__, __LINE__);
			return;
		}
		chmod $permissionVal, $errorFilePath;
	}
	
}

#****************************************************************************************************
# Subroutine Name         : checkBinaryExists.
# Objective               : This subroutine checks for the existence of idevsutil_IDrive binary and 
#							also if the binary has executable permission.
# Modified By             : Deepak Chaurasia
#*****************************************************************************************************/
sub checkBinaryExists()
{
	if(-f $idevsutilBinaryPath and -x $idevsutilBinaryPath){
		return;
	}
	my $errMsg = "";	
	if(!-f $idevsutilBinaryPath){
		$errMsg = "idevsutil file does not exist in current directory. Please copy idevsutil file to current directory.";
	}
	elsif(!-x $idevsutilBinaryPath){
		$errMsg = "idevsutil file does not have executable permission. Please give it executable permission.";
	}

	if(open(ERRORFILE, ">> $errorFilePath")){
		#autoflush ERRORFILE;
		select((select(ERRORFILE), $| = 1)[0]);
		print ERRORFILE "$errMsg\n";
		close ERRORFILE;
		chmod $permissionVal, $errorFilePath;
	}
	else {
		traceLog("Unable to open file $errorFilePath, Reason:$!", __FILE__, __LINE__);
	}
	
	if(!open(OUTFILE, ">> $outputFilePath")){
		traceLog("Unable to open file $outputFilePath, Reason: $!", __FILE__, __LINE__);
	}
	else {
		print OUTFILE "$errMsg"; 
	}
	appendErrorFileContents();
	unlink($processIdFile);
	exit 1;
}

#*************************************************************************************************************
# Subroutine Name         : configureCron
# Objective               :
# Added By                : 
#**************************************************************************************************************/
sub configureCron()
{
	$retVal = 1;
	if("synology" eq $machine){
		system("/usr/syno/sbin/synoservicectl","--restart","crond");
		# $? perl special variable to collect the error returned by system call
		if($? eq -1){
			system("synoservice","--restart","crond");
		}
	}
	elsif(ASUSTOR eq $machine){
		system("./etc/init.d/S41crond", "stop");	
		system("./etc/init.d/S41crond", "start");	
	}
	else {
		system("/etc/init.d/crond.sh", "restart");
	}
	$retVal = $?;
	$retVal = $retVal >> 8;
	print $retVal;

}

#****************************************************************************************************
# Subroutine Name         : readAccountSettingsFile.
# Objective               : Reads the entire Account Settings File.
# Added By                : Arnab Gupta.
#*****************************************************************************************************/
sub readAccountSettingsFile()
{  
	open ACCOUNT_SETTINGS_FILE, "<", "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/ACCOUNT_SETTINGS_FILE" or (traceLog("Account Settings File does not exist:$!", __FILE__, __LINE__) and die);
	@linesAccountSettingsFile = <ACCOUNT_SETTINGS_FILE>; 
	close ACCOUNT_SETTINGS_FILE;
}

#****************************************************************************************************
# Subroutine Name         : updateServerAddr.
# Objective               : Construction of get-server address evs command and execution.
#			    			Parse the output and update same in Account Setting File.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub updateServerAddr()
{
	my $getServerUtfFile = getOperationFile($getServerAddressOp);
	$idevsutilCommandLine = $idevsutilBinaryPath.$whiteSpace.$hashEvsParameters{UTF8CMD}.$assignmentOperator."\"$getServerUtfFile\"".$whiteSpace.$errorRedirection.$lineFeed;

	my $commandOutput = `$idevsutilCommandLine`;

	unlink($getServerUtfFile);
	
    my $serverAddr = undef;
	parseXMLOutput(\$commandOutput, \$serverAddr, \"cmdUtilityServer");
    
	if($serverAddr ne ""){
		my $sreverAddrPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/".SERVER_ADDR_PATH;
		
		if(!open(SERVERHDL, "> $sreverAddrPath")){
			traceLog("Unable to open file $sreverAddrPath, Reason:$!", __FILE__, __LINE__);
		}
		print SERVERHDL $serverAddr;
		close SERVERHDL;
		chmod $permissionVal, $sreverAddrPath;		
	} else{
		traceLog("Unable to get server address. Reason:$commandOutput", __FILE__, __LINE__);
	}

	return $serverAddr;
}

#****************************************************************************************************
# Subroutine Name         : parseXMLOutput.
# Objective               : Parse evs command output.
# Added By                : Arnab Gupta.
#*****************************************************************************************************/
sub parseXMLOutput()
{
	if(defined ${$_[0]} and ${$_[0]} ne ""){
		if(${$_[0]} =~ m/${$_[2]}/){
			if($' =~ m/"[^"]+"/){
				my $paramVal = $&;
				$paramVal =~ s/^.//;
				$paramVal =~ s/.$//;

				${$_[1]} = $paramVal;
			}
		}
	}
}

#****************************************************************************************************  
# Subroutine Name         : decodePwdPvt                                                         
# Objective               : Decode password and private key.                                                  
# Added By                : Avinash Kumar.                                           
#*****************************************************************************************************/
sub decodePwdPvt()
{
	$arg = $_[0];
	my @hexPvtKeyArr = split('-', $arg);                                                       
	
	shift(@hexPvtKeyArr);                                                                                                      
	pop(@hexPvtKeyArr);
	my $len = @hexPvtKeyArr;
	for(my $i = 0; $i < $len; $i++){
		$hexPvtKeyArr[$i] = chr(hex($hexPvtKeyArr[$i]));
	}	
	$decodeData = join '', @hexPvtKeyArr;
	return $decodeData;
}

#****************************************************************************************************
# Subroutine Name         : createPwdFile.
# Objective               : Create password encrypted file.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub createEncodeFile()
{
	my $data = $_[0];
	my $path = $_[1];
	my $utfFile = "";
	if(-f $path){
		unlink $path;
	}
	$utfFile = getUtf8File($data, $path);
	
	$idevsutilCommandLine = $idevsutilBinaryPath.
	$whiteSpace.$hashEvsParameters{UTF8CMD}.$assignmentOperator."\"$utfFile\"";
	
	my $commandOutput = `$idevsutilCommandLine`;
	unlink $utfFile;
}

#****************************************************************************************************
# Subroutine Name         : getUtf8File.
# Objective               : utf8 encode file creation.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub getUtf8File()
{
	my ($getVal, $encPath) = @_;
	#create utf8 file.	
 	my $utfFile = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/utf8.txt";
  	open FILE, ">", $utfFile or (traceLog("Unable to open file $utfFile for encode file creation, Reason:$!", __FILE__, __LINE__) and die $!);
  	print FILE "--string-encode=$getVal\n";
  	print FILE "--out-file=$encPath";
  	close(FILE);
	chmod $permissionVal, $utfFile;
	return $utfFile;
}

#****************************************************************************************************
# Subroutine Name         : copyError2Trace.
# Objective               : Copy any errors to Trace log that might occur while backup/restore.
# Added By                : Basavaraj Bennur.
# Modified By 			  : Avinash Kumar(02-JUN-2016)
#*****************************************************************************************************/
sub copyError2Trace()
{
	if((-s ${$_[0]})> 0){
		my $cancelData = "SIGTERM";
		my $errorPattern = "unauthorized user";
		if(!open(eHANDLE, "<", ${$_[0]})){
			traceLog("Unable to open file ${$_[0]}, Reason:$!", __FILE__, __LINE__);
			return;
		}
		local $/;
		$content = <eHANDLE>;
		close eHANDLE;
		chomp($content);
		if($content =~ /$cancelData/){
			$cancelFlag = true;
			$errStr = $userCancelStr;
		} # handling wrong server address error message	
		elsif($content =~ m/$errorPattern/){
			updateServerAddr();
		}
		my $tmpErrorPath = $jobrunningDir."/LOGS/"."$_[1]";
		if(!open(IFH, ">> $tmpErrorPath")){
			traceLog("Unable to open $tmpErrorPath Reason : $!", __FILE__, __LINE__);
			return;
		}
		print IFH $content."\n";
		close IFH;
	}
}

#****************************************************************************************************
# Subroutine Name         : updateEvsError
# Objective               : Fill the proper error message corresponding to error type.                                                  
# Added By                : Avinash Kumar.                                           
#*****************************************************************************************************/
sub updateEvsError
{
	my $getError = $_[0];
	my $tmpErrorPath = $_[1];
	for($i = 0; $i <= $#evsError; $i++){
		if($getError =~ /$evsError[$i]/){
			$evsMsg = $evsErrorMsg[$i];
			if(!open(IFH, ">> $tmpErrorPath")){
				traceLog("Unable to open $tmpErrorPath Reason : $!", __FILE__, __LINE__);
				return;
			}
			print IFH $evsErrorMsgWeb[$i]."\n";
			close IFH;
			last;
		}
	}
}

#****************************************************************************************************
# Subroutine Name         : getProxyString.
# Objective               : Reads Account Settings file and returns the proxy details if set or 
#			   				returns empty otherwise.
# Added By                : Basavaraj Bennur.
#*****************************************************************************************************/
sub getProxyString()
{	
	my $proxyPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/ACCOUNT_SETTINGS_FILE";
	if(-e $proxyPath){
			open PROXYHANDLE, "<", $proxyPath or (traceLog("Unable to open file $proxyPath, Reason:$!", __FILE__, __LINE__) and die $!);
			my @tempString = <PROXYHANDLE>;
			my @proxyString;
			my $len  = @tempString;
			for (my $index = 0; $index < $len; $index++){
				if($tempString[$index] =~ m/PROXY = /){
				   @proxyString = split("PROXY = ", $tempString[$index]);
				}        
		   }
		   close PROXYHANDLE;
		   $proxyString[1] =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg; #decode the string which was encoded in php
		   $proxyString[1] =~ s/\R//g;
		   return $proxyString[1];
	}
	return "";
}
#****************************************************************************************************
# Subroutine Name         : getProxyToValidate.
# Objective               : Reads entermediate file returns the proxy details.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub getProxyToValidate()
{
	my $authFilePath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.idriveAuthParams.txt";
	my $proxyData = "";
	my $content = "";
	if(!open(FHP, "< $authFilePath")){
		traceLog("Unable to open file $authFilePath, Reason: $!", __FILE__, __LINE__);
		return $proxyData;
	}
	undef $/;
	$content = <FHP>;
	close FHP;
	@contentArr = split("\n", $content);
	$len = @contentArr;
	if($content =~ /proxy/){
			$proxyData = "\'".$contentArr[$len - 1]."\'".":"."\'".$contentArr[$len - 2]."\'"."@".$contentArr[$len - 3].":".$contentArr[$len - 4];
	}
	$encTypeDir = $contentArr[3];
	return $proxyData;
}

#********************************************************************************************************
# Subroutine Name         : addtionalErrorInfo.
# Objective               : Logs error info into temporay error text file which is displayed in Log page.
# Added By                : Basavaraj Bennur.
#********************************************************************************************************/
sub addtionalErrorInfo()
{	
	my $tmpErrorPath = $jobrunningDir."/ERROR/"."$_[1]";
	open FHERR, ">>", $tmpErrorPath or (traceLog("Unable to open file $tmpErrorPath, Reason: $!", __FILE__, __LINE__) and die);
	print FHERR "${$_[0]}\n";	
	close FHERR;
}

#****************************************************************************************************
# Subroutine Name         : configureAndCommitCron.
# Objective               : Configure and commit crontab.
# Added By                : Uttam Tiwari.
#*****************************************************************************************************/
sub configureAndCommitCron()
{
	my $returnVal = -1;	
	if($machine eq "QNAP"){
		$returnVal = commitCrontabChanges();
		if($returnVal == 0){
			configureCron();
		}
	}
	if($machine eq "synology" || $machine eq ASUSTOR){ 
		configureCron();
	}
}

#*************************************************************************************************************
# Subroutine Name         : commitCrontabChanges
# Objective               : To reflect the changes made in crontab file
# Added By                : 
#**************************************************************************************************************/
sub commitCrontabChanges()
{
	$retVal = 1;
	system("/usr/bin/crontab", "/etc/config/crontab");
	$retVal = $?;
	$retVal = $retVal >> 8;
	print $retVal;
}

#********************************************************************************************************************
# Subroutine Name         : getOperationFile.
# Objective               : Create utf8 file for EVS command respective to operation type(backup/restore/validate...).
# Added By                : Avinash Kumar.
#********************************************************************************************************************/
sub getOperationFile()
{
	my $opType = "";
	my $utfFile = "";
	my $utfValidate = "";	
	my $userPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/";
	my $encPwdPath = $userPath."IDPWD";
	my $encPvtkeyPath = $userPath."IDPVT";
	my $utfPath = $userPath."utf8.txt";
	my $currentDir = `pwd`;
	chomp($currentDir);
	my $bck_res_utf8 = $currentDir."/utf8.txt";
	my $sreverAddrPath = $userPath.SERVER_ADDR_PATH;
	my $proxyString = getProxyString();
	my $RestoresetFile = "./RestoresetFile.txt";
	my $serverAddress = "";
	my $serverAddressOperator = "@";
	my $serverName = "home";
	my $serverNameOperator = "::";
	my $privateEncryptionKey = "private";
	my $encryptionType = "";
	
	my $operationType = $_[0];

	if($operationType ne $getServerAddressOp){
		if(!-e $sreverAddrPath or !-s $sreverAddrPath){
			updateServerAddr();
		}
		
		# get server address
		if(!open(SERVERHDL, "< $sreverAddrPath")){
			traceLog("Unable to open file $sreverAddrPath Reason: $!", __FILE__, __LINE__);
			$serverAddress = updateServerAddr();
		}
		else {
			$serverAddress = <SERVERHDL>;
			close SERVERHDL;
		}
		chomp($serverAddress);
	}
	
	#getParameterValueFromAccountSettingsFile(\"serverAddr",\$serverAddress);
	getParameterValueFromAccountSettingsFile(\"encType",\$encryptionType);
	
	if($operationType eq $validateOp)
	{ 
		my $proxyData = getProxyToValidate();
		open UTF8FILE, ">", $utfPath or (traceLog("Unable to open file $utfPath for validate, Reason:$!", __FILE__, __LINE__) and die);
		$utfFile = $hashEvsParameters{VALIDATE}.$lineFeed.
		           $hashEvsParameters{USERNAME}.$assignmentOperator.$username.$lineFeed.
                           $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed.
			   $hashEvsParameters{PROXY}.$assignmentOperator.$proxyData.$lineFeed.
			   $hashEvsParameters{ENCODE}.$lineFeed;
	}
	elsif($operationType eq $getServerAddressOp)
	{ 
		my $proxyData = "";
		my $authFilePath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.idriveAuthParams.txt";
		if(-e $authFilePath and 0 < -s $authFilePath){
			my $proxyData = getProxyToValidate();		# only this call was there
		}
		
		open UTF8FILE, ">", $utfPath or (traceLog("Unable to open file $utfPath for getServerAddress, Reason:$!", __FILE__, __LINE__) and die);
		$utfFile = $hashEvsParameters{SERVERADDRESS}.$lineFeed.
			   $username.$lineFeed.
			   $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed.
		           $hashEvsParameters{PROXY}.$assignmentOperator.$proxyData.$lineFeed.
			   $hashEvsParameters{ENCODE}.$lineFeed.
			   $hashEvsParameters{ERROR}.$assignmentOperator.$OutErrorFilePaths[1].$lineFeed;
	}
	elsif($operationType eq $configOp)
	{ 
		my $proxyData = getProxyToValidate();
		open UTF8FILE, ">", $utfPath or (traceLog("Unable to open file $utfPath for config, Reason:$!", __FILE__, __LINE__) and die);
		$utfFile = $hashEvsParameters{CONFIG}.$lineFeed.
			   $hashEvsParameters{USERNAME}.$assignmentOperator.$username.$lineFeed.
			   $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed;
		if("Private" eq $encTypeDir){
			$utfFile .= $hashEvsParameters{ENCTYPE}.$assignmentOperator.$privateEncryptionKey.$lineFeed.
   				    $hashEvsParameters{PVTKEY}.$assignmentOperator.$encPvtkeyPath.$lineFeed;
   		}
		else{
			$utfFile .= $hashEvsParameters{ENCTYPE}.$assignmentOperator.$defaultEncryptionKey.$lineFeed;
   		}
		$utfFile .= $hashEvsParameters{PROXY}.$assignmentOperator.$proxyData.$lineFeed.	
			    $hashEvsParameters{ENCODE}.$lineFeed;
	}
	elsif($operationType eq $backupOp)
	{
		my $BackupsetFile = $_[1];
		my $bandwidthFilePath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.bw.txt";
		my $source = $_[3];	
		
		open UTF8FILE, ">", $bck_res_utf8 or (traceLog("Unable to open file $utfPath for backup, Reason:$!", __FILE__, __LINE__) and die);
		$utfFile = $hashEvsParameters{FROMFILE}.$assignmentOperator.$BackupsetFile.$lineFeed.
   			   $hashEvsParameters{BWFILE}.$assignmentOperator.$bandwidthFilePath.$lineFeed.
   			   $hashEvsParameters{TYPE}.$lineFeed.
   			   $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed;
		if($encryptionType =~ m/^$privateEncryptionKey$/i){
			$utfFile .= $hashEvsParameters{PVTKEY}.$assignmentOperator.$encPvtkeyPath.$lineFeed;
		}
		$utfFile .= $hashEvsParameters{PROGRESS}.$lineFeed.
				$hashEvsParameters{ADDPROGRESS}.$lineFeed.
			    $hashEvsParameters{PROXY}.$assignmentOperator.$proxyString.$lineFeed.
    			    $hashEvsParameters{ENCODE}.$lineFeed;
		if($_[2] eq "--no-relative" and $_[3] eq "/"){
			if($_[1] =~ m/_onlyFiles/){
				$utfFile .= "--no-relative".$lineFeed;
			}
		}
		$utfFile .= $hashEvsParameters{OUTPUT}.$assignmentOperator.$OutErrorFilePaths[0].$lineFeed.
			    $hashEvsParameters{ERROR}.$assignmentOperator.$OutErrorFilePaths[1].$lineFeed;
		#if($_[2] ne ""){
			$utfFile .= $source.$lineFeed;
		#}
		#else{
		#	$utfFile .= $pathSeparator.$lineFeed;
		#}
		$utfFile .= $username.$serverAddressOperator.
			    $serverAddress.$serverNameOperator.
			    $serverName.$backupLocation.$pathSeparator.$lineFeed;
		print UTF8FILE $utfFile;
		close UTF8FILE;
		chmod $permissionVal, $bck_res_utf8;
		return $bck_res_utf8;
	}
	elsif($operationType eq $propertiesOp)
		{
			open UTF8FILE, ">", $utfPath or (traceLog("Unable to open file $utfPath for properties, Reason:$!", __FILE__, __LINE__) and die);
			$utfFile = $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed.
				   $hashEvsParameters{PROPERTIES}.$lineFeed.
				   $hashEvsParameters{PROXY}.$assignmentOperator.$proxyString.$lineFeed.
			   	   $hashEvsParameters{ENCODE}.$lineFeed.
				   $hashEvsParameters{ERROR}.$assignmentOperator.$OutErrorFilePaths[1].$lineFeed.
			   	   $username.$serverAddressOperator.
			   	   $serverAddress.$serverNameOperator.
			   	   $serverName;	
		}
	elsif($operationType eq $restoreOp)
		{
			$host = $_[3];
			my $RestoresetFile = $_[1];
   			open UTF8FILE, ">", $bck_res_utf8 or (traceLog("Unable to open file $utfPath for restore, Reason:$!", __FILE__, __LINE__) and die);
			$utfFile = $hashEvsParameters{FROMFILE}.$assignmentOperator.$RestoresetFile.$lineFeed.
	   			   $hashEvsParameters{TYPE}.$lineFeed.
	   			   $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed;
			if($encryptionType =~ m/^$privateEncryptionKey$/i){
				$utfFile .= $hashEvsParameters{PVTKEY}.$assignmentOperator.$encPvtkeyPath.$lineFeed;
			}
			my $restorelocation = getRestoreLocation();
			$utfFile .= $hashEvsParameters{PROGRESS}.$lineFeed.
					$hashEvsParameters{ADDPROGRESS}.$lineFeed.
				    $hashEvsParameters{PROXY}.$assignmentOperator.$proxyString.$lineFeed.
	   			    $hashEvsParameters{ENCODE}.$lineFeed;
			
			if($_[2] eq "--no-relative"){
				$utfFile .= "--no-relative".$lineFeed;
			}
			
	   		$utfFile .= $hashEvsParameters{OUTPUT}.$assignmentOperator.$OutErrorFilePaths[0].$lineFeed.
						$hashEvsParameters{ERROR}.$assignmentOperator.$OutErrorFilePaths[1].$lineFeed.
						$username.$serverAddressOperator.
						$serverAddress.$serverNameOperator.
						$serverName.$host.$lineFeed.
						$restorelocation.$lineFeed;
			print UTF8FILE $utfFile;
			close UTF8FILE;
			chmod $permissionVal, $bck_res_utf8;
			return $bck_res_utf8;
		}
	elsif($operationType eq $getQuotaOp)
		{
			open UTF8FILE, ">", $utfPath or (traceLog("Unable to open file $utfPath for getQuota, Reason:$!", __FILE__, __LINE__) and die);
			$failedOpen = 0;
			open USAGE_HANDLE, "<", "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.statAccountUsage.txt" or $failedOpen = 1;
			$tempTotalQuota = <USAGE_HANDLE>;
			$utfFile = $hashEvsParameters{XMLOUTPUT}.$lineFeed.
				   $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed.
				   $hashEvsParameters{ENCODE}.$lineFeed;
			if(!$failedOpen and $tempTotalQuota != 0 and $tempTotalQuota != ""){			
				$utfFile .= $hashEvsParameters{QUOTAFROMFILE}.$lineFeed;
			}
			else{	   
				$utfFile .= $hashEvsParameters{GETQUOTA}.$lineFeed;
			}
			
			$utfFile .= $hashEvsParameters{PROXY}.$assignmentOperator.$proxyString.$lineFeed.
			$hashEvsParameters{ERROR}.$assignmentOperator.$OutErrorFilePaths[1].$lineFeed.		
			$username.$serverAddressOperator.
			$serverAddress.$serverNameOperator.
			$serverName.$pathSeparator.$lineFeed;

			close USAGE_HANDLE;
		}
	elsif($operationType eq $authListOp)
		{
			open UTF8FILE, ">", $utfPath or (traceLog("Unable to open file $utfPath for auth list, Reason:$!", __FILE__, __LINE__) and die);
			$utfFile = $hashEvsParameters{AUTHLIST}.$lineFeed.
				   $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed.
				   $hashEvsParameters{PROXY}.$assignmentOperator.$proxyString.$lineFeed.
				   $hashEvsParameters{ENCODE}.$lineFeed.
				   $hashEvsParameters{ERROR}.$assignmentOperator.$OutErrorFilePaths[1].$lineFeed.
				   $username.$serverAddressOperator.
				   $serverAddress.$serverNameOperator.
				   $serverName.$pathSeparator;
		}
	elsif($operationType eq $speedOp)
	{
		my $speedPath = "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.speed.txt";
		if(open(SPEEDHANDLE, "< $speedPath")){
			$string = <SPEEDHANDLE>; 
			$string =~ s/\R//g;
			close SPEEDHANDLE;
		}
		else{
			traceLog("Unable to open file $speedPath, Reason:$! $lineFeed", __FILE__, __LINE__) and die;
		}
		open UTF8FILE, ">", $utfPath or (traceLog("Unable to open file $utfPath for speed operation, Reason:$!", __FILE__, __LINE__) and die);
		$utfFile = $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed;
		if($encryptionType =~ m/^$privateEncryptionKey$/i){
			$utfFile .= $hashEvsParameters{PVTKEY}.$assignmentOperator.$encPvtkeyPath.$lineFeed;
		}
		$utfFile .= $hashEvsParameters{SPEED}.$string.$lineFeed.
				$hashEvsParameters{PROXY}.$assignmentOperator.$proxyString.$lineFeed.
				$hashEvsParameters{ENCODE}.$lineFeed.
				$hashEvsParameters{ERROR}.$assignmentOperator.$OutErrorFilePaths[1].$lineFeed.
				$username.$serverAddressOperator.
				$serverAddress.$serverNameOperator.
				$serverName.$lineFeed;
		
	}
	elsif($operationType eq $createDirOp)
	{
		my $proxyData = getProxyToValidate();
		my $serverAddFile = "/$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/".SERVER_ADDR_PATH;
		$dirName = readBackupLocation();
	
		if(!open(FHS, "< $serverAddFile")){
			traceLog("Unable to open file $serverAddFile, Reason: $!", __FILE__, __LINE__);
		}
		$serverAddress = <FHS>;
		close FHS;
		
		open UTF8FILE, ">", $utfPath or (traceLog("Unable to open file $utfPath for createDir, Reason:$!", __FILE__, __LINE__) and die);
		$utfFile = $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed;
		if($encTypeDir eq "Private"){
		   	$utfFile .= $hashEvsParameters{PVTKEY}.$assignmentOperator.$encPvtkeyPath.$lineFeed;
		}				
		$utfFile .= $hashEvsParameters{ENCODE}.$lineFeed.
			   $hashEvsParameters{PROXY}.$assignmentOperator.$proxyData.$lineFeed.
			   $hashEvsParameters{CREATEDIR}.$assignmentOperator.$dirName.$lineFeed.				   
			   $username.$serverAddressOperator.
			   $serverAddress.$serverNameOperator.
			   $serverName.$lineFeed;
	}
	elsif($operationType eq $searchOp)
	{
		$searchUtfPath = "utf8.txt";
		my $searchPatteren = $_[1];
		open UTF8FILE, ">", $searchUtfPath or (traceLog("Unable to open file $searchUtfPath for auth list, Reason:$!", __FILE__, __LINE__) and die);
		$utfFile = $hashEvsParameters{PASSWORD}.$assignmentOperator.$encPwdPath.$lineFeed.
		$hashEvsParameters{PROXY}.$assignmentOperator.$proxyString.$lineFeed.
		$hashEvsParameters{ENCODE}.$lineFeed.
		$hashEvsParameters{OUTPUT}.$assignmentOperator.$OutErrorFilePaths[0].$lineFeed.
		$hashEvsParameters{ERROR}.$assignmentOperator.$OutErrorFilePaths[1].$lineFeed.
		$hashEvsParameters{SEARCH}.$lineFeed;
		# in case of resore search.
		# Note: this should be implement with archive cleanup.
		if($_[2] == SEARCH_FOR_RESTORE){
			$utfFile .= $hashEvsParameters{FILE}.$lineFeed;
			$searchPatteren .= "/*";
		}
		$utfFile .= $username.$serverAddressOperator.
		$serverAddress.$serverNameOperator.
		$serverName.$pathSeparator.$searchPatteren.$lineFeed;
		print UTF8FILE $utfFile;
		close UTF8FILE;
		chmod $permissionVal, $searchUtfPath;
		return $bck_res_utf8;
	}
	else {
		traceLog("Invalid Operation Type For Utf8 File", __FILE__, __LINE__);
	}

	print UTF8FILE $utfFile;
	close UTF8FILE;
	traceLog("$operationType operation has been executed", __FILE__, __LINE__);
	chmod $permissionVal, $utfPath;
	return $utfPath;
}

#****************************************************************************************************
# Subroutine Name         : getHeaderMsg.
# Objective               : This subroutine returns string with machine name, backup type and hidden
#							file information in case of NAS backup and return machine id for vault 
#							backup. Returns machine name or id dependes on NAS or vault restore.
# Modified By             : Avinash Kumar.
#*****************************************************************************************************/
sub getHeaderMsg()
{
	my $header = "";
	my $operationType = $_[0];
	my $hidden = $_[1];
	
	$jobName = getJobName();
	my $throttle = getThrottleValue();
		
	chomp($host);
	if($machine ne "twotier"){
		if($operationName eq "Backup"){
			$header = 	"Backup Type: $operationType$lineFeed"."Show hidden files and folders: $hidden$lineFeed";
		}
		
		if($taskType ne "Manual"){
			$header .= "Schedule $operationName Job: $jobName$lineFeed";
		}	
		
		$header .= 	"Machine Name: $host$lineFeed"."Throttle Value: $throttle$lineFeed";
	}
	else {
		$header = "Machine Id: $host $lineFeed"."Throttle Value: $throttle$lineFeed";
	}
	return $header;
}


#****************************************************************************************************
# Subroutine Name         : appendErrorFileContents
# Objective               : This subroutine appends the contents of the error file to the output file
#							and deletes the error file.
# Modified By             : Deepak Chaurasia
#*****************************************************************************************************/
sub appendErrorFileContents()
{
	$error_dir = $jobrunningDir."/ERROR/";
	my @files_list = getDirList($error_dir);
	$fileopen = 0;
	foreach my $file (@files_list){
		if ( $file eq "." or $file eq "..") {
			next;
		}
		$file = $error_dir.$file;
		if(-s $file > 0){
			if($fileopen == 0){
				$mail_content.="$lineFeed"."_______________________________________________________________________________________";
				$mail_content.="$lineFeed"."|Error Report|"."$lineFeed";
				$mail_content.="_______________________________________________________________________________________$lineFeed";
			}
			$fileopen = 1;
			if(open(ERROR_FILE, "< $file")){
				while(my $line = <ERROR_FILE>){ 
					$mail_content.=$line;
				}
				close ERROR_FILE;
			}
		}
	}		
}

##############################################################################################################
#This subroutine converts the file size of a file which has been backed up/synced into human readable format #                                #
##############################################################################################################
sub convertFileSize()
{
  my $fileSize = $_[0];
  my $fileSpec = "bytes";

  if($fileSize > 1023){
    $fileSize /= 1024;
    $fileSpec = "KB";
  }

  if($fileSize > 1023){
    $fileSize /= 1024;
    $fileSpec = "MB";
  }

  if($fileSize > 1023){
    $fileSize /= 1024;
    $fileSpec = "GB";
  }

  if($fileSize > 1023){
    $fileSize /= 1024;
    $fileSpec = "TB";
  }

  $fileSize = sprintf "%.2f", $fileSize;
  if(0 == ($fileSize - int($fileSize))){
    $fileSize = sprintf("%.0f", $fileSize);
  }
  return $fileSize.$whiteSpace.$fileSpec;
}

#****************************************************************************************************
# Subroutine Name         : errorSendMail
# Objective               : Sends the reason of failed operation via mail to user
# Added By                : Deepak Chaurasia
#*****************************************************************************************************/
sub errorSendMail()
{  
	my $status = "FAILURE";
	my $jobType = $_[0];
	my $content = $_[1];
	my $jobNameForMail = `basename '$jobrunningDir'`;
	chomp($jobNameForMail);
	
	my $cmd_mail = "$phpPath $baseDir/$webDir/$APPDIR/.config/sendmail.php '$username' '$jobType' '$jobNameForMail' '$status' '$content'";
	`$cmd_mail`;
}

#****************************************************************************************************
# Subroutine Name         : getParameterValueFromAccountSettingsFile.
# Objective               : Fetches the value of individual parameters which are specified in the 
#                           Account Settings file.
# Added By                : Arnab Gupta.
#*****************************************************************************************************/
sub getParameterValueFromAccountSettingsFile()
{
	if (!@linesAccountSettingsFile) {
		readAccountSettingsFile();
	}
	
  foreach my $line (@linesAccountSettingsFile)
  {
    if($line =~ m/${$_[0]}/)
    {
      my @keyValuePair = split /=/, $line;
      ${$_[1]} = $keyValuePair[1];
      chomp ${$_[1]};
      ${$_[1]} =~ s/^\s+//;
      ${$_[1]} =~ s/\s+$//;

      last;
    }
  }
}
#****************************************************************************************************
# Subroutine Name         : readStatusFile.
# Objective               : reads the status file 
# Added By                : Deepak Chaurasia
#*****************************************************************************************************/
sub readStatusFile()
{
	if(-f $StatusFilePath and -s $StatusFilePath ){
		if(open(STATUS_FILE, "< $StatusFilePath")){ 
			@linesStatusFile = <STATUS_FILE>;
			close STATUS_FILE;
		}
		else {
			traceLog("Unable to open file $StatusFilePath, Reason:$!", __FILE__, __LINE__);
		}
	}
}

#******************************************************************************************************************
# Subroutine Name         : updateRetryCount.
# Objective               : This subroutine update retry count based on any success bavkup/sync.
# Added By                : Avinash Kumar.
#******************************************************************************************************************/
sub updateRetryCount()
{
	my $curFailedCount = 0;
	getParameterValueFromStatusFile( \$statusFileArray[$_[0]], \$curFailedCount );
		
	if($prevFailedCount == 0 or $curFailedCount < $prevFailedCount){
		$retrycount = 0;
	}
	else {
		$retrycount++;
	}
	
	# assign the latest backuped and synced value to prev.
	$prevFailedCount = $curFailedCount;
}

#****************************************************************************************************
# Subroutine Name         : getParameterValueFromStatusFile.
# Objective               : Fetches the value of individual parameters which are specified in the 
#                           Account Settings file.
# Added By                : Arnab Gupta.
# Modified By			  : Deepak Chaurasia
#*****************************************************************************************************/
sub getParameterValueFromStatusFile()
{
	if ($#linesStatusFile == -1){
		readStatusFile();
	}
	
	if ($#linesStatusFile >= 0){
		foreach my $line (@linesStatusFile)
		{ 
			if($line =~ m/${$_[0]}/)
			{
				my @keyValuePair = split /=/, $line;
				${$_[1]} = $keyValuePair[1];
				chomp ${$_[1]};
	
				${$_[1]} =~ s/^\s+//;
				${$_[1]} =~ s/\s+$//;
	
				last;
			}
			elsif($_[0] eq "" and $line ne ""){
				$errmsgNoRetry = $line; 
			}
		}
	}
	else{
		${$_[1]} = 0;
	}
}

#******************************************************************************************************************************
# Subroutine Name         : getJobTerminationCommand
# Objective               : This function creates the Job Termination command for Backup/Restore/Local Search/Remote Search 
#							depending on machine name
# Added By                : Pooja Havaldar
# Modified By			  : Avinash kumar(02-JUN-2016, Removed return statement from each if block and put to last)
#******************************************************************************************************************************/
sub getJobTerminationCommand()
{
	my $jobPath = $_[1];
	my $jobtype = $_[2];
	my $jobStatusCmd = "";
	
	if($machine eq "QNAP"){
		if($jobtype eq "BACKUP_RESTORE_REMOTESEARCH_CLEANUP"){
			$jobStatusCmd = "grep $jobPath \/proc\/\*\/cmdline" ;
		}
		elsif($jobtype eq "LOCALSEARCH"){
			$jobStatusCmd = "ps | grep find | grep -v 'sh -c'";
			$pidIdx = 0;
			$separator = " ";
		}
		else {
			$jobStatusCmd = "grep \"Delete\" \/proc\/\*\/cmdline";
		}	
	}
	else {
		if($jobtype eq "BACKUP_RESTORE_REMOTESEARCH_CLEANUP"){
			$jobStatusCmd = "$psPath | grep $jobPath | grep idevsutil_IDrive";
		}
		elsif($jobtype eq "LOCALSEARCH"){
			$jobStatusCmd = "$psPath | grep \"find\" | grep $jobPath";
		}
		else {
			$jobStatusCmd = "$psPath | grep Delete";		
		}
	}
	
	return $jobStatusCmd ;
}

#****************************************************************************************************
# Subroutine Name         : getSearchResult
# Objective               : This function search the pattern provided in full NAS machine and returns 
#							the output.
# Added By                : Deepak Chaurasia
#*****************************************************************************************************/
sub getSearchResult() 
{
	my $TotalFindPaths = 10;
	my ($searcharray,$searchDir) = @_;
	my $searchItem = $$searcharray[0];
	$searchItem = quotemeta($searchItem);
	$searchItem =~ s/'/'\\''/g;
	my $OnlySearch = "\'".$searchItem."\'";
	$$searcharray[1] =~ s/'/'\\''/g;
	my $toSearchPath = "\'".$$searcharray[1]."\'";
	my $excludePath = readlink("$baseDir/$webDir");
	my $searchHiddenItem = "";
	
	if($searchItem =~ m/^\\\./){
		$searchHiddenItem = "\'"."$searchItem"."*\'";
	}
	else{
		$searchHiddenItem = "\'."."$searchItem"."*\'";
	}
	
	$searchDir =~ s/'/'\\''/g;
	$searchDir = "\'".$searchDir."\'";
	$searchItem = "\'*"."$searchItem"."*\'";

	my $searcharray_size = @$searcharray;
	if(("synology" eq $machine) or ("netgear" eq $machine) or (ASUSTOR eq $machine)){
	
		my $pattern = "-type d \\( -path $excludePath/$APPDIR -o -path $excludePath/$SERVICE \\) -prune -o -iname $searchItem -print -o -iname $searchHiddenItem -print -o -iname $OnlySearch -print >> $searchDir/output.txt  2>>$searchDir/error.txt;";
		
		my $find = "find ";
		
		for(my $i=1 ; $i<$searcharray_size ; $i++){
			chomp($$searcharray[$i]);
			$find .= "'$$searcharray[$i]' ";
			if($i%$TotalFindPaths == 0){
				$cmd = $find.$pattern;
				
				if(-e $processIdFile){
					`$cmd`;
				}
				else{
					last;
				}
				$find = "find ";
			}		
		}
		
		if($find ne "find "){
			$cmd = $find.$pattern;
			if(-e $processIdFile){
				`$cmd`;
			}
		}
	}
	elsif("QNAP" eq $machine){
	    my $pattern1 = "-name $searchItem >> $searchDir/output.txt  2>>$searchDir/error.txt";
		my $pattern2 = "-name $searchHiddenItem >> $searchDir/output.txt  2>>$searchDir/error.txt";
		my $find = "find ";
		for(my $i=1 ; $i<$searcharray_size ; $i++){
			chomp($$searcharray[$i]);
			$find .= "'$$searcharray[$i]' ";
			if($i%$TotalFindPaths == 0){
				$cmd1 = $find.$pattern1;
			
				if(-e $processIdFile){
					`$cmd1`;
				}
				else{
					
					last;
				}
				
				$cmd2 = $find.$pattern2;
				if(-e $processIdFile){
					`$cmd2`;
				}
				else{
					
					last;
				}
		
				
				$find = "find ";
			}		
		}
		
		if($find ne "find "){
			$cmd1 = $find.$pattern1;
			if(-e $processIdFile){
				`$cmd1`;
			}
		
			$cmd2 = $find.$pattern2;
			if(-e $processIdFile){
				`$cmd2`;
			}	
		}
		
	}
}

##########################################
#This subroutine deletes the Status File #
##########################################
sub removeStatusFile()
{
  unlink $StatusFilePath; 
}

#****************************************************************************************************
# Subroutine Name         : copyTempErrorFile
# Objective               : This subroutine copies the contents of the temporary error file to the 
#							Error File.
# Added By                : 
# Modified By			  : Deepak Chaurasia
#*****************************************************************************************************/
sub copyTempErrorFile()
{
	# if error file is empty then return 
	if(! -s $OutErrorFilePaths[1]){
		return;
	}
	
	#open the error file for read and if open fails then return
	if (! open(TEMP_ERRORFILE, "< $OutErrorFilePaths[1]")){
		traceLog("Unable to open file $OutErrorFilePaths[1], Reason: $!", __FILE__, __LINE__);
		return;
	}
	
	#read error file content 
	my @tempErrorFileContents = ();	
	@tempErrorFileContents = <TEMP_ERRORFILE>;
	close TEMP_ERRORFILE; 
	
	$file = $jobrunningDir."/ERROR/$_[0]";
	#open the App error file and if failed to open then return
	if (! open(ERRORFILE, ">> $file")){     
		traceLog("Unable to open file $file, Reason: $!", __FILE__, __LINE__);
		return;
	}

	#write the content of error file in App error file
	for(my $index = 0; $index <= $#tempErrorFileContents; $index++){
		chomp($tempErrorFileContents[$index]);
		$tempErrorFileContents[$index] =~ s/^\s+|\s+$//g;
		if($tempErrorFileContents[$index] ne ""){
			print ERRORFILE $tempErrorFileContents[$index].$lineFeed;
		}
	}
	chmod $permissionVal, $file;
	close ERRORFILE;
}

#****************************************************************************************************
# Subroutine Name         	: debug_print.
# Objective               	: This subroutine writes log into traceLog.txt for debug purpose only
# Added By             		: Pooja Havaldar
# Modified By 				: Sabin Cheruvattil
#*****************************************************************************************************/
sub debug_print
{
	if($mode ne 'debug') {
		return;
	}
	
	my ($logData, $fileName, $lineNumber) = @_;
	
	traceLog($logData, $fileName, $lineNumber, "SYNXKH#HG");
}

#****************************************************************************************************
# Subroutine Name         : checkIfJobRunning.
# Objective               : This subroutine will check whether jobs are running in particular path
# Modified By             : Pooja Havaldar
#*****************************************************************************************************/
sub checkIfJobRunning()
{
	my @files_list = getDirList($_[0]);
	my $job_flag = 0;
	foreach my $item(@files_list)
	{
		if($item eq "." or $item eq ".."){
			next;
		}
		$item_pidpath = $_[0].$item."/pid.txt";
		if(-e $item_pidpath){
			$job_flag = 1;
			last;
		}
	}
	return $job_flag;
}

#****************************************************************************************************
# Subroutine Name			: traceLog
# Objective					: This subroutine helps to add log
# Added By					: Sabin Cheruvattil - 2016-05-10
# usage						: traceLog("Something goes to log", __FILE__, __LINE__);
#****************************************************************************************************
sub traceLog
{
	my ($logData, $fileName, $lineNumber, $access)	= @_;
	my $traceDir 		= "$baseDir/$webDir/$SERVICE/$USER_PROFILE/$username/.trace";
	my $traceFileName	= "$traceDir/traceLog.txt";
	
	if($mode eq 'debug' and $access ne "SYNXKH#HG") {
		return false;
	}
	
	if(-e $traceFileName) {
		if(-s $traceFileName >= LOG_FILE_SIZE_LIMIT) {
			my $date = time();
			my $tempTrace = $traceFileName . "_" . $date;
			`mv $traceFileName $tempTrace`;
			
			opendir(DIR, $traceDir);
			@files = grep(/traceLog.txt_/, readdir(DIR));
			closedir(DIR);
			
			my $remFileCount = scalar(@files) - LOG_FILE_MAX_COUNT;
			
			while($remFileCount > 0) {
			   unlink "$traceDir/" . pop(@files);
			   $remFileCount--;
			}
			
			writeToTrace($traceFileName, "IDrive Username: " . $username . "\n");
		}
	} else {
		writeToTrace($traceFileName, "IDrive Username: " . $username . "\n");
	}
	
	@fNameArr 			= split("/", $fileName);
	$logContent = "[$fNameArr[-1]][Line: $lineNumber] $logData\n";
	writeToTrace($traceFileName, $logContent);
}

#****************************************************************************************************
# Subroutine Name			: writeToTrace
# Objective					: This subroutine writes to log
# Added By					: Sabin Cheruvattil - 2016-06-01
#****************************************************************************************************
sub writeToTrace
{
	open LOG_TRACE_HANDLE, ">>", $_[0];
	
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime();
	$year		+= 1900;
	$mon		+= 1;
	$mday		= (($mday < 10)? "0" . $mday : $mday);
	$mon		= (($mon < 10)? "0" . $mon : $mon);
	my $date 	= strftime "%Y/%m/%d %H:%M:%S", localtime;
	
	chomp($httpuser);
	$user = $httpuser;
	if((ASUSTOR eq $machine) and ($user eq 'root')){
		$user = 'admin';
	}
	my $logContent = "[$date][$user]". $_[1];
	print LOG_TRACE_HANDLE $logContent;
	close(LOG_TRACE_HANDLE);
}

#****************************************************************************************************
# Subroutine Name         : getPermission.
# Objective               : This subroutine will check the machine and return permission accordingly
# Modified By             : Sajana K
#*****************************************************************************************************/
sub getPermission()
{
	#if(($machine eq 'synology') and ($httpuser eq 'root')){
		#$permission = 0775;
	#}
	#else{
			$permission = 0777;
	#}
		return $permission;
}

#**************************************************************************************************************************
# Subroutine Name         : createPid
# Objective               : This subroutine creates the pid.txt file for Scheduled Backup if it is not already running.
# Added By                : Pooja Havaldar
# Modified By 			  : Avinash Kumar
#**************************************************************************************************************************/
sub createPid()
{
	my $isLocked = false;
	if($taskType eq "Scheduled"){
		# create start id file
		open FHSPID, ">>", $startIdFile or (traceLog("Unable to open file $startIdFile, Reason:$!", __FILE__, __LINE__) and die);
		chmod $permissionVal, $startIdFile;
	}
	else {								# Added by Avinash
		if(-e $startIdFile){
			open FHSPID, ">>", $startIdFile or (traceLog("Unable to open file $startIdFile for lock, Reason:$!", __FILE__, __LINE__) and die);
		}
		else{
			traceLog("Operation could not complete, Reason: $startIdFile is missing", __FILE__, __LINE__);
			exit 0;
		}
	}
	
	flock(FHSPID, 2) or (traceLog("Unable to put lock on $startIdFile, Reason:$!", __FILE__, __LINE__) and $isLocked = true);
	if(!isLocked){
		traceLog("$jobrunningDir job is already running\n", __FILE__, __LINE__);
		exit 0;
	}

	# create process id file
	open FH, ">", $processIdFile or (traceLog("Unable to open file $processIdFile, Reason:$!", __FILE__, __LINE__) and die);
	close FH;
	chmod $permissionVal, $processIdFile;
}

#****************************************************************************************************
# Subroutine Name         : writeOperationSummary
# Objective               : Writes the backup summary to the output file
# Added By                : Arnab Gupta.
# Modified By			  : Pooja Havaldar
#*****************************************************************************************************/
sub writeOperationSummary()
{	
	$filesConsideredCount = $totalFiles;
	
	# open output.txt file to write restore summary.
	if (!open(OUTFILE, ">> $outputFilePath")){ 
		traceLog("Unable to open file $outputFilePath, Reason:$!", __FILE__, __LINE__);
		return;
	}
	
	if($failedFiles > 0){
		appendErrorFileContents();
		$summaryMsg .= $mail_content;
	}
	
	# construct summary message.
	$summaryMsg .= "$lineFeed"."Summary: $lineFeed";
	if($_[0] eq $backupOp){
		$mailSummaryMsg =	"Files considered for backup: $filesConsideredCount $lineFeed".
							"Files backed up now: $successFiles $lineFeed".
							"Files already present in your account: $syncedFiles $lineFeed".
							"Files failed to backup:  $failedFiles $lineFeed";
		$summaryMsg .= "$mailSummaryMsg $lineFeed"."Backup End Time: $whiteSpace".localtime()."$lineFeed";
		$mailSummaryMsg .= "Backup End Time: $whiteSpace".localtime()."$lineFeed";
	}
	else{
		$mailSummaryMsg =	"Files considered for restore: $filesConsideredCount $lineFeed".
							"Files restored now: $successFiles $lineFeed".
							"Files already present: $syncedFiles $lineFeed".
							"Files failed to restore:  $failedFiles $lineFeed";
		$summaryMsg .= "$mailSummaryMsg $lineFeed"."Restore End Time: $whiteSpace".localtime()."$lineFeed";
		$mailSummaryMsg .= "Restore End Time: $whiteSpace".localtime()."$lineFeed";
	}
	
    if("" ne $errStr){
		$mailSummaryMsg .= "$lineFeed$errStr $lineFeed";
		$summaryMsg .= "$lineFeed$errStr $lineFeed";
	}

	print OUTFILE $summaryMsg;
	close OUTFILE;
}

#******************************************************************************************************************
# Subroutine Name         : getOperationStatus
# Objective               : This fills the status of backup/restore operation status e.g SUCCESS, Failure etc.
# Added By                : Pooja Havaldar
# Modified By			  :	Avinash Kumar
#******************************************************************************************************************/
sub getOperationStatus()
{
	if($cancelFlag == true){
		$status = "ABORTED";
	}
	elsif($filesConsideredCount > 0){		# if backup/restore operation has attempted backup/restore for all files
		if($failedFiles == 0){
			$status = "SUCCESS";
		}
		else{
			$status = "FAILURE";
		}
	}
	else{
		$status = "FAILURE";
	}
}

#****************************************************************************************************
# Subroutine Name         : checkLastDayOfMonth.
# Objective               : Check today date is last day of month.
# Added By                : Avinash Kumar.
#*****************************************************************************************************/
sub checkLastDayOfMonth()
{
	my $lastDay = "";
	if("twotier" eq $machine){
		$lastDay = `date -v +1d +%d`;
	}
	elsif("QNAP" eq $machine or "netgear" eq $machine){
		$lastDay = `date +%d -d tomorrow`;
	}
	elsif("synology" eq $machine || ASUSTOR eq $machine){
		my $cmd = 'date -D "%s" -d $(( $(date +%s ) + 86400 )) +%d';
		$lastDay = `$cmd`;
	}
	if(1 == $lastDay){
		return true;
	}
	return false;
}

#*******************************************************************************************************
# Subroutine Name         : checkErrorAndUpdateServerAddr.
# Objective               : Read error.txt file check for server error if found update server address.
# Added By                : Avinash Kumar.
#*******************************************************************************************************/
sub checkErrorAndUpdateServerAddr()
{
	if(-e $_[0] and 0 < -s $_[0]){
		if(!open(EVSERROR, "< $_[0]")){
			traceLog("Unable to open file $_[0], Reason: $!", __FILE__, __LINE__);
			return false;
		}
		$errorContent = <EVSERROR>;
		close EVSERROR;
		if($errorContent =~ m/$serverError/){
			updateServerAddr();
			return true;
		}
	}
	return false;
}

#******************************************************************************************************************
# Subroutine Name         : sendMail.
# Objective               : This subroutine sends a mail to the user in case of successful/cancelled/failed backup
# Added By                : Arnab Gupta
# Modified By 			  : Deepak Chaurasia, Pooja Havaldar
#******************************************************************************************************************/
sub sendMail()
{
    my $content = "";
	my $mailStatus = "";
	if($taskType eq "Manual"){
		return;
	}
	
	chomp($mailSummaryMsg);
	
	$content = "Dear IDriveUser, \n\n";
	$content .= "Ref: User name - $username \n\n";	
	
	if($status eq "SUCCESS"){
		$mailStatus = "Successful $operationName";
	}
	elsif($status eq "ABORTED"){
		$mailStatus = "Cancelled $operationName";
	}
	else{
		$mailStatus = "Failed $operationName";
	}
	
	$content .= $headerMsg.$mailSummaryMsg;


	$content .= "\n\nRegards,\nIDrive Support";
	my $jobNameForMail = `basename '$jobrunningDir'`;
	chomp($jobNameForMail);

	my $jobType = "$operationName"."_";
	my $cmd_mail = "$phpPath $baseDir/$webDir/$APPDIR/.config/sendmail.php '$username' '$jobType' '$jobNameForMail' '$mailStatus' '$content'";
	`$cmd_mail`;
}

#******************************************************************************************************************
# Subroutine Name         : updateLogFileName.
# Objective               : This subroutine renames backup log file and update new name to logpid.txt.
# Added By                : Pooja Havaldar
# Modified By			  : Avinash Kumar
#******************************************************************************************************************/
sub updateLogFileName()
{
	my $newName = ""; 
	
	$newName = $outputFilePath."_$status";
	$res = `mv \"$outputFilePath\" \"$newName\"`;
	$outputFilePath = $newName;

	if(!open FH, ">", $logPidPath){
		traceLog("Unable to open $logPidPath to write, Reason:$!", __FILE__, __LINE__);
		return;
	}
	chmod $permissionVal, $logPidPath;
	print FH $newName;
	close FH;
}
#******************************************************************************************************************
# Subroutine Name         : getSource.
# Objective               : This subroutine return source respective to machine.
# Added By                : Avinash Kumar.
#******************************************************************************************************************/
sub getSource()
{
	my $source = "";
	if("twotier" eq $machine){
		$source = "/BackupData/";
	}
	else {
		$source = "/";
	}
	return $source;
}
#******************************************************************************************************************
# Subroutine Name         : getPrintItem.
# Objective               : This subroutine return path after 1st level in case of twotier.
# Added By                : Avinash Kumar.
#******************************************************************************************************************/
sub getPrintItem()
{
	my $item = $_[0];
	if("twotier" eq $machine){
		$item =~ s/^\/BackupData//;
	}
	return $item;
}
#******************************************************************************************************************
# Subroutine Name         : getHostName.
# Objective               : This subroutine return host name.
# Added By                : Deepak Chaurasia.
#******************************************************************************************************************/
sub getHostName()
{
	my $hostName = "";
	
	if("twotier" eq $machine){
		if(open(MPC, "< /mpc.txt")){
			$hostName = <MPC>;
			close MPC;
		}
		else{
			traceLog("Unable to open file mpc.txt, Reason: $!", __FILE__, __LINE__);
		}
	}
	
	if($hostName eq ""){
		$hostName = `hostname`;
	}
	chomp($hostName);
	return $hostName;
}

#******************************************************************************************************************
# Subroutine Name         : autoUpdateBackupset.
# Objective               : This subroutine is to udpate the default backup set file.
# Added By                : Deepak Chaurasia.
#******************************************************************************************************************/
sub autoUpdateBackupset()
{
	# Call autoUpdateBackupset function to udpate backupset files to
        # sync with the root(/) directory.
	if("twotier" eq $machine){
        	`$phpPath $baseDir/$webDir/$APPDIR/.config/checkDirectories.php`;
	}
}
#******************************************************************************************************************
# Subroutine Name         : idriveStat.
# Objective               : Execute stat command and create array with simillar content as stat api in perl.
# Added By                : Avinash Kumar.
#******************************************************************************************************************/
sub idriveStat()
{
	my $item = "\'$_[0]\'";
	$cmd = "stat -c %F:%Y:%s $item";
	$statRes = `$cmd`;
	my @resultStat = split(':', $statRes);
	return @resultStat;
}

#******************************************************************************************************************
# Subroutine Name         : updateStatusFile.
# Objective               : Read file and made some changes and overwrite to that file.
# Added By                : Avinash Kumar.
#******************************************************************************************************************/
sub updateStatusFile()
{
	my $failedfiles_index = $_[0];
	
	open STATUS_FILE, "+<", "$StatusFilePath" or (traceLog("Unable to open $StatusFilePath, Reason: $!", __FILE__, __LINE__) and return false);
	my @status = <STATUS_FILE>;
	$status[3] = "FILE_COUNT_INDEX = $failedfiles_index \n";
	seek(STATUS_FILE, 0, 0);
	print STATUS_FILE @status;
	close(STATUS_FILE);
	
	return true;
}

#******************************************************************************************************************
# Subroutine Name         : readFromUserCancel.
# Objective               : read cancel.txt to write job cancel message in log
# Added By                : Avinash Kumar.
#******************************************************************************************************************/
sub readFromUserCancel()
{
	my $cancelMsg = "";
	if(-e $userCancel and -s $userCancel){
		if(open(CFH, "< $userCancel")){
			$cancelMsg = <CFH>;
			close CFH;
		}
		else {
			traceLog("Could not open file $userCancel, Reason:$!", __FILE__, __LINE__);
		}
	}
	return $cancelMsg;
}

#******************************************************************************************************************
# Subroutine Name         : getDirList.
# Objective               : get one level listing of particular dir path
# Added By                : Pooja Havaldar
#******************************************************************************************************************/
sub getDirList
{
	opendir(DIR, $_[0]) || traceLog("Unable to open $_[0], Reason:$!", __FILE__, __LINE__);
	@files_list = readdir DIR;
	closedir DIR;
	chomp(@files_list);
	return @files_list;
}
true;
