##################################
#DB related                      #
##################################
my $currentFilePath  = __FILE__;
require substr($currentFilePath, 0, rindex($currentFilePath, '/')) . '/fetchPath.pl';
#use DBI;
use constant false => 0;
use constant true => 1;
our $varManualTask = '\+ManualTask/';
our $driver   = "SQLite";
our $database = "";
our $dsn = "";
our $userid = "";
our $password = "";
our $dbh = undef;
our $databaseLB = "";
our $dsnLB = "";
our $useridLB = "";
our $passwordLB = "";
our $dbh_LB = undef;
our $current_source = "";
our $sth_limit_level;
our $sth_limit;
our $sth;
#our $dbh_insert;
#our $dbh_update;
our $filehandle = 'FILEH';
our %backupExcludeHash = 0;
our @excludeArray;
our $parStr = "";
our $extendedCounter = 0;
our $isExtendedFileOpen = 0;
our $counter = 0;
our $index = 0;
our $partialSyncFlag = 0;
our $syncfilecounter = 0;
our $extendedFileCount = 0;
our $initialCounter = 1;
our $tempfiles = "tempfiles";
our $ExtendedBackupList = $tempfiles."/ExtendedList.txt";
our $parSyncFile = $tempfiles."/PartialSyncFile.txt";
our $isPartialSyncFileOpen = 0;
our $localBackupLocation = "localBackupLocation.txt";
our $LDBNEW = "LDBNEW";
our $LDBName = "IDriveLocalBackup.db";
our $varLocalBackupManualTask = "/$username/LocalBackup/";
our $varLocalRestoreManualTask = "/$username/LocalRestore/";
our $liveConnections = "$webDir/$SERVICE/$USER_PROFILE/$username/liveConnections.txt";

our %table;
our %parSync;
use constant SEARCH_LIMIT => 200;							#6000000
use constant BACKUPARRAY_LIMIT => 50;					#60000
use constant SEARCHLEVEL => 1;
use constant SEARCHALL => 0;
our @BackupArray;
our $readDB = 1;
our $hostNameLB = "";
our $SyncLimit = 10*86400;

our $backupSQLite = "$webDir/$SERVICE/$USER_PROFILE/$username/Backup_SQLite";
our $restoreSQLite = "$webDir/$SERVICE/$USER_PROFILE/$username/Restore_SQLite";
our $quotaSQLite = "$webDir/$SERVICE/$USER_PROFILE/$username/Quota_SQLite";
our $detailsSQLite = "$webDir/$SERVICE/$USER_PROFILE/$username/Details_SQLite";
our $remoteListSQLite = "$webDir/$SERVICE/$USER_PROFILE/$username/RemoteList_SQLite";
our $searchSQLite = "$webDir/$SERVICE/$USER_PROFILE/$username/Search_SQLite";
our @sqliteLockFiles = ($backupSQLite, $restoreSQLite, $quotaSQLite, $detailsSQLite, $remoteListSQLite, $searchSQLite);

if($isLocalBackup != 2 and $isLocalRestore != 2){
	if($isLocalBackup or $isLocalRestore){
		#my $hostNameLB = readLocalBackupLocation;
		$hostNameLB = readLocalBackupLocation();
		$databaseLB = "$hostNameLB/$username/$LDBNEW/$username.ibenc";
	}
	else{
		if($jobDir !~ /$varManualTask/){	
			$taskType = "Scheduled";
			$jobName = getJobName();
			$fileName = "$webDir/$SERVICE/$USER_PROFILE/$username/.popUpList.txt";
			$phpPath = getPhpPath();
			my $cmd_mail = "$phpPath $webDir/$APPDIR/.config/getSchedulerDetails.php '$fileName' 'Backup_$jobName'";
			$res = `$cmd_mail`;
			chomp($res);
			if($res eq "monthly"){
				$SyncLimit = 32*86400;
			}
		}
	}
}

#****************************************************************************************************
# Subroutine Name         : createDB
# Objective               : This function connects to the DB and then calls function to createTable
# Added By                : Pooja Havaldar
# Modified by			  : 	
#*****************************************************************************************************/
sub createDB()
{
	if($machine ne "twotier"){
		return 1;
	}
	$database = "$webDir/$SERVICE/$USER_PROFILE/$username/Backup/IDriveLocal.db";
	$dsn = "DBI:$driver:dbname=$database";
	%attr = ( RaiseError => 1, AutoCommit => 1);
	$dbh = DBI->connect($dsn, $userid, $password, \%attr);
	if(defined $dbh){
		$dbh->do( 'PRAGMA read_uncommitted = on' );
		$dbh->do('PRAGMA case_sensitive_like = 1');
		$dbh->do('PRAGMA journal_mode = wal'); 
		
		if(!createTable()){ 
			return 0;
		} else {
			return 1;
		}		
	}
	else{
		traceLog("\n Error : ".$DBI::errstr, __FILE__, __LINE__);
	}
	return 0;
}

#****************************************************************************************************
# Subroutine Name         : prepareSelectStmt
# Objective               : This function prepares the query to search from DB with limit and offset
# Added By                : Pooja Havaldar
# Modified by			  : 	
#*****************************************************************************************************/
sub prepareSelectStmt()
{
	$sth_limit_level = "";
	$sth_limit = "";
	
	if(defined $dbh){
		$a = SEARCH_LIMIT;
		$sth_limit_level = $dbh->prepare( "SELECT * FROM IDriveLocalTable WHERE FILEPATH LIKE ?  AND LEVELCOUNT = ? LIMIT $a OFFSET ?" );
		$sth_limit = $dbh->prepare( "SELECT * FROM IDriveLocalTable WHERE FILEPATH LIKE ? LIMIT $a OFFSET ?" );
	}
}

#******************************************************************************************************************
# Subroutine Name         : createTable.
# Objective               : This subroutine creates a table in DB only if it already does not exist
# Added By                : Pooja Havaldar
# Modified by			  : 	
#******************************************************************************************************************/
sub createTable
{
	my $stmt = qq(CREATE TABLE IF NOT EXISTS IDriveLocalTable 
       (FILEPATH      TEXT    NOT NULL,
        MOD_DT     	  TIMESTAMP     NOT NULL,
        FILESIZE      INT,
		PRESENTDATE TIMESTAMP default (strftime('%s','now')),
		LEVELCOUNT INT NOT NULL,
		UNIQUE(FILEPATH)););
	
	my $rv = $dbh->do($stmt);
	$dbh->do("CREATE INDEX IF NOT EXISTS IDriveLocalTable_indx on IDriveLocalTable (FILEPATH)");
	
	if($rv < 0){
		traceLog("Create table failed for IDriveLocalTable. Error : ".$DBI::errstr, __FILE__, __LINE__);
		return 0;
	} 
	return 1;
}


#******************************************************************************************************************
# Subroutine Name         : createLBDB.
# Objective               : This subroutine connects to the Local Backup DB and then calls function to createTableLB
# Added By                : Pooja Havaldar
# Modified by			  : Avinash Kumar 	
#******************************************************************************************************************/	
sub createLBDB()
{
	if($machine ne "twotier"){
		return 1;
	}
	# check if complete path is not found then create
	# flag to check DB is already exists or going to create
	# this condition is fesible or let the chmod call for existing right permission also?
	my $baseDirPath = "";
	my $dirPath = substr($databaseLB,0,rindex($databaseLB,'/'));
	
	if(!-e $databaseLB){
		if($! =~ m/Device not configured/){
			$errStr = "Operation could not be completed. Reason:".$!;
			return 0;
		}
		$baseDirPath = substr($databaseLB,0,index($databaseLB,'/',1));
		`mkdir -p \'$dirPath\'`;  #Creating LDBNEW folder & providing permission
	}
	
	$dsnLB = "DBI:$driver:dbname=$databaseLB";
	%attr = ( RaiseError => 1, AutoCommit => 1);
	$dbh_LB = DBI->connect($dsnLB, $useridLB, $passwordLB, \%attr);
	
	if(!defined $dbh_LB){
		$errStr = "Operation could not be completed. Reason: Creation of Local DB failed. ".$DBI::errstr;
		return 0;
	}
	
	$dbh_LB->do( 'PRAGMA read_uncommitted = on' );
	$dbh_LB->do('PRAGMA case_sensitive_like = 1');
	$dbh_LB->do('PRAGMA journal_mode = wal'); 
	
	# if local restore no need to create table
	if($isLocalRestore){
		return 1;
	}
	
	`chmod -R 0777 \'$dirPath\'`;
		if(!createTableLB()){
			return 0;
		}
	
			return 1;
}

#******************************************************************************************************************************
# Subroutine Name         : createTableLB.
# Objective               : This subroutine creates 2 tables - IbFile and IbFolder in DB only if it already does not exist
# Added By                : Pooja Havaldar
# Modified by			  : 	
#******************************************************************************************************************************/
sub createTableLB
{
	my $stmt = qq(CREATE TABLE IF NOT EXISTS ibfolder 
	   (DIRID integer primary key autoincrement,
	    NAME char(1024) not null,
		FILE_LMD char(256),
		FILE_SIZE __int64,
		LEVEL_NO integer DEFAULT 0,
		SYNC_DATE char(50),
		UNIQUE(NAME)););
	
	my $rv = $dbh_LB->do($stmt);
	if($rv < 0){
		$errStr = "Operation could not be completed. Reason: Creation of Local DB failed. ".$dbh_LB::errstr;
		traceLog("\n Create table ibfolder failed : ".$dbh_LB::errstr, __FILE__, __LINE__);
		return 0;
	} 
	$dbh_LB->do("CREATE INDEX IF NOT EXISTS ibfolder_indx on IbFolder (NAME)");
	
	my $stmt = qq(CREATE TABLE IF NOT EXISTS ibfile 
	   (FILEID integer primary key autoincrement,
	    DIRID integer not null,
		NAME char(1024) not null,
		FILE_LMD char(256),
		FILE_SIZE __int64,
		FILE_OR_FOLDER integer DEFAULT 0,
		BKSET_LMD char(50),
		SYNC_DATE char(50),
		BACKUP_STATUS integer DEFAULT 0,
		BKSET_NAME char(50),
		HASH_VALUE __int64,
		THUMB integer DEFAULT 0, 
		FOLDER_ID char(1024),
		MPC char(50),
		ENC_NAME char(1024), 
		foreign key (DIRID) references ibfolder (DIRID),
		UNIQUE(DIRID, NAME)););
		
		
	my $rv = $dbh_LB->do($stmt);
	if($rv < 0){
		$errStr = "Operation could not be completed. Reason: Creation of Local DB failed. ".$dbh_LB::errstr;
		traceLog("\n Create table ibfile failed : ".$dbh_LB::errstr, __FILE__, __LINE__);
		return 0;
	} 
	
	$dbh_LB->do("CREATE INDEX IF NOT EXISTS ibfile_indx on ibfile (NAME)");
	traceLog("\n createTableLB : END", __FILE__, __LINE__);
	return 1;
}

#******************************************************************************************************************
# Subroutine Name         : handle_error.
# Objective               : This subroutine prints all the DB related errors to traceLog
# Added By                : Pooja Havaldar
# Modified by			  : 	
#******************************************************************************************************************/
sub handle_error {
    my $error = shift;
	traceLog("An error occurred in the script\n Message: $error\n", __FILE__, __LINE__);
    return 1;
}

#*******************************************************************************************************************************************************
# Subroutine Name         : set.
# Objective               : This subroutine checks the liveConnections.txt file for current live connections and sets the DB if required
# Added By                : Pooja Havaldar
# Modified by			  : 	
#*******************************************************************************************************************************************************/
sub set
{
	my $operation = $_[0];
	my $res = 'set';
	my $retVal = 0;
	traceLog("set operation : *$operation*", __FILE__, __LINE__);
	open(FHLC, "+< $liveConnections") or (traceLog("\nCannot open $liveConnections file. Reason : $!", __FILE__, __LINE__) and die);
	flock(FHLC, 2) or (traceLog("Could not put lock on $liveConnections file, Reason:$!", __FILE__, __LINE__) and die);
	
	if($databaseLB eq ""){
		$hostNameLB = readLocalBackupLocation();
		$databaseLB = "$hostNameLB/$username/$LDBNEW/$username.ibenc";
	}
		
	if(-e $databaseLB and isNotLocked($operation)){	
		#sqliteldb binary path
		$sqliteBinaryPath = "$webDir/$APPDIR/sqliteldb";
		$cmdSetDB = $sqliteBinaryPath.$whiteSpace.$databaseLB.$whiteSpace."set";
		$res = `$cmdSetDB`;
	chomp($res);
	}
	unlink $operation;
	close FHLC;
	return $res;	
}

#*******************************************************************************************************************************************************
# Subroutine Name         : unset.
# Objective               : This subroutine checks the liveConnections.txt file for current live connections and unsets the DB if required
# Added By                : Pooja Havaldar
# Modified by			  : 	
#*******************************************************************************************************************************************************/
sub unset
{
	my $operation = $_[0];
	traceLog("unset operation : *$operation*", __FILE__, __LINE__);
	my $res = 'unset'; 
	my $retVal = 0;
	if($databaseLB eq ""){
		$hostNameLB = readLocalBackupLocation();
		$databaseLB = "$hostNameLB/$username/$LDBNEW/$username.ibenc";
	}
	
	if(!-e $liveConnections){
		open(FHLC, "> $liveConnections") or (traceLog("\nCannot open $liveConnections file. Reason : $!", __FILE__, __LINE__) and die);
		`chmod 777 $liveConnections`;
		flock(FHLC, 2) or (traceLog("Could not put lock on $liveConnections file, Reason:$!", __FILE__, __LINE__) and die);
	}
	else{
		open(FHLC, "+< $liveConnections") or (traceLog("\nCannot open $liveConnections file. Reason : $!", __FILE__, __LINE__) and die);
		flock(FHLC, 2) or (traceLog("Could not put lock on $liveConnections file, Reason:$!", __FILE__, __LINE__) and die);
	}
	
	if(-e $databaseLB and isNotLocked($operation)){
			#sqliteldb binary path
			$sqliteBinaryPath = "$webDir/$APPDIR/sqliteldb";
			$cmdUnsetDB = $sqliteBinaryPath.$whiteSpace.$databaseLB.$whiteSpace."unset";
			$res = `$cmdUnsetDB`;
	chomp($res);
	}
		
	open(OFH, "> $operation") or (traceLog("\nCannot open $operation file. Reason : $!", __FILE__, __LINE__) and die);
	flock(OFH, 2) or (traceLog("Could not put lock on $operation file, Reason:$!", __FILE__, __LINE__) and die);
	close FHLC;
	return $res;
}

sub isNotLocked
{
	my $ret = 1;
	my $operation = $_[0];
	for(my $i = 0; $i <= $#sqliteLockFiles; $i++){
		$ret = 1;
		if($sqliteLockFiles[$i] eq $operation or !-e $sqliteLockFiles[$i]){
			next;
		}
		open(FH, "+< $sqliteLockFiles[$i]") or (traceLog("\nCannot open $sqliteLockFiles[$i] file. Reason : $!", __FILE__, __LINE__) and die);
		$ret = flock(FH, 2|4) or (traceLog("Could not check lock on $sqliteLockFiles[$i] file, Reason:$!", __FILE__, __LINE__) and die);
		if($ret == 0){			#returns value 0 if lock found
			last;
		}	
		unlink($sqliteLockFiles[$i]);
	}
	return $ret;
}

#******************************************************************************************************************************************
# Subroutine Name         : getSearchResultfromDB
# Objective               : This function executes query to get number of rows in DB with resp. folder name and then calls to searchDB
# Added By                : Pooja Havaldar
# Modified by			  : 	
#******************************************************************************************************************************************/
sub getSearchResultfromDB
{	
	if("twotier" ne $machine){
		return 1;
	}
	
	my $item = $_[0];
	$printItem = getPrintItem($item);
	$hostName = readBackupLocation();
	$searchItem = "$hostName$printItem";
	
	if (substr($searchItem, -1, 1) ne "/"){
		$searchItem .= "/";
	}
	$searchItem = $searchItem.'%';

	if($_[1] == 0){						
		my $rows = $dbh->selectrow_array("SELECT COUNT(*) FROM IDriveLocalTable WHERE FILEPATH LIKE ?", undef, $searchItem);
		if(!$rows){
			return 1;
		}
		#checking if the rows we need to read are within limit if not then we create extended list in place of loading full db results at once
		if($rows > SEARCH_LIMIT){
			if(!getExtendedBackupList($item)){
				traceLog("Could not open new ExtendedList file, for $item.", __FILE__, __LINE__);
				return 0;
			}
			else{
				return 2;
			}
		}
		searchDB($searchItem,$_[1], SEARCHALL);
	}
	else{
		searchDB($searchItem,$_[1], SEARCHLEVEL);
	}
	return 1;
}

#********************************************************************************************************************
# Subroutine Name         : getExtendedBackupList
# Objective               : To enumerate one level and based on that decide whether to create PartialSyncFiles or 
#							append to Backup list and create ExtendedListFiles so that search result is within limit.
# Added By                : Pooja Havaldar
# Modified by			  : 
#********************************************************************************************************************/
sub getExtendedBackupList
{
	$index = 1;
	my $item = $_[0];
	if (substr($item, -1, 1) ne "/"){
		$item .= "/";
	}
	
	if(!opendir(DIR, $item)){
		traceLog("Could not open Dir $item, Reason:$!", __FILE__, __LINE__);
		return 0;
	}
	
	if($isExtendedFileOpen == 0 and !openExtendedBackupList()){
		traceLog("Could not open new ExtendedList file.", __FILE__, __LINE__);
		return 0;
	}
	
	$counter++;
	$newFile = $parSyncFile.$counter.".".$index;
	$isPartialSyncFileOpen = 0;
	createPartialSyncFile($newFile);
	
	$printItem = getPrintItem($item);
#	$hostName = readBackupLocation();
	$searchItem = "$backupLocation$printItem"."%";
	searchDB($searchItem, 0, SEARCHLEVEL);
	
	foreach my $file (readdir(DIR)){
		if(!-e $processIdFile){
			last;
		}
		
		my $temp = $item.$file;
		chomp($temp);
		if ( $file eq "." or $file eq "..") {
			next;
		}
		my $printItem = getPrintItem($temp);
		
		if(-d $temp){
			if(pushEntries($temp)){				#Fill these folder entries in backup array and ExtendedFile list
				next;
			}
		}
		else{
        	if(excludeCheck($temp, $printItem)){
                	next;
        	}

			$totalFiles++;
			if(checkForSync($backupLocation.$printItem, $temp, 1)){
				next;
			}
		
			print BACK_FILE $printItem.$lineFeed;			
			$filecount++;	
			
			if($filecount == FILE_MAX_COUNT){
				if(!createBackupSetFiles1k()){
			last;
		}
	}
		}
	}
	insertHash($item);
	closedir(DIR);
	return 1;
}

#******************************************************************************************************************
# Subroutine Name         : openExtendedBackupList
# Objective               : This subroutine closes the existing file handle for ExtendedListFile and opens a new 
#							extendedlist file with new name
# Added By                : Pooja Havaldar
# Modified by			  : 	
#******************************************************************************************************************/
sub openExtendedBackupList()
{
	if($isExtendedFileOpen){
		close EXTN;
	}
	
	$extendedCounter++;
	$newFile = $ExtendedBackupList.$extendedCounter;
	$isExtendedFileOpen = 1;
	if(!open EXTN, ">", $newFile){
		traceLog("Could not open $newFile to write , Reason:$!", __FILE__, __LINE__);
		$isExtendedFileOpen = 0;
	}
	
	$extendedFileCount = 0;
	return $isExtendedFileOpen;
}

#****************************************************************************************************
# Subroutine Name         : searchDB
# Objective               : This subroutine loads the search result in associative array and if rows 
#							read are less than expected limit then we make db read flag as false as it 
#							means db is read full already.
# Added By                : Pooja Havaldar
# Modified by			  :
#****************************************************************************************************/
sub searchDB
{
	undef %table;
	$a = SEARCH_LIMIT;
	$limit = $a * $_[1];
	if($_[2] == SEARCHLEVEL){
		$sth = $sth_limit_level;
		$levelCount = () = $_[0] =~ /\//g;
		$sth->execute($_[0], $levelCount-1, $limit);
	}
	else{
		$sth = $sth_limit;
		$sth->execute($_[0], $limit);
	}
	
	if($sth eq ""){
		traceLog("DB handle sth is not defined in searchDB function.", __FILE__, __LINE__);
		return;
	}

	my $row;
	
		while($row = $sth->fetchrow_hashref()) {
			$table{$row->{FILEPATH}}{datetime}   = $row->{MOD_DT};				
			$table{$row->{FILEPATH}}{size}  = $row->{FILESIZE};
			$table{$row->{FILEPATH}}{backupdate} = $row->{PRESENTDATE};
		}
	
	$rowsAffected = $sth->rows;
	$sth->finish();	
	if($rowsAffected < SEARCH_LIMIT){
		$readDB = 0;										
	}
}

#************************************************************************************************************************************************
# Subroutine Name         : checkForSync
# Objective               : This subroutine will check if file is present in search result, in sync or not.
# Added By                : Pooja Havaldar
# Modified by			  : 	
#************************************************************************************************************************************************/
sub checkForSync
{
	if("twotier" ne $machine){
		return 0;
	}
	
	$searchFolder = $_[0];
	my $isExistCheck = $_[2];
	
	# check if file does not exist in db result
	if(!exists($table{$searchFolder}{datetime})){
		#if call comes from readRemainingResultsFromDB subroutine then return from function
		if($isExistCheck == 2){																		
			return 2;
		}
		elsif($isExistCheck == 1){
		#If backup array limit is reached then open new partial sync file
		if($syncfilecounter == BACKUPARRAY_LIMIT){
			$index++;
			$newFile = $parSyncFile.$counter.".".$index;
			createPartialSyncFile($newFile);
		}
		
		#Write this file to current partial sync file to sync with remaining db result if possible
		print PARSYNCFILE $_[1]."\n";
		$syncfilecounter++;
		return 1;
	}
		else{
			return 0;
		}	
	}
	
	#checking if current date and last backed up date difference for this file is greater than 10 days. Forcing file for backup again in this case.
	$diff = time - $table{$searchFolder}{backupdate};											
	if($diff > $SyncLimit){																				
		return 0;
	}	
	
	@statResult = stat($_[1]);
	$size = $statResult[7];
	$modtime = $statResult[9];
	
	#checking file in sync based on database result
	if($table{$searchFolder}{datetime} == $modtime and $table{$searchFolder}{size} == $size){
		$bacSync++;
		return 1;
	}
	return 0;
}

#****************************************************************************************************************************************************
# Subroutine Name         : loadExtendedList
# Objective               : This subroutine loads content of ExtendedListFile into BackupArray so that entire backup process can be performed on it.
# Added By                : Pooja Havaldar
# Modified by			  : 	
#****************************************************************************************************************************************************/
sub loadExtendedList
{
	if("twotier" ne $machine){
		return 0;
	}
	
	if($isExtendedFileOpen){
		close EXTN;
		$isExtendedFileOpen = 0;
	}

	for(my $i = $initialCounter; $i <= $extendedCounter; $i++){
		$newFile = $ExtendedBackupList.$i;
		if(!-e $newFile or -s $newFile <= 0){
			next;
		}

		if(!open EXTN, "<", $newFile){
			traceLog("Could not open $newFile to read , Reason:$!", __FILE__, __LINE__);
			next;
		}
		
		undef @BackupArray;
		@BackupArray = <EXTN>;
		close EXTN;
		unlink $newFile;
		$initialCounter++;
		return 1;
	}	
	
	return 0;
}

#****************************************************************************************************************************************************
# Subroutine Name         : pushEntries
# Objective               : This subroutine pushes directory entries into backupArray or to ExtendedListFile based on PartialSyncFlag
# Added By                : Pooja Havaldar
# Modified by			  : 	
#****************************************************************************************************************************************************/
sub pushEntries()
{
	$temp = $_[0];	
	#push the directory entry to array if it is within array limit
	if($extendedFileCount == 0 and $#BackupArray < BACKUPARRAY_LIMIT){							
		push(@BackupArray, $temp);
		return 1;
	}
		
	#open the extended backup set file if limit is reached for backupset array
	if($extendedFileCount == BACKUPARRAY_LIMIT and !openExtendedBackupList()){
		traceLog("Could not open extended backup list file to write , Reason:$!", __FILE__, __LINE__);
		return 0;
	}
	
	#Write to extended list
	print EXTN "$temp\n";
	$extendedFileCount++;
	return 1;
}

#****************************************************************************************************************************************************
# Subroutine Name         : insertHash
# Objective               : This subroutine fills entry of PartialSyncFile name and the number of files created for each directory to hash
# Added By                : Pooja Havaldar
# Modified by			  : 	
#****************************************************************************************************************************************************/
sub insertHash()
{
		$dirName = $_[0];
		if($isPartialSyncFileOpen){
			close PARSYNCFILE;
			$isPartialSyncFileOpen = 0;
		}
		$parSync{$dirName}{partialFileName} = $parSyncFile.$counter;							
		$parSync{$dirName}{indexcount} = $index;
}

#****************************************************************************************************************************************************
# Subroutine Name         : readRemainingResultsFromDB
# Objective               : This subroutine reads remaining results from DB and checks with PartialSyncFiles created and based on that creates more 
#							PartialSyncFiles.
# Added By                : Pooja Havaldar
# Modified by			  : 	
#****************************************************************************************************************************************************/
sub readRemainingResultsFromDB()
{		
	if("twotier" ne $machine){
		return 0;
	}
	my $setEndIndex = "";
	my $matchedCount = 0;
	$isPartialSyncFileOpen = 0;		
	@itemCount = keys %parSync;
	
	#running a loop for all hash items for partial sync
	for(my $i = 0; $i <= $#itemCount; $i++){
		if(!-e $processIdFile){
			last;
		}
		
		$readDB = 1;
		$readCount = 1;

		$item = $itemCount[$i];
		$setEndIndex = $parSync{$item}{indexcount};											#This variable has the count of first set of PartialSyncFiles created before
		$endIndex = $setEndIndex + 1;
		$finalFile = $parSync{$item}{partialFileName}.".".$endIndex;
	
		# create a new partial sync file for unmatched items if db read is still partial
		createPartialSyncFile($finalFile);
		
		# read the db for the limit defined for remaining items
		getSearchResultfromDB($item,$readCount);
		
		# running a loop for loading every partial sync file for current item to check sync based on loaded database result
		for(my $indexCount = 1; $indexCount <= $parSync{$item}{indexcount}; $indexCount++){
			if(!-e $processIdFile){
				last;
			}
	
			#checking if first set of partial files is finished
			if($setEndIndex == $indexCount-1){
				if($syncfilecounter > 0){
					#updating the last index value based on last partial sync file created
					$parSync{$item}{indexcount} = $endIndex;
					$endIndex++;
					$finalFile = $parSync{$item}{partialFileName}.".".$endIndex;
					createPartialSyncFile($finalFile);
				}		
				
				#reading the remaining db items for next set
				if($readDB){
					$readCount++;
					getSearchResultfromDB($item,$readCount);
					$matchedCount = 0;
				
					#resetting the setEndIndex for new set
					$setEndIndex = $parSync{$item}{indexcount};
				}
			}
			
			undef @fileContent ;
			$fileToRead = $parSync{$item}{partialFileName}.".".$indexCount;
			@fileContent = readPartialSyncFile($fileToRead);
			if($#fileContent == -1){
				next;
			}
			# running a loop for sync check for loaded partial sync file items
			foreach(@fileContent){
				$lineContent = $_;
				chomp($lineContent);
				
				# Create a new partial sync file if limit is reached only if we have readDB flag true 
				if($readDB && $syncfilecounter == BACKUPARRAY_LIMIT){
					#updating the last index value based on last partial sync file created
					$parSync{$item}{indexcount} = $endIndex;
					$endIndex++;
					$finalFile = $parSync{$item}{partialFileName}.".".$endIndex;
					createPartialSyncFile($finalFile);
				}
				
				#Update the info file for newly created backup set file. Also open a new backup set file
				if($filecount == FILE_MAX_COUNT){
					if(!createBackupSetFiles1k()){
						last;
					}
				}
	
				$printItem = getPrintItem($lineContent);
				$retVal = checkForSync($hostName.$printItem, $lineContent, 2);
				
				#item found in db but not in sync
				if($retVal == 0){
					#write the item to backup set file for backup
					print BACK_FILE $printItem.$lineFeed; 
					$filecount++;
				}
				if($retVal == 2){		#item not found in db 
					#if still we have results to read from db then write item to partial sync file
					if($readDB){
						$isPartialSyncFileOpen and print PARSYNCFILE "$lineContent\n";
						$syncfilecounter++;
					}else{	# write item to backup set
						print BACK_FILE $printItem.$lineFeed; 
						$filecount++;
					}
				}
			}

			# check if we have a new partial sync file with some items
			if($indexCount+1 == $endIndex){
				if($readDB and $syncfilecounter > 0){
					$endIndex++;
					$finalFile = $parSync{$item}{partialFileName}.".".$endIndex;
					createPartialSyncFile($finalFile);
					$parSync{$item}{indexcount} = $endIndex;
				}
				elsif($syncfilecounter > 0){
					$parSync{$item}{indexcount} = $endIndex;
					if($isPartialSyncFileOpen){
						close PARSYNCFILE;
						$isPartialSyncFileOpen = 0;
					}
				}
			}	
		}
	}
	if($isPartialSyncFileOpen){
		close PARSYNCFILE;
	}
}

#*********************************************************************************************************
# Subroutine Name         : readPartialSyncFile
# Objective               : This subroutine reads the PartialSyncFile and returns it in an array
# Added By                : Pooja Havaldar
# Modified by			  : 	
#*********************************************************************************************************/
sub readPartialSyncFile
{
	my @syncContent = undef;
	$syncFile = $_[0];
	if(-s $syncFile <= 0){
		unlink $syncFile;
		return @syncContent;
	}
	
	if(!open PARSYNCREAD, "<", $syncFile){
		traceLog("Cannot open $syncFile for reading , Reason:$!", __FILE__, __LINE__);
		return @syncContent;
	}
	
	@syncContent = <PARSYNCREAD>;
	close PARSYNCREAD;
	unlink $syncFile;
	return @syncContent;
}			

#********************************************************************************************************************
# Subroutine Name         : createPartialSyncFile
# Objective               : This subroutine closes already open PartialSyncFile and opens new file for re-writing
# Added By                : Pooja Havaldar
# Modified by			  : 	
#*********************************************************************************************************************/
sub createPartialSyncFile
{	
	$finalFile = $_[0];
	if($isPartialSyncFileOpen){
		close PARSYNCFILE;
		$isPartialSyncFileOpen = 0;
	}
	
	if(!open PARSYNCFILE, ">", $finalFile){
		traceLog("Cannot open $finalFile for re-writing , Reason:$!", __FILE__, __LINE__);
	}
	else{
		$isPartialSyncFileOpen = 1;
	}
	$syncfilecounter = 0;
}

#************************************************************************************************************************************
# Subroutine Name         : excludeCheck
# Objective               : This function checks whether the argument passed is present in any exclude list - full/partial exclude
# Added By                : Pooja Havaldar
#**************************************************************************************************************************************/
sub excludeCheck()
{
        my $element = $_[0];
        my $parElement = $_[1];

        if(!open(OUTFILE, ">> $outputFilePath")){
                traceLog("Could not open file $outputFilePath, Reason:$outputFilePath $lineFeed", __FILE__, __LINE__);
        }

        if(exists $backupExcludeHash{$element}){
                print OUTFILE "[".(localtime)."] [EXCLUDED] [$parElement]. Reason: Full path excluded item.$lineFeed";
                close OUTFILE;
                return 1;
        }
        else{
                for(my $i = 0;$i <= $#excludeArray; $i++){
                        $excludeArray_quotemeta = quotemeta($excludeArray[$i]);
                        if($element =~ m/^$excludeArray_quotemeta/){
                                print OUTFILE "[".(localtime)."] [EXCLUDED] [$parElement]. Reason: Full path excluded item.$lineFeed";
                                close OUTFILE;
                                return 1;
                        }
                }
        }

        if($parStr ne ""){
                if($parElement =~ m/$parStr/) {
                        print OUTFILE "[".(localtime)."] [EXCLUDED] [$parElement]. Reason: Partial path excluded item.$lineFeed";
                        close OUTFILE;
                        return 1;
                }
        }

        if(tell(OUTFILE) != -1){
                close OUTFILE;
        }

        return 0;
}


true;
